/* Copyright (c) 2016 by Adaptive Computing Enterprises, Inc. All Rights Reserved. */

;(function($, Handlebars) {

  Handlebars.registerHelper('ifCenter', function(position, options) {
    if (position === 'center') {
      return options.fn(this);
    }
    return options.inverse(this);
  });

  Handlebars.registerHelper('select', function(value, options) {
    var $el = $('<select />').html(options.fn(this));
    $el.find('[value=' + value + ']').attr({'selected': 'selected'});
    return $el.html();
  });

  Handlebars.registerHelper('selectMultiple', function(values, options) {
    var $el = $('<select />').html(options.fn(this));
    $el.find('option').filter(function() {
      return $.inArray($(this).val(), values) != -1;
    }).attr({'selected': 'selected'});
    return $el.html();
  });

  Handlebars.registerHelper('ifIn', function(elem, list, options) {
    if (list.indexOf(elem) > -1) {
      return options.fn(this);
    }
    return options.inverse(this);
  });

  Handlebars.registerHelper('ifSelected', function(selectedValue, currentValue, options) {
    if (selectedValue == currentValue) {
      return options.fn(this);
    }
    return options.inverse(this);
  });
})(jQuery, Handlebars);
