// Copyright (c) 2016 by Adaptive Computing Enterprises, Inc. All Rights Reserved.

var isDirtyPlaceholder = false;
var intervalId;
filterParam = {
    'jobState': null,
    'priorityFrom': 0,
    'priorityTo': 0,
    'rankFrom': 0,
    'rankTo': 0,
    'dateTimeRange': 'null',
    'startDate': null,
    'endDate': null,
    'wallclockStartDay': 0,
    'wallclockStartHr': 0,
    'wallclockStartMin': 0,
    'wallclockStartSec': 0,
    'wallclockEndDay': 0,
    'wallclockEndHr': 0,
    'wallclockEndMin': 0,
    'wallclockEndSec': 0
};
var searchParam = {
        jobId: null,
        userName: null,
        resourceName: 'null',
        ResourceID: 'null',
        Class: 'null',
        Features: 'null',
        submitterID: 'null'
    };
var sortingState = {
        'job_name': -1,
        'user_name': -1,
        'job_custom_name': -1,
        'priority': -1,
        'jobstatus': -1,
        'queue_status': -1,
        'wallclock_seconds': -1,
        'job_start_datetime': -1,
        'job_submit_datetime': -1,
        'processor_count': -1,
        'node_count': -1
    };
function setupSortClass(persistedSortObj) {
    "use strict";
    if (persistedSortObj == undefined || persistedSortObj == null || persistedSortObj.colname == undefined || persistedSortObj.sortState == null) {
        return;
    }
    var sortedField = $("#" + persistedSortObj.colname);
    if (sortedField != undefined && sortedField != null) {
        var ascClass, descClass;
        ascClass = "sorted_asc";
        descClass = "sorted_desc";
        sortedField.parent().find("th.span").remove();
        if (persistedSortObj.sortState == -1) {
            sortedField.append('<span class="sorted_desc"></span>');
        } else {
            sortedField.append('<span class="sorted_asc"></span>');
        }
    }
}
function disablePaginationContent() {
    "use strict";
    var pageNumber = $('#pageNumber').val();
    $('#goToLast').attr('disabled', false);
    $('#next').attr('disabled', false);
    $('#goToFirst').attr('disabled', false);
    $('#prev').attr('disabled', false);
    if (pageNumber === $('#totalPages').text()) {
        $('#goToLast').attr('disabled', true);
        $('#next').attr('disabled', true);
    }
    if (pageNumber === '1') {
        $('#goToFirst').attr('disabled', true);
        $('#prev').attr('disabled', true);
    }
    if ($('#totalPages').text().trim() === '1') {
        $('#goToFirst').attr('disabled', true);
        $('#prev').attr('disabled', true);
        $('#goToLast').attr('disabled', true);
        $('#next').attr('disabled', true);
    }
}
function checkObjection(caller, event) {
    "use strict";
    var keycode;
    keycode = event.keyCode || event.charCode;
    // Modified for IRIS-859
    if (event.keyCode === 8 || event.keyCode === 46 || event.keyCode === 9 || event.keyCode === 37 || event.keyCode === 39 || event.keyCode === 35 || event.keyCode === 36) {
        //NA
    } else if (!(keycode >= 48 && keycode <= 57)) {
        event.preventDefault();
    }
}
function disablecopypaste() {
    "use strict";
    $('input.number-input').bind("cut copy paste", function (e) {
        e.preventDefault();
    });
}
function getParameterByName(name) {
    "use strict";
    name = name.replace(/[\[]/, '\\[').replace(/[\]]/, '\\]');
    var regex = new RegExp('[\\?&]' + name + '=([^&#]*)'), results = regex.exec(location.search);
    return results == null ? '' : decodeURIComponent(results[1].replace(/\+/g, ' '));
}
function goto(url) {
    "use strict";
    window.location.href = '/' + url + '/';
}
function clearValue(obj, e) {
    "use strict";
    if (!e) {
        // doesn't work in FF
        if (!window.event) {
          return;
        }
        var event, code;
        event = window.event;
        code = event.which || event.keyCode;
        if (code == 13) {
            obj.value = '';
        }
    }
}
function mousedownfunc(divid, fname, id_name, limit, elementMessage) {
    "use strict";
    if (limit) {
        intervalId = setInterval(fname, 80, divid, id_name, limit, elementMessage);
    } else {
        intervalId = setInterval(fname, 80, divid, id_name);
    }
}
function mouseupfunc() {
    "use strict";
    clearInterval(intervalId);
}

function increment(id) {
    "use strict";
    var value = parseInt($('#' + id).val(), 10);
    if (isNaN(value)) {
        $('#' + id).val(0);
    } else {
        $('#' + id).val(value + 1);
    }
}

function decrement(id, id_name) {
    "use strict";
    var value = parseInt($('#' + id).val(), 10);
    if (value > 0) {
        $('#' + id).val(value - 1);
    } else if (id == id_name && value == 0){
        $('#' + id).val("0");
    } else if (value == 0) {
        $('#' + id).val("∞");
    }
}
function statusCodeInitialise() {
    "use strict";
    filterParam.jobState = $('#jobState').val();
}
function createDirtyUnloadListener(fieldObjects, message) {
    "use strict";
    $('body').on('change', fieldObjects, function () {
        isDirtyPlaceholder = true;
    });
    $(window).on('beforeunload', function () {
        if (isDirtyPlaceholder) {
         if (message == undefined) {
                message = '';
            }
            $(".form-jobDetail").submit(function () {
                $(window).unbind("beforeunload");
            });
            $(".form-nodeDetail").submit(function () {
                $(window).unbind("beforeunload");
            });
            return message;
        }
    });
}
function initCsrfToken(token) {
    "use strict";
    $(document).on('submit', 'form', function (e) {
        $(this).append('<input type="hidden" name="csrfmiddlewaretoken" value="' + token + '"/>');
    });
    $(document).ajaxSend(function (event, jqxhr, settings) {
        if (!/^(GET|HEAD|OPTIONS|TRACE)$/.test(settings.type)) {
            jqxhr.setRequestHeader('X-CSRFToken', token);
        }
    });
    checkAjaxError();
}

function checkAjaxError() {
    "use strict";

    $(document).ajaxError(function (event, jqxhr, settings, thrownError) {
        if (jqxhr.status == 401) {
            window.location = '/logout?expired=1';
        }
    });
}

var dateFormat = (function () {
    "use strict";
    var token = /d{1,4}|m{1,4}|yy(?:yy)?|([HhMsTt])\1?|[LloSZ]|"[^"]*"|'[^']*'/g, timezone = /\b(?:[PMCEA][SDP]T|(?:Pacific|Mountain|Central|Eastern|Atlantic) (?:Standard|Daylight|Prevailing) Time|(?:GMT|UTC)(?:[-+]\d{4})?)\b/g, timezoneClip = /[^-+\dA-Z]/g, pad = function (val, len) {
        val = String(val);
        len = len || 2;
        while (val.length < len) {
            val = '0' + val;
            return val;
        }
    };
    return function (date, mask, utc) {
        var dF = dateFormat;
        if (arguments.length == 1 && Object.prototype.toString.call(date) == '[object String]' && !/\d/.test(date)) {
            mask = date;
            date = undefined;
        }
        date = date ? new Date(date) : new Date();
        if (isNaN(date)) {
            throw new SyntaxError('invalid date');
        }
        mask = String(dF.masks[mask] || mask || dF.masks['default']);
        if (mask.slice(0, 4) == 'UTC:') {
            mask = mask.slice(4);
            utc = true;
        }
        var _ = utc ? 'getUTC' : 'get', d = date[_ + 'Date'](), D = date[_ + 'Day'](), m = date[_ + 'Month'](), y = date[_ + 'FullYear'](), H = date[_ + 'Hours'](), M = date[_ + 'Minutes'](), s = date[_ + 'Seconds'](), L = date[_ + 'Milliseconds'](), o = utc ? 0 : date.getTimezoneOffset(), flags = {
            d: d,
            dd: pad(d),
            ddd: dF.i18n.dayNames[D],
            dddd: dF.i18n.dayNames[D + 7],
            m: m + 1,
            mm: pad(m + 1),
            mmm: dF.i18n.monthNames[m],
            mmmm: dF.i18n.monthNames[m + 12],
            yy: String(y).slice(2),
            yyyy: y,
            h: H % 12 || 12,
            hh: pad(H % 12 || 12),
            H: H,
            HH: pad(H),
            M: M,
            MM: pad(M),
            ss: pad(s),
            l: pad(L, 3),
            L: pad(L > 99 ? Math.round(L / 10) : L),
            t: H < 12 ? 'a' : 'p',
            tt: H < 12 ? 'am' : 'pm',
            T: H < 12 ? 'A' : 'P',
            TT: H < 12 ? 'AM' : 'PM',
            Z: utc ? 'UTC' : (String(date).match(timezone) || ['']).pop().replace(timezoneClip, ''),
            o: (o > 0 ? '-' : '+') + pad(Math.floor(Math.abs(o) / 60) * 100 + Math.abs(o) % 60, 4),
            S: [
                'th',
                'st',
                'nd',
                'rd'
            ][d % 10 > 3 ? 0 : (d % 100 - d % 10 !== 10) * d % 10]
        };
        return mask.replace(token, function ($0) {
            return $0 in flags ? flags[$0] : $0.slice(1, $0.length - 1);
        });
    };
}());
dateFormat.masks = {
    'default': 'ddd mmm dd yyyy HH:MM:ss',
    shortDate: 'm/d/yy',
    mediumDate: 'mmm d, yyyy',
    longDate: 'mmmm d, yyyy',
    fullDate: 'dddd, mmmm d, yyyy',
    shortTime: 'h:MM TT',
    mediumTime: 'h:MM:ss TT',
    longTime: 'h:MM:ss TT Z',
    isoDate: 'yyyy-mm-dd',
    isoTime: 'HH:MM:ss',
    isoDateTime: 'yyyy-mm-dd\'T\'HH:MM:ss',
    isoUtcDateTime: 'UTC:yyyy-mm-dd\'T\'HH:MM:ss\'Z\''
};
dateFormat.i18n = {
    dayNames: [
        'Sun',
        'Mon',
        'Tue',
        'Wed',
        'Thu',
        'Fri',
        'Sat',
        'Sunday',
        'Monday',
        'Tuesday',
        'Wednesday',
        'Thursday',
        'Friday',
        'Saturday'
    ],
    monthNames: [
        'Jan',
        'Feb',
        'Mar',
        'Apr',
        'May',
        'Jun',
        'Jul',
        'Aug',
        'Sep',
        'Oct',
        'Nov',
        'Dec',
        'January',
        'February',
        'March',
        'April',
        'May',
        'June',
        'July',
        'August',
        'September',
        'October',
        'November',
        'December'
    ]
};

Date.prototype.format = function (mask, utc) {
    "use strict";
    return dateFormat(this, mask, utc);
};
// XXX: this function copied from loader.js
// it must be deleted after refactoring resource job timeline
function notifyAlreadyShown(message) {
  if ($('.alert-warning [data-notify="message"] p')
        .filter(function() {
          return $(this).text() === message;}).length === 0 ) {
    return false;
  } else {
    return true;
  }
}
/* error function */
function griderror(jqXHR, exception) {
    "use strict";
    $('#timeRangeAlert').hide();
    if (jqXHR.status === 0) {
        $('#dataGrid').html('Not connected.\n Verify network connection.');
    } else if (jqXHR.statusText === 'TooMuchDataException') {
        $('#dataGrid').html(jqXHR.responseText);
    } else if (jqXHR.status == 404) {
        $('#dataGrid').html('404 Requested page not found.');
    } else if (jqXHR.status == 500) {
        if (jqXHR.statusText) {
            if (!notifyAlreadyShown(jqXHR.statusText)) {
              $.notify('<h1>Server said:</h1><p>' + jqXHR.statusText + '</p>', {
                  type: 'warning',
                  delay: 0
              });
            }
            $('#dataGrid').html('No data available in table');
        } else {
          $('#dataGrid').html('500 Internal Server Error.');
        }
    } else if (jqXHR.status == 401 || jqXHR.status == 403) {
        if (jqXHR.responseText) {
            if (!notifyAlreadyShown(jqXHR.responseText)) {
              $.notify('<h1>Server said:</h1><p>' + jqXHR.responseText + '</p>', {
                  type: 'warning',
                  delay: 0
              });
            }
            $('#dataGrid').html('No data available in table');
        } else {
          $('#dataGrid').html(jqXHR.responseText);
        }
    } else if (exception === 'parsererror') {
        $('#dataGrid').html('Requested JSON parse failed.');
    } else if (exception === 'timeout') {
        $('#dataGrid').html('Time out error.');
    } else if (exception === 'abort') {
        $('#dataGrid').html('Ajax request aborted.');
    } else {
        $('#dataGrid').html('Uncaught Error.\n' + jqXHR.responseText);
    }
}
function gridconfigerror(jqXHR, exception) {
    "use strict";
    $('#error').addClass("alert alert-success");
    $('#error .preloader').hide();
    $('#error').show();
    $('#principallistcontainer .preloader, #rolelistcontainer .preloader').hide();
    if (jqXHR.status === 0) {
        $('#error').text('Not connected.\n Verify network connection.');
    } else if (jqXHR.status == 404) {
        $('#error').text('404 Requested page not found.');
    } else if (jqXHR.status == 500) {
        $('#error').text('500 Internal Server Error.');
    } else if (exception === 'parsererror') {
        $('#error').text('Requested JSON parse failed.');
    } else if (exception === 'timeout') {
        $('#error').text('Time out error.');
    } else if (exception === 'abort') {
        $('#error').text('Ajax request aborted.');
    } else {
        $('#error').text('Uncaught Error.\n' + jqXHR.responseText);
    }
}
