;(function($) {
  var nitroFirstLoaded = false;
  var nitroRepeater;
  var nitroTaskPermissionChecked;
  var nitroLogPermissionChecked;
  var previousSearchFilter;
  var jobCompleted = false;
  var opts;
  var pageNumber = 1;
  var totalCount;
  var sort = {
    'createdDate': -1
  }

  $(onPageLoad);

  function onPageLoad() {
    // remove back_count parameter from url (see IRIS-2568)
    window.history.pushState("", document.title, window.location.href.replace(/&?back_count=\d+/, ""));
    $.fn.addArrows('footer');
    disablecopypaste();
    handleTopMessages();
    createDataTable();
    createPaginator();

    $('#detailsRefresh').click(function(){
      location.reload();
    });

    $('.form-jobDetail').submit(validateForm);

    setQualityOfService();
    setScriptPathLink();

    // [More Information] -button click
    $('#scheduler-info-btn').click(function() {
      var jobId = $(this).data('jobid');
      $.viewpoint.modal.show('/scheduler-info-viewer', { jobId: jobId }).done(function() {
        initCPUStatisticChart($('#cpu-statistics-container')[0], jobId);
      });
    });

    // Check that paths (init, output and error) exist
    checkPathLink('#init-path-link');
    checkPathLink('#output-path-link');
    checkPathLink('#error-path-link');

    setTemplateName();

    bindMessagesBarEvents();

    expandCollapseRequirementDetails();

    // [cancel], [hold], [release] click handlers binding
    bindStatusButtonsEvents();

    // Start watching for Job Status
    startJobDetailsWatch();

    // [Go back] click handler binding
    goBackBinding();

    $('#jDDoneBtn').click(function() {
      prepareData();
      $('#actionField').val($(this).val());
      $('.form-jobDetail').submit();
      $(this).prop('disabled', true);
      $('#jDApplyBtn').prop('disabled', true);
    });
    $('#jDApplyBtn').click(function() {
      prepareData();
      $('#actionField').val($(this).val());
      $('.form-jobDetail').submit();
      $(this).prop('disabled', true);
      $('#jDDoneBtn').prop('disabled', true);
    });
    $('.duration-link').click(jobDetailsDuration);

    initRemoteVizWidget();

    $('#apply-priority').click(function(){
      $('#actionField').val('Apply');
      $('#priorityOnly').val(true);
      $('.form-jobDetail').submit();
      $(this).prop('disabled', true);
      $('#done-priority').prop('disabled', true);
    });

    $('#done-priority').click(function(){
      $('#actionField').val('Done');
      $('#priorityOnly').val(true);
      $('.form-jobDetail').submit();
      $(this).prop('disabled', true);
      $('#apply-priority').prop('disabled', true);
    });

    $(document).on('keyup', '#job-priority', function(e) {
      var v = this.value;
      if ((!/^-\d+$|^0$/g.test(v) && v != '-') || parseInt(v) > 0 || parseInt(v) < -1024)
        this.value = '';
    });

    $(document).on('keyup', '#system-priority', function(e) {
      var v = this.value;
      if (/\D+/g.test(v) || parseInt(v) < 0 || parseInt(v) > 1000)
        this.value = '';
    });

    if ($('.nitro-bar').length > 0) {
      nitroRepeater = new Viewpoint.Repeater({
        timeout: nitroInterval,
        fn: [loadNitro]
      });
      loadNitroInfo();
    }
    $('.nitro-title .show-all').trigger('click');
    // This line of code is strongly necessary. Makes progress-bar to grow from zero to pct value
    setNitroPercentage(0);
    setStatusTooltips();

    var searchParams = {
      'jobname': '',
      'user_name': '',
      'job_custom_name': '',
      'queue_status': '',
      'job_type': '',
      'job_start_datetime': '',
      'job_end_datetime': '',
      'wallclock_start': '',
      'wallclock_end': ''
    };

    var returnHref = $('.return-previous-link').attr('href');
    paramsArr = []
    for (var i in searchParams) {
      var param = $.url('?' + i);
      if (param) {
        paramsArr.push(i + '=' + param);
      }
    }
    if (!$.url('?', returnHref) && paramsArr.length)
      returnHref += '?'
    $('.return-previous-link').attr('href', returnHref += paramsArr.join('&'));

    var tabParam = getURLParameterByName('tab');
    if (tabParam == 'nodedetails' || tabParam == 'jobdetails') {
      $('.return-previous-link').hide();
    }

    initCPUStatistic();
    addTooltipsToAllocationNodeList();
    $('#viewPerPage').on('change', function() {
      pageNumber = 1;
      loadData();
    });
    $(document).on('click', '#job-messages-table th', function() {
      var colId = $(this).attr('id');
      if (colId == Object.keys(sort)[0]) {
        if ($(this).hasClass('sorting_asc')) {
          sort[colId] = 1
        } else {
          sort[colId] = -1
        }
      } else {
        sort = {}
        sort[colId] = 1;
      }
      loadData();
    });
  }

  function addTooltipsToAllocationNodeList() {
    var index = 1;
    var $node = $('.allocated-nodelist span').first();
    if ($node.text().replace(/(^\s+|\s+$)/g, "") == 'GLOBAL') {
      $node.addClass('global-node');
      $node.attr('title', $node.attr('title') + ' is a global resource pool');
      index++;
    }
    $node = $('.allocated-nodelist span:nth-child(' + index + ')');
    $node.addClass('coordinator-node');
    $node.attr('title', $node.attr('title') + ' is the job coordinator node');
    for (var i = index + 1; i <= $('.allocated-nodelist span').length; i++) {
      $node = $('.allocated-nodelist span:nth-child(' + i + ')');
      $node.attr('title', $node.attr('title') + ' is a job worker node');
    }
  }

  function getURLParameterByName(name) {
    name = name.replace(/[\[]/, "\\[").replace(/[\]]/, "\\]");
    var regex = new RegExp("[\\?&]" + name + "=([^&#]*)"),
        results = regex.exec(location.search);
    return results === null ? "" : decodeURIComponent(results[1].replace(/\+/g, " "));
  }

  function initRemoteVizWidget() {
    $('.remote-viz-container-loader').loader(new Viewpoint.API());
    $('.screenshot-container').loader(new Viewpoint.API());
    var remoteVizApi = $('.remote-viz-container-loader').data('api');
    var screenshotApi = $('.screenshot-container').data('api');
    var api = new Viewpoint.API();
    var remoteSessionFirstLoaded = false;
    var remoteSessionScreenshotFirstLoaded = false;
    var inUpdateProcess = false;
    var screenshotInUpdateProcess = false;
    var refreshTimer;
    var sessionId;
    var screenshotRefreshTimer;
    var remoteRefreshInterval = 5000;
    var screenshotRefreshInterval = 5000;
    var screenshotExists = false;
    var sessionExists = false;
    var img = new Image();
    img.onload = function() {
      if (img.naturalWidth == 1) {
        $('#remote-viz-screenshot').hide();
        $('#remote-viz-screenshot-disabled').show();
        clearInterval(screenshotRefreshTimer);
        screenshotRefreshTimer = changeInterval(screenshotRefreshInterval, 'screenshot');
        screenshotExists = false;
      } else {
        $('#remote-viz-screenshot').attr('src', img.src);
        $('#remote-viz-screenshot-disabled').hide();
        $('#remote-viz-screenshot').show();
        screenshotExists = true;
        clearInterval(screenshotRefreshTimer);
      }
    }

    function changeInterval(val, type) {
      switch(type) {
        case 'info':
          var timer = setInterval(function(){loadRemoteInfo(api)}, val)
          return timer;
         break;
        case 'screenshot':
         var timer = setInterval(function(){loadRemoteScreenshot(sessionId, api)}, val)
         return timer;
         break;
      }
    }

    $(document).click(function (e) {
      if (typeof $(e.target).data('original-title') == 'undefined' &&
       !$(e.target).parents().is('.popover.in')) {
       if ($('.popover').hasClass('in')) {
          $('[data-toggle="cpu-statistics-controls"]').popover('hide');
          $('[data-toggle="nitro-refresh-bar"]').popover('hide');
       }
      }
    });

    function loadRemoteScreenshot(sessionId, api) {
      if (!screenshotExists && !screenshotInUpdateProcess && $('.remote-viz-settings').is(':visible') && sessionExists) {
        screenshotInUpdateProcess = true;
        api.get('/api/fastx-sessions/' + sessionId + '/screenshot/')
            .done(function(data){
              if (data.result && data.result.src) {
                img.src = data.result.src;
              } else {
                $('#remote-viz-screenshot').hide();
                $('#remote-viz-screenshot-disabled').show();
                screenshotExists = false;
                clearInterval(screenshotRefreshTimer);
                screenshotRefreshTimer = changeInterval(screenshotRefreshInterval, 'screenshot');
              }
              screenshotInUpdateProcess = false;
            })
            .fail(function(){
              $('#remote-viz-screenshot').hide();
              $('#remote-viz-screenshot-disabled').show();
              screenshotInUpdateProcess = false;
            })
      }
    }

    function loadRemoteInfo(customAPI) {
      var settingsBlock = $('.remote-viz-settings');
      var ownerName = $('#jDUserVal').attr('title');
      var message = '';

      if ($.viewpoint.user.name == ownerName) {
        if (!$.viewpoint.user.permissions.remote_visualization_details_widget) {
          message = 'We apologize but you need the "Remote Visualization Details Widget" permission ';
        }
      } else {
        if (!$.viewpoint.user.permissions.remote_visualization_details_widgets_admin) {
          message = 'We apologize but you need the "Remote Visualization Details Widgets Admin" permission ';
        }
      }

      if (message) {
        message += 'to connect to Remote session. ' +
          'Please ask a Viewpoint administrator to grant you this permission if you require it.';
        var bar = $('<div>')
          .addClass('remote-permission-denied')
          .text(message);
        settingsBlock.append(bar);
        return;
      }

      if (!inUpdateProcess && settingsBlock.is(':visible') && !jobCompleted) {
        inUpdateProcess = true;

        var jobId = getJobId();
        var api = customAPI || remoteVizApi;

        api.get('/api/jobs/' + jobId + '/fastx-sessions/').done(
            function(data) {
              if (data.results.length == 1) {
                sessionExists = true;
                var session = data.results[0];
                var title = ''
                if (session.params && session.params.name) {
                  title = 'Session name: ' + session.params.name;
                }
                title += '\nSession command: ' + session.command + '\nSession geometry: ' + session.geometry;
                if ($('.vacated').length == 0) {
                  $('#remote-viz-url').removeClass('disabled');
                  if (session.clients > 0) {
                    $('#stop-session').data('command', session.commands);
                    $('#stop-session').removeClass('disabled');
                  } else {
                    $('#stop-session').addClass('disabled');
                  }
                }
                $('#remote-viz-screenshot-disabled').attr('title', title);
                $('#remote-viz-screenshot').attr('title', title);
                if (!remoteSessionScreenshotFirstLoaded) {
                  remoteSessionScreenshotFirstLoaded = true;
                  sessionId = session.id
                  screenshotRefreshTimer = changeInterval(screenshotRefreshInterval, 'screenshot');
                  loadRemoteScreenshot(sessionId, api)
                }
                if (!remoteSessionFirstLoaded) {
                  clearInterval(refreshTimer);
                  refreshTimer = changeInterval('15000', 'info')
                  remoteSessionFirstLoaded = true;
                }
              } else {
                sessionExists = false;
              }
              inUpdateProcess = false;
            }
        );
      }
    }

    $('.remote-viz-title .show-all').click(function(){
      if ($(this).hasClass('glyphicon-chevron-down')) {
        $('.remote-viz-settings').hide()
        $(this).removeClass('glyphicon-chevron-down');
        $(this).addClass('glyphicon-chevron-right');
      } else {
        $('.remote-viz-settings').show()
        screenshotExists = false;
        loadRemoteInfo()
        loadRemoteScreenshot(sessionId, remoteVizApi);
        $(this).removeClass('glyphicon-chevron-right');
        $(this).addClass('glyphicon-chevron-down');
      }
      $('.remote-refresh').toggleClass('glyphicon-refresh');
    })

    $('.remote-refresh').click(function(){
      screenshotExists = false;
      loadRemoteInfo();
      loadRemoteScreenshot(sessionId, remoteVizApi);
    })

    $('body').on('click', '.screenshot-container', function(){
      screenshotExists = false;
      loadRemoteScreenshot(sessionId, screenshotApi);
    })

    $('#stop-session').click(function(e) {
      if ($(this).hasClass('disabled')) {
        return;
      }
      inUpdateProcess = true;
      $.viewpoint.confirm('Disconnect users', 'Are you sure you want to disconnect all other users currently accessing the session?')
          .done(function(result) {
            if (result) {
              setTimeout(function() {
                remoteVizApi.post($('#stop-session').data('command'), {
                  command: 'disconnect'})
                    .done(function() {
                      $('#stop-session').addClass('disabled');
                      inUpdateProcess = false;
                    })
                    .fail(function() {
                      $.notify('Disconnect request sent to Remote Session', {
                        type: 'info'
                      });
                    });
              }, 1500);
            }
          });
    });

    $('#remote-viz-url').click(function() {
      if ($(this).hasClass('disabled')) {
        return;
      }
      inUpdateProcess = true;
      remoteVizApi.get('/api/jobs/' + getJobId() + '/fastx-sessions/').done(
          function(data) {
            function connect() {
              remoteVizApi.get('/api/jobs/' + getJobId() + '/fastx-sessions/?loadConnectionUrl=true').done(
                  function(data) {
                    if (data.results.length == 1) {
                      var session = data.results[0];
                      window.open(session.connectionUrl, '_blank');
                    }
                  }
              );
            }

            if (data.results.length == 1) {
              var session = data.results[0];
              var clients = session.clients;
              if (clients != 0) {
                $.viewpoint.confirm('Disconnect users',
                    'This session currently has active users connected to it. Do you want to disconnect all other users and take over the session?')
                    .done(function(result) {
                      if (result) {
                        remoteVizApi.post(session.commands, {command: 'disconnect'}).done(function() {
                          connect();
                        });
                      }
                    });
              } else {
                connect();
              }
            } else {
              $.notify('Session does not exist', {
                type: 'danger'
              });
            }
            inUpdateProcess = false;
          }
      );

    });
    $('#remote-viz-url').addClass('disabled');
    if ($('.remote-viz-container').length > 0) {
      loadRemoteInfo();
    }
    refreshTimer = changeInterval(remoteRefreshInterval, 'info');
  }

  var nitroInterval = 5000;
  var nitroAutoRefresh = true;

  function loadNitroInfo() {
    var jobId = getJobId();
    showNitroPermissionDeniedBar('No Nitro Statistics available at this time');

    var autoRefreshClicked = function() {
      var checkbox = $('.popover-content .nitro-autorefresh');
      if (!nitroFirstLoaded || checkbox.is(':checked')) {
        nitroAutoRefresh = true;
        nitroRepeater.start();
      } else {
        nitroAutoRefresh = false;
        nitroRepeater.stop();
      }
    };

    $('.nitro-title .show-all').on('click', function(e) {
      var link = $(e.target);
      if (link.hasClass('glyphicon-chevron-right')) {
        link.removeClass('glyphicon-chevron-right');
        link.addClass('glyphicon-chevron-down');
        $('.nitro-bar .glyphicon-cog').show();
        $('.nitro-bar .nitro-title').addClass('expanded');
        $('.nitro-bar .nitro-body').show(700, function() {
          if (!nitroFirstLoaded) {
            loadNitroBefore();
            // Switch on autorefresh
            autoRefreshClicked();
            nitroFirstLoaded = true;
          }
        });
      } else {
        $('.nitro-bar .glyphicon-cog').hide();
        link.removeClass('glyphicon-chevron-down');
        link.toggleClass('glyphicon-chevron-right');
        $('.nitro-bar .nitro-body').hide();
        $('.nitro-bar .nitro-title').removeClass('expanded');
      }
    });

    $('body').on('click', '.popover-content .update-info', function() {
      loadNitro();
      $("[data-toggle=nitro-refresh-bar]").popover('hide');
    });

    $('body').on('click', '.popover-content .nitro-autorefresh', autoRefreshClicked);

    $('body').on('change', '.popover-content .nitro-refresh-interval', function(){
      nitroInterval = $('.popover-content .nitro-refresh-interval').val();
      var interval = nitroInterval;
      if ($('.popover-content .nitro-autorefresh').is(':checked')) {
        nitroRepeater.setTimeout(interval);
      }
    });

    $('.nitro-config').on('shown.bs.popover', function () {
      $('.popover-content .nitro-refresh-interval').val(nitroInterval);
      $('.popover-content .nitro-autorefresh').prop('checked', nitroAutoRefresh);
    });

  }

  function setNitroPercentage(pct) {
    $('.nitro-bar .progress .progress-bar')
      .width(pct + '%')
      .text(pct + '%');
  }

  function loadNitroBefore() {
    var api = new Viewpoint.API();
    api.get('/api/nitro-jobs/' + getJobId() + '/')
      .done(function() {
        loadNitro(null, true);
        nitroRepeater.start();
      })
      .fail(function(jqXHR, textStatus, errorThrown) {
        nitroRepeater.start();
        var detail;
        if (jqXHR.responseJSON && jqXHR.responseJSON.detail) {
          detail = jqXHR.responseJSON.detail;
        }
        var message = detail || textStatus || errorThrown;
        if (jqXHR.status == 403) {
          showNitroPermissionDeniedBar(message);
        } else {
          showNitroPermissionDeniedBar('No Nitro Statistics available at this time');
        }
        api.get('/api/jobs/' + getJobId() + '/').done(function(data) {
          if (data.queue_status && 'ACTIVE' == data.queue_status) {
            return;
          }
        });

        nitroCanNotGetValues();
      });
  }

  function showNitroPermissionDeniedBar(message) {
    var bar = $('<div>')
      .addClass('nitro-permission-denied')
      .text(message);
    $('.nitro-column').hide();
    $('.nitro-body').css('height', '100px').append(bar);
  }

  function hideNitroPermissionDeniedBar() {
    $('.nitro-column').show();
    $('.nitro-body').css('height', '100%').find('.nitro-permission-denied').hide();
  }

  function nitroCanNotGetValues() {
    $('.worker-summary .workers .workers-value').text('N/A');
    $('.worker-summary .workers .caret').hide();
    $('.worker-summary .threads').text('N/A');
    $('.worker-summary .avgAsgmtDuration').text('N/A');
    $('.worker-summary .avgTaskDuration').text('N/A');
    $('.worker-summary .avgNodeLoad').text('N/A');
    $('.task-summary .queued').text('N/A');
    $('.task-summary .pending').text('N/A');
    $('.task-summary .running').text('N/A');
    $('.task-summary .completed .completed-value').text('N/A');
    $('.task-summary .completed .dropdown-menu').text('N/A');
    $('.task-summary .tasksPerSecond').text('N/A');
    $('.task-summary .total').text('N/A');
  }

  function loadNitro(cb, showLoader) {
    var api = showLoader ? $('.nitro-body').data('api') : new Viewpoint.API();

    var toStr = function (s) {
      if (s || _.isNumber(s)) {
        return s;
      }
      return 'N/A';
    };
      api.get('/api/nitro-jobs/' + getJobId() + '/')
        .done(function(data) {
          setNitroPercentage(data.percentComplete);
          $('#nitroJobState').text(toStr(data.state));
          if (data.has_resource_permission) {
            var $host = $('<a></a>')
              .addClass('nodeLink')
              .text(data.coordHost)
              .attr('href', '/nodedetails/?node_name=' + data.coordHost + '&tab=resources');
            if (0 == $('#mainNav').find('#resources').length) {
              $host.attr('href', '#');
            }
            $('#nitroCoordHost').html($host);
          } else {
            $('#nitroCoordHost').text(toStr(data.coordHost));
          }

          // Check Permission once instead of checking it every time loadNitro is called
          if (!nitroTaskPermissionChecked) {
            if (data.taskFile) {
              $('#nitroTaskFile span').text(data.taskFile);
              var path = '/api/file/' + encodeURI(data.taskFile);
              checkFilePermissions(path, function() {
                $('#nitro-task-file').attr('href', '/file-manager/?path=' + data.taskFile);
                $('#nitro-task-file').show();
              }, $('#nitro-task-file'));
            } else {
              $('#nitroTaskFile span').text('N/A');
            }
            nitroTaskPermissionChecked = true;
          }

          // Check Permission once instead of checking it every time loadNitro is called
          if (!nitroLogPermissionChecked) {
            if (data.taskLog) {
              $('#nitroTaskLog span').text(data.taskLog);
              var path = '/api/file/' + encodeURI(data.taskLog);
              checkFilePermissions(path, function() {
                $('#nitro-task-log').attr('href', '/file-manager/?path=' + data.taskLog);
                $('#nitro-task-log').show();
              }, $('#nitro-task-log'));
            } else {
              $('#nitroTaskLog span').text('N/A');
            }

            if (data.jobLog) {
              $('#nitroJobLog span').text(data.jobLog);
              var path = '/api/file/' + encodeURI(data.jobLog);
              checkFilePermissions(path, function() {
                $('#nitro-job-log').attr('href', '/file-manager/?path=' + data.jobLog);
                $('#nitro-job-log').show();
              }, $('#nitro-job-log'));
            } else {
              $('#nitroJobLog span').text('N/A');
            }
            nitroLogPermissionChecked = true;
          }

          $('.worker-summary .workers .workers-value').text(numberWithCommas(toStr(data.workerCount)));
          $('.worker-summary .workers .caret').show();
          $('.worker-summary .workers .dropdown-menu').html(getWorkersSummary(data));
          $('.worker-summary .threads').text(numberWithCommas(toStr(data.workerThreads)));
          $('.worker-summary .avgAsgmtDuration').text(numberWithCommas(toStr(cutFraction(data.averageAssignmentDuration, 3))));
          $('.worker-summary .avgTaskDuration').text(numberWithCommas(toStr(cutFraction(data.averageTaskDuration, 3))));
          //$('.worker-summary .avgNodeLoad').html(toStr(cutFraction(data.averageNodeLoad, 3)));

          $('.task-summary .pending').text(numberWithCommas(toStr(data.tasksPending)));
          $('.task-summary .running').text(numberWithCommas(toStr(data.tasksInProgress)));
          $('.task-summary .completed .completed-value').text(numberWithCommas(toStr(data.tasksCompleted)));
          $('.task-summary .completed .dropdown-menu').html(getCompletedSummary(data));
          $('.task-summary .tasksPerSecond').text(numberWithCommas(toStr(cutFraction(data.tasksPerSecond))));
          $('.task-summary .total').text(numberWithCommas(toStr(data.tasksTotal)));

          // Check if Job is already completed
          if ($.data(document.body, 'IS_COMPLETED')) {
            nitroRepeater.stop();
          } else {
            if ($.isFunction(cb)) {
              cb();
            }
          }
          hideNitroPermissionDeniedBar();
      }).fail(function() {
          nitroCanNotGetValues();
          showNitroPermissionDeniedBar('No Nitro Statistics available at this time');
          if ($.isFunction(cb))
            cb();
      });

    function checkFilePermissions(path, fn, button) {
      api.head(path).done(fn);
    }

    function cutFraction(value, numsAfterPoint) {
      if (isNaN(value)) {
        return value;
      }
      if (!numsAfterPoint) {
        numsAfterPoint = 2;
      }

      return '' + value.toFixed(numsAfterPoint);
    }

    function numberWithCommas(x) {
      return x.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ",");
    }

    function getCompletedSummary(data) {
      return '<li><div class="tasksCompletedLabel">Success:</div>' + numberWithCommas(toStr(data.tasksSuccess)) + '</li>' +
        '<li><div class="tasksCompletedLabel">Failure:</div>' + numberWithCommas(toStr(data.tasksFailed)) + '</li>' +
        '<li><div class="tasksCompletedLabel">Timeout:</div>' + numberWithCommas(toStr(data.tasksTimeout)) + '</li>' +
        '<li><div class="tasksCompletedLabel">Invalid:</div>' + numberWithCommas(toStr(data.tasksInvalid)) + '</li>' +
        '<li><div class="tasksCompletedLabel">Insufficient:</div>' + numberWithCommas(toStr(data.tasksInsufRes)) + '</li>';
    }

    function getWorkersSummary(data) {
      return '<li><div class="workerLabel">Running:</div>' + toStr(data.workersRunning) + '</li>' +
        '<li><div class="workerLabel">Unresponsive:</div>' + toStr(data.workersUnresponsive) + '</li>' +
        '<li><div class="workerLabel">Closed:</div>' + toStr(data.workersClosed) + '</li>' +
        '<li><div class="workerLabel">Unconnected:</div>' + toStr(data.workersUnconnected) + '</li>';
    }
  }

  function isAllowChanges() {
    var flag = $('form.form-jobDetail').attr('data-allow-changes');
    return flag.toLowerCase() == 'true';
  }

  function getJobId() {
    return $('form.form-jobDetail').attr('data-job-id');
  }

  function getQosName() {
    return $('form.form-jobDetail').attr('data-qos-name');
  }

  function getUserName() {
    return $('form.form-jobDetail').attr('data-user-name');
  }

  function setScriptPathLink() {
    var $scriptPathLink = $('#script-path-link');
    if ($scriptPathLink.length == 1) {
      var api = new Viewpoint.API();
      var path = $scriptPathLink.data('path');
      var fileEndpoint = '/api/file/';

      api.head(fileEndpoint + encodeURI(path)).done(function() {
        $scriptPathLink.click(function() {
          $.viewpoint.modal.show('/file-viewer', {
            title: 'Job Script Preview',
            path: path
          });
        });

        $scriptPathLink.addClass('available-script-link');
      });
    }
  }

  function setQualityOfService() {
    var $qosField = $('#qos');
    var qosApi = new Viewpoint.API();
    var defValue = getQosName();
    var jobOwner = getUserName();

    if ($qosField.length > 0) {

      $qosField.select2({
        width: '150px',
        placeholder: 'Loading',
        data: [],
        disabled: true
      });

      qosApi.get('/api/credentials/' + jobOwner + '/')
        .done(function(data) {
          var qosList = data.qos_access_list;
          var fieldDisabled = !isAllowChanges();
          $qosField.select2({
            width: '150px',
            placeholder: 'None',
            data: qosList,
            disabled: fieldDisabled
          });

          if (defValue) {
            $('#qos').select2('val', defValue);
          }
        });
    }
  }

  function checkPathLink(selector) {
    var api = new Viewpoint.API();
    var fsEndpoint = '/api/fsobject';
    var $pathLink = $(selector);
    var needCheckPath = $pathLink.data('need-check-path');

    if ($pathLink.length == 1) {
      var path = $pathLink.data('path');
      var hostname = path.match(/^(.+:).*/);
      if (hostname) {
        path = path.replace(hostname[1], '');
        $(selector).prev('span').text(path);
        $pathLink.attr('href', '/file-manager/?path=' + path);
      }
      if (needCheckPath || needCheckPath === undefined) {
        api.get(encodeURI(fsEndpoint + path))
          .done(function(data) {
            var url = '/api/directory/';
            if (data.object_type == 'FILE') {
              url = '/api/file/';
              $('.output-path-label').text('Output File');
              $('.error-path-label').text('Error File');
            }
            $pathLink.data('need-check-path', false);
            api.head(encodeURI(url + path)).done(function() {
              $pathLink.show();
              if (data.object_type == 'FILE') {
                $pathLink.click(function(e) {
                  e.preventDefault();
                  $.viewpoint.modal.show('/file-viewer/', {
                    title: 'File Viewer',
                    path: path
                  }).done(function(payload) {});
                });
              }
            });
          })
          .fail(function(jqXHR, textStatus, errorThrown) {
            if (jqXHR.status == 404) {
              $pathLink.data('need-check-path', true);
            }
          });
      }
    }
  }

  function setTemplateName() {
    var api = new Viewpoint.API();
    var jobId = getJobId();
    api.get('/api/jobs/' + jobId + '/')
      .done(function(data) {
        if (data.template) {
          api.get(data.template)
            .done(function(data) {
              var text = data.current ? data.name + ' (v.' + data.version + ' CURRENT)' :
                            data.name + ' (v.' + data.version + ')';
              $('.template-name')
                .empty()
                .append($('<a>')
                  .attr('href',
                    '/create_job?t=' + data.url)
                  .text(text));
            });
        } else if (data.templateName) {
          $('.template-name').text(data.templateName);
        } else $('.template-name').text('N/A');
      });
  }

  function bindMessagesBarEvents() {
    $('.messages-title .show-all').on('click', function(e) {
      var link = $(e.target);
      if (link.hasClass('glyphicon-chevron-right')) {
        link.removeClass('glyphicon-chevron-right');
        link.addClass('glyphicon-chevron-down');
        $('.messages-bar .messages-title').addClass('expanded');
        $('.messages-bar .messages-body').show();
        loadData();
        $('.messages-bar .update-messages').show();
      } else {
        link.removeClass('glyphicon-chevron-down');
        link.toggleClass('glyphicon-chevron-right');
        $('.messages-bar .messages-body').hide();
        $('.messages-bar .messages-title').removeClass('expanded');
        $('.messages-bar .update-messages').hide();
        $('.messages-bar .nomessages').remove();
      }
    });
    $('.messages-bar .update-messages').on('click', function() {
      loadData();
    });
  }

  function createPaginator() {
    $('.datagrid-container .paginator-container').bootpag({
      total: 1, // total pages
      maxVisible: 7,
      leaps: true,
      firstLastUse: true,
      next: 'next',
      prev: 'prev'
    }).on('page', function(event, num) {
      pageNumber = num;
      loadData();
    });
  }

  function updatePaginator(totalRows, rowsPerPage, currentRow) {
    totalRows = parseInt(totalRows);
    rowsPerPage = parseInt(rowsPerPage);
    var total = Math.ceil(totalRows / rowsPerPage);
    total = total === 0 ? 1 : total;
    $('.datagrid-container .paginator-container').bootpag({
        total: total, // total pages
        page: currentRow,
        maxVisible: 7,
        leaps: true,
        firstLastUse: true,
        next: 'next',
        prev: 'prev'
    });
  }

  function createDataTable() {
    opts = {
      data: [],
      dom: 't',
      bInfo: false,
      bPaginate: false,
      bDestroy: true,
      order: [[ 0, 'desc' ]],
      'columnDefs': [{
        'width': '20%',
        'targets': 0,
        'sType': 'sortOff',
        'data': 'createdDate',
        'defaultContent': 'N/A',
        'className': 'date-cell',
        'render': function(data, type, full) {
          return createDateColumn(data, type, full);
        }
      }, {
        'width': '80%',
        'targets': 1,
        'sType': 'sortOff',
        'data': 'message',
        'defaultContent': 'N/A',
        'className': 'message-cell',
        'render': function(data, type, full) {
          return '<span title="' + data + '">' + data + '</span>';
        }
      }]
    };
    var $table = $('#job-messages-table');
    table = $table.DataTable(opts);
    $.fn.dataTableExt.oSort["sortOff-desc"] = function (x, y) {
      return 0;
    };
    $.fn.dataTableExt.oSort["sortOff-asc"] = function (x, y) {
      return 0;
    };
  }

  function createDateColumn (data, type, full) {
    if (data) {
      var localTime = moment.utc(data.replace(' UTC', '')).toDate();
      return moment(localTime).format('YYYY-MM-DD HH:mm:ss');
    } else return 'N/A';
  }

  function loadData() {
    var jobId = getJobId();
    var api = $('.messages-bar.api').data('api');
    var pageSize = $('#viewPerPage').val();
    api.get('/api/jobs/' + jobId + '/messages/?page=' + pageNumber + '&page_size=' + pageSize + '&sort=' + JSON.stringify(sort))
      .done(function(data) {
        totalCount = data.count;
        table.clear();
        table.rows.add(data.results);
        table.draw();
        updatePaginator(totalCount, pageSize, pageNumber);
        if ($(window).scrollTop() > $('.messages-bar').offset().top) {
          $('html, body').animate({
            scrollTop: $('.messages-bar').offset().top
          }, 0);
        }
      });
  }

  function expandCollapseRequirementDetails() {
    $('#jobCollapse').click(function() {
      if (!$('.reqDetails').hasClass('collapsing')) {
        $('.reqDetails').collapse('toggle');
        if ($('#jobCollapse').hasClass('glyphicon-chevron-right')) {
          $('#jobCollapse').removeClass('glyphicon-chevron-right');
          $('#jobCollapse').addClass('glyphicon-chevron-down');
          $('.req-details-bar .req-details-title').addClass('expanded');
        } else {
          $('#jobCollapse').removeClass('glyphicon-chevron-down');
          $('#jobCollapse').toggleClass('glyphicon-chevron-right');
          $('.req-details-bar .req-details-title').removeClass('expanded');
        }
      }
    });
  }

  function setStatusTooltips() {
    var status = $('#jDStatusVal').text();
    var queueStatus = $('#jDQueueStatus').text();
    var statusTitle = window.StatusTooltips[status] || '';
    var queueStatusTitle = window.QueueStatusTooltips[queueStatus] || '';
    $('#jDStatusVal').attr('title', statusTitle);
    $('#jDQueueStatus').attr('title', queueStatusTitle);
  }

  function bindStatusButtonsEvents() {
    $('.cancel-job-btn').click(function(evt) {
      $(evt.target).prop('disabled', true);
      changeStatus('cancel', 'CANCEL was sent');
    });

    $('.hold-job-btn').click(function(evt) {
      $(evt.target).prop('disabled', true);
      changeStatus('hold', 'HOLD was sent');
    });

    $('.release-job-btn').click(function(evt) {
      $(evt.target).prop('disabled', true);
      changeStatus('unhold', 'RELEASE was sent');
    });

    function changeStatus(status, message) {
      changeTempState(status);
      var jobId = getJobId();
      $.ajax({
        url: '/modifyjob/',
        type: 'GET',
        data: {
          jobId: jobId,
          changeStatus: status
        }
      })
      .done(function(msg) {
        if (msg.indexOf('ERROR:') == 0) {
            $.notify(msg, {
              type: 'danger',
              onClose: function() {}
            });
        } else {
            $.notify(message, {
              type: 'info',
              onClose: function() {}
            });
        }
      });
    }
  }

  function goBackBinding() {

    $("#goback").click(function() {
      var goback = parseInt($("#back_count").val());
      if (window.history.length > goback)
        window.history.go(-goback);
      else
        window.location.href = "/workload/";
    });
  }

  function validateForm() {
    if (!chkData('qos_txtBox')) {
      return false;
    }
    if (!chkData('jobDetails_SysPriorityTxtbox')) {
      return false;
    }
    if (!chkData('job_priority')) {
      return false;
    }
  }

  function fetchPrepareData(id) {
    nodelist = "";
    $(id).find("a").each(function() {
      nodelist += "," + $(this).text();
    });
    nodelist=nodelist.replace(/^(,)*/,'');
    return nodelist;
  }

  function prepareData() {
    $("#nodeList").val(fetchPrepareData("#nodeListContainer"));
  }

  function jobDetailsDuration() {
    var fieldDisabled = !isAllowChanges();
    if (fieldDisabled) {
      return;
    }
    // OLD CODE (I can't see it without tears)
    var durationTxtBox, newArry;
    var divDuration = document.getElementById('durationContent');
    if (divDuration.style.display !== 'none') {
        divDuration.style.display = 'none';
    } else {
        divDuration.style.display = 'block';
        divDuration.style.top = '23px';
        divDuration.style.left = '14px';
        durationTxtBox = document.getElementById('durInput').value;
        newArry = [];
        newArry = durationTxtBox.split(':');
        document.getElementById('dInput').value = newArry[0];
        document.getElementById('hInput').value = newArry[1];
        document.getElementById('mInput').value = newArry[2];
        document.getElementById('sInput').value = newArry[3];
    }
    var platForm, userAgent;
    platForm = navigator.platform;
    userAgent = navigator.userAgent;
    if (platForm === 'Linux x86_64' && userAgent.toLowerCase().indexOf("firefox") >= 0) {
        $('.popover').css({"top": "188px", "left": "239px"});
    }
    if (platForm === 'MacIntel' && userAgent.toLowerCase().indexOf("firefox") >= 0) {
        $('.popover').css({"top": "177px", "left": "207px"});
    }
  }

  function changeTempState(status) {
    $('#jDStatusVal').removeClass();
    if (status == 'cancel') {
      $('#jDStatusVal').html('CANCELING');
      $('#jDStatusVal').attr('title', '');
      $('#featuresContainer .add').remove();
    }
    if (status == 'hold') {
      $('#jDStatusVal').html('HOLDING');
      $('#jDStatusVal').attr('title', '');
    }
    if (status == 'unhold') {
      $('#jDStatusVal').html('RELEASING');
      $('#jDStatusVal').attr('title', '');
    }
  }

  function startJobDetailsWatch() {
    var jobId = getJobId();
    var oldState = $('#jDQueueStatus').text();
    var oldHolds = null;
    var jw = new Viewpoint.JobWatcher({ job: jobId });
    // See the description of behaviors in IRIS-1553
    var editableStatuses = ['IDLE', 'BLOCKED', 'HOLD', 'DEFERRED', 'ELIGIBLE'];
    var notEditableStatuses = ['ACTIVE', 'RUNNING', 'SUSPENDED', 'STAGING', 'NOTQUEUED', 'STARTING', 'UNKNOWN',
        'VACATED', 'REMOVED', 'COMPLETED', 'FAILED'];
    var jobStateChangeEvent = $.Event('jobStateChange');

    function updatePage(stateObj) {
      var newState = stateObj.queue_status.toUpperCase();
      var newHolds = stateObj.holds;

      checkHoldReleaseBtn(newState, stateObj.holds);

      $('#jDStatusVal').text(stateObj.state.toUpperCase());

      if ($.inArray(newState, ['VACATED', 'REMOVED', 'COMPLETED']) != -1) {
        $.data(document.body, 'IS_COMPLETED', true);
      }
      if (stateObj.dedicate_all_processors && $.inArray(newState, ['STARTING', 'ACTIVE', 'COMPLETED', 'VACATED', 'CANCELED', 'REMOVED', 'RUNNING']) == -1) {
        $.each($('.processors-per-task'), function(){
          var text = $(this).text().trim();
          if (text.indexOf('~') == -1) {
            $(this).attr('title', 'This job has not been scheduled yet. ' +
            		'Requested core count is being estimated based on total amount of requested nodes.');
            $(this).text('~' + text);
          }
        });
      } else {
        updateRequirements(stateObj.requirements);
      }

      if (newState != oldState && newState == 'ACTIVE') {
        if (nitroRepeater && !nitroRepeater.isRunning() && nitroAutoRefresh) {
          nitroRepeater.start();
        }
      }
      checkRemoteSession(newState);
      // initialization of the user hold
      if (!oldHolds) {
        oldHolds = newHolds;
      }
      // check that the "user hold" value has changed
      if (oldHolds && !_.isEqual(oldHolds.sort(), newHolds.sort())) {
        oldHolds = newHolds;
        updateState(newState);
      }
      if (newState != oldState) {
        checkRemoteVizBtn(newState);
        if ($.inArray(oldState, editableStatuses) > -1 && $.inArray(newState, editableStatuses) > -1) {
          updateState(newState);
          $('#page-content').trigger(jobStateChangeEvent);
          return;
        }
        // TODO: refactor on else if () ...
        if ($.inArray(oldState, notEditableStatuses) > -1 && $.inArray(newState, notEditableStatuses) > -1) {
          hideElements();
          updateState(newState);
          $('#page-content').trigger(jobStateChangeEvent);
          return;
        }
        // if the job status changed from not editable to editable then need job_details_pre.mako so we reload page
        if ($.inArray(oldState, notEditableStatuses) > -1 && $.inArray(newState, editableStatuses) > -1) {
          updateState(newState);
          var msg = 'Job status has been changed to \"' + newState + '\". The page will be reloaded.';
          showNotify(msg, function() {
            location.reload();
          });
        }
        // if the job status changed from editable to not editable then we just hide elements
        if ($.inArray(oldState, editableStatuses) > -1 && $.inArray(newState, notEditableStatuses) > -1) {
          hideElements();
          updateState(newState);
          $('#page-content').trigger(jobStateChangeEvent);
        }
      }
      setStatusTooltips();
    }

    // Check a few of controls after page load
    if ($.inArray(oldState, notEditableStatuses) > -1) {
      hideElements();
    }

    // wait job state change event and check path again
    $('body').on('jobStateChange', '#page-content', function(e) {
      checkPathLink('#init-path-link');
      checkPathLink('#output-path-link');
      checkPathLink('#error-path-link');
      setStatusTooltips();
    });

    // start watching
    jw.watch(function(stateObj) {
      var status = stateObj.queue_status;
      updatePage(stateObj);
      if ($.inArray(status, ['VACATED', 'REMOVED', 'COMPLETED']) == -1) {
        jw.addTask(this.callback);
      }
    });

    function showNotify(msg, callback) {
      $.notify(msg, {
        type: 'info',
        onClose: callback()
      });
    }

    function checkRemoteSession(state) {
      if (state == "COMPLETED") {
        jobCompleted = true;
        $('.remote-viz-container').hide();
      }
    }

    // See IRIS-1146
    function checkHoldReleaseBtn(status, userHold) {
      if ($.inArray(status,["RUNNING","ACTIVE","SUSPENDED","BLOCKED","DEFERRED","STAGING","NOTQUEUED","IDLE","STARTING","UNKNOWN","HOLD"]) > -1) {
    	  $('.cancel-job-btn').show().prop("disabled", false);
      }
      if ($.inArray(status, ["BLOCKED","DEFERRED","NOTQUEUED","IDLE","UNKNOWN", "ELIGIBLE"]) > -1 &&
            $.inArray("user", userHold) == -1) {
        $('.release-job-btn').hide();
        $('.hold-job-btn').show().prop("disabled", false);
      }
      if ($.inArray("user", userHold) > -1) {
        $('.hold-job-btn').hide();
        $('.release-job-btn').show().prop("disabled", false);
      }
      if ($.inArray(status, ['RUNNING', 'ACTIVE']) > -1) {
        $('.release-job-btn').hide();
        $('.hold-job-btn').hide();
      }
      // hide all buttons for completed jobs
      if ($.inArray(status, ['VACATED', 'REMOVED', 'COMPLETED']) > -1) {
        $('.cancel-job-btn').hide();
        $('.hold-job-btn').hide();
        $('.release-job-btn').hide();
      }
    }

    function checkRemoteVizBtn(status) {
      if (status == 'VACATED') {
          $('#remote-viz-url').addClass('disabled');
          $('#stop-session').addClass('disabled');
      }
    }

    function hideElements() {
      var $duration = $('#durInput');
      $duration.hide();
      $('#infoPopUp').hide();
      $('#jDTime').text($duration.val());
      var $qos = $('#qos_txtBox');
      $qos.hide();
      $qos.parent().addClass('ffld').text($qos.val());
      $('.priority-bar').hide();
      $('#scheduler-info-btn').hide();
      $('#jDDoneBtn').hide();
      $('#jDApplyBtn').hide();
      $('#qos').prop('disabled', true);
    }

    function updateState(newState) {
      oldState = newState;
      $('#jDQueueStatus').text(newState);
      $('#jDQueueStatus').attr('class', newState.toLowerCase());
      var msg = 'Status has been changed to \"' + newState + '\".';
      showNotify(msg, function() {});
    }

    function updateRequirements(requirements) {
      function updateField($field, value) {
        $field.attr('title', value);
        $field.text(value);
      }

      function updatePrimaryLabel($field, values) {
        $field.empty();
        if (values && values.length) {
          $.each(values, function(i, feature) {
            $field
              .append(
                $('<span></span>')
                  .addClass('label label-primary ffld')
                  .text(feature)
                  .attr('title', feature))
              .append('&nbsp;');
          });
        } else {
          $field.text('N/A');
        }
      }

      function updateGres($field, values) {
        $field.empty();
        if (values && _.size(values)) {
          var $tbody = $('<tbody></tbody>');
          $.each(values, function(name, count) {
            $tbody
              .append(
                $('<tr></tr>')
                  .append($('<td></td>').text(name))
                  .append($('<td></td>').text(count)))
          });

          $field.append(
            $('<table></table>')
              .addClass('table-common')
              .append(
                $('<thead></thead>')
                  .append(
                    $('<tr></tr>')
                      .append($('<td></td>').text('Name'))
                      .append($('<td></td>').text('Count'))))
              .append($tbody)
          )
        } else {
          $field.text('N/A');
        }
      }

      var fieldSelectorMap = {
        'total_dedicated_processors': '.processors-per-task',
        'memory_byte': '.memory_requested',
        'swap_byte': '.swap_requested',
        'disk_byte': '.disk_requested',
        'nodes': '.nodes_requested',
        'allocated_node_count': '.allocated_node_count',
        'allocated_partition': '.allocated_partition',
        'operating_system': '.operating_system',
        'architecture': '.architecture'
      };

      // update requirement summary

      $.each(fieldSelectorMap, function(key, selector) {
        var field = $(selector).not('.taskRequirementsBody *');
        var value = 'N/A';
        if (typeof requirements.requirements_summary[key] != 'undefined')
          value = requirements.requirements_summary[key];
        updateField(field, value);
      });

      updatePrimaryLabel($('.features_requested').not('.taskRequirementsBody *'),
                         requirements.requirements_summary.features);

      updatePrimaryLabel($('.allocated-nodelist').not('.taskRequirementsBody *'),
                         requirements.requirements_summary.nodelist_allocated);

      updateGres($('.generic_resources').not('.taskRequirementsBody *'),
                 requirements.requirements_summary.generic_resources);

      // update requirement details
      $.each(requirements.requirements_details, function(i, requirement) {
        $.each(fieldSelectorMap, function(key, selector) {
          var field = $('#req-detail-' + i + ' ' + selector);
          var value = 'N/A';
          if (typeof requirement[key] != 'undefined')
            value = requirement[key];
          updateField(field, value);
        });

        updatePrimaryLabel($('#req-detail-' + i + ' .features_requested'), requirement.features);
        updateGres($('#req-detail-' + i + ' .generic_resources'), requirement.generic_resources);
      });

      addTooltipsToAllocationNodeList();
    }
  }
})(jQuery);
