// Copyright (c) 2016 by Adaptive Computing Enterprises, Inc. All Rights Reserved.

function padWithLeadingZeros(string) {
    "use strict";
    return new Array(5 - string.length).join('0') + string;
}
function unicodeCharEscape(charCode) {
    "use strict";
    return '\\u' + padWithLeadingZeros(charCode.toString(16));
}
function unicodeEscape(string) {
    "use strict";
    return string.split('').map(function (char) {
        var charCode = char.charCodeAt(0);
        return charCode > 127 ? unicodeCharEscape(charCode) : char;
    }).join('');
}
var idlist = '';
function replaceQuote(str) {
    "use strict";
    str = str.replace(/\"/g, '\\"');
    return str;
}
function onPageChangeRole() {
    "use strict";
    var pageNumber, viewPerPage;
    pageNumber = $('#pageNumber').val();
    viewPerPage = $('#viewPerPage').val();
    disablePaginationContent();
    $('#rolelistcontainer').append('<div class="preloader"></div>').show();
    $.ajax({
        url: '/rolelist_grid/',
        type: 'GET',
        data: {
            max: viewPerPage,
            offset: pageNumber
        },
        success: function (result) {
            $('#rolelistcontainer .preloader').hide();
            $('#rolelistcontainer').html(result);
            $('#pageNumber').children('option').eq(pageNumber - 1).attr('selected', true);
            $('#viewPerPage').val(viewPerPage);
            disablePaginationContent();
        }
    });
}
function onControlClickRole(caller) {
    "use strict";
    var pageNumber, viewPerPage, clickedButton, lastPageNumber;
    pageNumber = $('#pageNumber').val();
    viewPerPage = $('#viewPerPage').val();
    clickedButton = $(caller).attr('id');
    lastPageNumber = $('#pageNumber').find('option:last').val();
    $('#rolelistcontainer').append('<div class="preloader"></div>').show();
    $.ajax({
        url: '/rolelist_grid/',
        type: 'GET',
        data: {
            max: viewPerPage,
            offset: pageNumber,
            control: clickedButton,
            lastOffset: lastPageNumber
        },
        success: function (result) {
            $('#rolelistcontainer').html(result);
            switch (clickedButton) {
            case 'goToFirst':
                $('#pageNumber').children('option:first').attr('selected', true);
                break;
            case 'goToLast':
                $('#pageNumber').children('option:last').attr('selected', true);
                break;
            case 'prev':
                if (!$('#pageNumber').children('option').is(':first')) {
                    $('#pageNumber').children('option').eq(pageNumber - 2).attr('selected', true);
                }
                break;
            case 'next':
                if (!$('#pageNumber').children('option').is(':last')) {
                    $('#pageNumber').children('option').eq(pageNumber).attr('selected', true);
                }
                break;
            default:
                break;
            }
            $('#viewPerPage').val(viewPerPage);
            disablePaginationContent();
        }
    });
}
function jobPriority(ctrl, min, max) {
    "use strict";
    var input = parseInt(document.getElementById(ctrl).value, 10);
    if (input < min || input > max) {    	
        alert(gettext("Job priority:Value should be between {0} to {1}").replace("{0}",-1024).replace("{1}",0));
        document.getElementById(ctrl).value = min;
        return false;
    }
    return true;
}