// Copyright (c) 2016 by Adaptive Computing Enterprises, Inc. All Rights Reserved.

/**
    * Nodes.js will be used by NodeList, NodeDetails, ResourceJobTimeline
    * Created Date: 11/18/2014
    * Created By: Abhinavr
    * Version History:
    * 11/18/2014: [Abhinavr] Moved all the Nodes specifix methods/functions from main.js to Nodes.js
*/

var filterResourceListParam = {
    'resourceState': null,
    'processorFrom': 0,
    'processorTo': 0,
    'jobsFrom': 0,
    'jobsTo': 0,
    'cpuUtilizationFrom': 0,
    'cpuUtilizationTo': 0,
    'memoryUtilizationFrom': 0,
    'memoryUtilizationTo': 0
};
var searchResourceListParam = {
        resourceId: null,
        resourceClass: null,
        features: null
    };

var resourceJobTimeLineParam = {
    'NodeID': '',
    'JobID': '',
    'ReservationID': '',
    'resourceState': '',
    'processorFrom': 0,
    'processorTo': 0,
    'jobsFrom': 0,
    'jobsTo': 0,
    'nodeJobCntFrom': 0,
    'nodeJobCntTo': 0,
    'StartDate': 0,
    'EndDate': 0,
    'showJobs': 0,
    'showReservation': 0
};


var sortingStateRes = {
        'resourceid': 1,
        'resourcestatus': -1,
        'procs': -1,
        'jobs': -1,
        'cpuutilization': -1,
        'memoryutilization': -1
    };
var persistedResSortingState = {
        'colname': 'name',
        'sortState': 1,
        'isEnabled': true
    };

function checkData() {
    "use strict";
    var processorFrom, processorTo, jobsFrom, jobsTo, cpuUtilizationFrom, cpuUtilizationTo, memoryUtilizationFrom, memoryUtilizationTo;
    processorFrom = 0;
    processorFrom = parseInt($('#procsFrom').val(), 10);
    processorTo = 0;
    processorTo = parseInt($('#procsTo').val(), 10);
    if (processorFrom !== 0 && processorFrom > processorTo && processorTo !== -1) {
        alert(gettext('Processors: Please enter correct Range'));
        return false;
    }
    jobsFrom = 0;
    jobsFrom = parseInt($('#jobsFrom').val(), 10);
    jobsTo = 0;
    jobsTo = parseInt($('#jobsTo').val(), 10);
    if (jobsFrom !== 0 && jobsFrom > jobsTo && jobsTo !== -1) {
        alert(gettext('Jobs: Please enter correct Range'));
        return false;
    }
    cpuUtilizationFrom = 0;
    cpuUtilizationFrom = parseInt($('#proc_utilFrom').val(), 10);
    cpuUtilizationTo = 0;
    cpuUtilizationTo = parseInt($('#proc_utilTo').val(), 10);
    if (cpuUtilizationFrom !== 0 && cpuUtilizationFrom > cpuUtilizationTo && cpuUtilizationTo !== -1) {
        alert(gettext('CPU Utilization: Please enter correct Range'));
        return false;
    }
    memoryUtilizationFrom = 0;
    memoryUtilizationFrom = parseInt($('#memory_utilFrom').val(), 10);
    memoryUtilizationTo = 0;
    memoryUtilizationTo = parseInt($('#memory_utilTo').val(), 10);
    if (memoryUtilizationFrom !== 0 && memoryUtilizationFrom > memoryUtilizationTo && memoryUtilizationTo !== -1) {
        alert(gettext('Memory Utilization: Please enter correct Range'));
        return false;
    }
   /* $('.form-control').prop('readonly', 'true');
    $('#resourceState').prop('disabled', true);
    $('.filter').prop('disabled', true);
    $('#searchCat').prop('disabled', true);
    $('#searchBtn').prop('readonly', 'true');*/
    return true;
}
function checkMax(ctrl, min, max) {
    "use strict";
    var input;
    input = parseInt(document.getElementById(ctrl).value, 10);
    if (input < min || input > max) {
        alert(gettext('CPU Utilization:Value should be between {0} - {1}').replace('{0}', 0).replace('{1}', 100));
        clearInterval(intervalId);
        document.getElementById(ctrl).value = 100;
        return false;
    }
    return true;
}
function checkMaxMemory(ctrl, min, max) {
    "use strict";
    var input;
    input = parseInt(document.getElementById(ctrl).value, 10);
    if (input < min || input > max) {
        alert(gettext('Memory Utilization:Value should be between {0} - {1}').replace('{0}', 0).replace('{1}', 100));
        clearInterval(intervalId);
        document.getElementById(ctrl).value = 100;
        return false;
    }
    return true;
}
function disableResourcelistContentOnPageLoad() {
    "use strict";
    $('#searchCat').prop('disabled', true);
    $('.form-control').prop('readonly', 'true');
    $('#resourceState').prop('disabled', true);
    $('.filter').prop('disabled', true);
}

function disableResTimeLineContent() {
    "use strict";
    $('#searchCat').prop('disabled', true);
    $('.form-control').prop('readonly', 'true');
    $('#resourceState').prop('disabled', true);
    $('.filter').prop('disabled', true);
    $('#JobCheck').prop('disabled', true);
    $('#ReservastionChk').prop('disabled', true);
    $('#workload_toDate').css('display', 'none');
    $('#workload_startDate').css('display', 'none');
    $('#resourceJobTimeLineRefresh').addClass('disabled');
    $('#selectIntervals').attr('disabled', 'disabled');
    $('#nodelist').removeAttr("href");
    $('#timelineresources').removeAttr("href");
    $('#consumption').removeAttr("href");
    $('.incbutton').css('display', 'none');
    $('.decbutton').css('display', 'none');
}

function enableResourcelistContentOnPageLoad() {
    "use strict";
    $('#searchCat').prop('disabled', false);
    $('.form-control').removeAttr('readonly');
    $('#resourceState').prop('disabled', false);
    $('.filter').prop('disabled', false);
}

function enableResTimelineContent() {
    "use strict";
    $('#searchCat').prop('disabled', false);
    $('.form-control').removeAttr('readonly');
    $('#resourceState').prop('disabled', false);
    $('.filter').prop('disabled', false);
    $('#JobCheck').prop('disabled', false);
    $('#ReservastionChk').prop('disabled', false);
    $('#workload_toDate').css('display', 'block');
    $('#workload_startDate').css('display', 'block');
    $('#resourceJobTimeLineRefresh').removeClass('disabled');
    $('#selectIntervals').removeAttr('disabled');
    $('#nodelist').attr("href", "/nodelist/");
    $('#timelineresources').attr("href", "#");
    $('#consumption').attr("href", "#");
    $('.incbutton').css('display', 'block');
    $('.decbutton').css('display', 'block');
}

function updatePaginator(totalRows, rowsPerPage, currentRow) {
    totalRows = parseInt(totalRows);
    rowsPerPage = parseInt(rowsPerPage);
    var total = Math.ceil(totalRows / rowsPerPage);
    total = total === 0 ? 1 : total;
    $('#nodes .paginator-container').bootpag({
        total: total, // total pages
        page: currentRow,
        maxVisible: 7,
        leaps: true,
        firstLastUse: true,
        next: 'next',
        prev: 'prev'
    });
}

function js_yyyy_mm_dd_hh_mm_ss() {
    "use strict";
    var now, year, month, day, hour, minute, second, empty = '';
    now = new Date();
    year = empty + now.getFullYear();
    month = empty + (now.getMonth() + 1);
    if (month.length == 1) {
        month = '0' + month;
    }
    day = empty + now.getDate();
    if (day.length == 1) {
        day = '0' + day;
    }
    hour = empty + now.getHours();
    if (hour.length == 1) {
        hour = '0' + hour;
    }
    minute = empty + now.getMinutes();
    if (minute.length == 1) {
        minute = '0' + minute;
    }
    second = empty + now.getSeconds();
    if (second.length == 1) {
        second = '0' + second;
    }
    return year + '-' + month + '-' + day + ' ' + hour + ':' + minute + ':' + second;
}

function node_height_align() {
    "use strict";
    var obj, total_height;
    obj = $('.nodes-Row');
    total_height = parseInt(obj.length, 10) * 50 + 15;
    $('#now').height(total_height + 'px');
}
function onPageChangeResTimelineView() {
    "use strict";
    var viewPerPage, currentDateTime, flag = 0;
    viewPerPage = $('#viewPerPage').val();
    disableResTimeLineContent();
    localStorage.setItem('resJobTimeLine', viewPerPage);
    //Function to persist previous filter data of Narrow Search
    getnarrowsearchfilterdata()
    var intervalValue='OFF';
    intervalValue = $('#selectIntervals').val();       
    $('#dataGrid').append('<div class="preloader"></div>').show();
    $('#dataGrid').append('<div id="jobTimeLineLoader"></div>');
    if (!$('#filterInputNodeID').is(':visible')) {
        searchResourceListParam.NodeID = "";
    }

    if (!$('#filterInputJobID').is(':visible')) {
        searchResourceListParam.JobID = "";
    }
    if (!$('#filterInputReservationID').is(':visible')) {
        searchResourceListParam.ReservationID = null;
    }
    if (resourceJobTimeLineParam.processorFrom !== '0') {
        resourceJobTimeLineParam.processorFrom = $('#procsFrom').val();
    }
    if (resourceJobTimeLineParam.processorTo !== '0') {    	
    	resourceJobTimeLineParam.processorTo = $('#procsTo').val() == "∞" ? -1 : $('#procsTo').val();    	
    }
    if (resourceJobTimeLineParam.jobsFrom !== '0') {
        resourceJobTimeLineParam.jobsFrom = $('#jobsFrom').val();
    }
    if (resourceJobTimeLineParam.jobsTo !== '0') {     	
        resourceJobTimeLineParam.jobsTo = $('#jobsTo').val() == "∞" ? -1 : $('#jobsTo').val();
    }
    if (resourceJobTimeLineParam.nodeJobCntFrom !== '0') {
        resourceJobTimeLineParam.nodeJobCntFrom = $('#nodeJobCntFrom').val();
    }
    if (resourceJobTimeLineParam.nodeJobCntTo !== '0') {
        resourceJobTimeLineParam.nodeJobCntTo = $('#nodeJobCntTo').val() == "∞" ? -1 : $('#nodeJobCntTo').val();
    }
    if (resourceJobTimeLineParam.StartDate !== '0') {
        resourceJobTimeLineParam.StartDate = $('#txtStartDate').val();
    }
    if (resourceJobTimeLineParam.EndDate !== '0') {
        resourceJobTimeLineParam.EndDate = $('#txtEndDate').val();
    }
    if (resourceJobTimeLineParam.resourceState !== '0') {
        resourceJobTimeLineParam.resourceState = $('#resourceState').val();
    }
    if ($('#JobCheck').is(':checked')) {
        resourceJobTimeLineParam.showJobs = 1;
    } else {
        resourceJobTimeLineParam.showJobs = 0;
    }
    if ($('#ReservastionChk').is(':checked')) {
        resourceJobTimeLineParam.showReservation = 1;
    } else {
        resourceJobTimeLineParam.showReservation = 0;
    }
    var nodeState = $('#resourceState').val();
    if (nodeState) {
      searchResourceListParam.resourceState = nodeState;
    }
    currentDateTime = js_yyyy_mm_dd_hh_mm_ss();
    $.ajax({
        url: '/resourcejobtimelinegrid/',
        type: 'GET',
        data: {
        	persist: true,
            max: viewPerPage,
            offset: 1,
            nodeId: searchResourceListParam.NodeID,
            state: searchResourceListParam.resourceState,
            jobId: searchResourceListParam.JobID,
            reservationID: searchResourceListParam.ReservationID,
            procsFrom: resourceJobTimeLineParam.processorFrom,
            procsTo: resourceJobTimeLineParam.processorTo,
            jobsFrom: resourceJobTimeLineParam.jobsFrom,
            jobsTo: resourceJobTimeLineParam.jobsTo,
            nodeJobCntFrom: resourceJobTimeLineParam.nodeJobCntFrom,
            nodeJobCntTo: resourceJobTimeLineParam.nodeJobCntTo,
            startDate: resourceJobTimeLineParam.StartDate,
            endDate: resourceJobTimeLineParam.EndDate,
            showJobs: resourceJobTimeLineParam.showJobs,
            showReservation: resourceJobTimeLineParam.showReservation,
            currentDateTime: currentDateTime,
            intervalValue: intervalValue
        },
        success: function (result) {
            if (/^\s*<!DOCTYPE html>/.test(result)) {
                if (/Viewpoint Login/.test(result)) {
                    window.location = '/logout?expired=1';
                    return;
                }
                $('#dataGrid').html('500 Internal Server Error.');
                return;
            }
            $('#dataGrid .preloader').hide();
            $('#timeRangeAlert').hide();
            $('#dataGrid').html(result);
            $(".reservationRows").show();
            $('#pageNumber').children('option').eq(pageNumber - 1).attr('selected', true);
            $('#viewPerPage').val(viewPerPage);
            node_height_align();
            enableResTimelineContent();
            flag = 1;
        },
        error: function (jqXHR, exception) {
                griderror(jqXHR, exception);
                flag = 1
                $('#dataGrid').find('.preloader').hide();
                $('#jobTimeLineLoader').remove();
            }
    });
 // Large data load message         
    setInterval(function () {
        if (flag == 0) {
            $('#timeRangeAlert').show(1000);
        }
        flag = 1;
    }, 5000);
}

function findElementByText(searchField, searchStr, caseSensitive) {
    "use strict";
    if (caseSensitive == undefined || caseSensitive == null) {
        caseSensitive = false;
    }
    return searchField.filter(function () {
        if (caseSensitive) {
            return $(this).text().trim().toLowerCase() == searchStr.trim().toLowerCase();
        }
        return $(this).text().trim() == searchStr.trim();
    });
}

function incrementMax(id) {
    "use strict";
    if (checkMax(id, 0, 99) == true) {
        var value = parseInt($('#' + id).val(), 10);
        if (isNaN(value)) {
            $('#' + id).val(0);
        } else {
            $('#' + id).val(value + 1);
        }
    }
}
function incrementMaxM(id) {
    "use strict";
    if (checkMaxMemory(id, 0, 99) == true) {
        var value = parseInt($('#' + id).val(), 10);
        if (isNaN(value)) {
            $('#' + id).val(0);
        } else {
            $('#' + id).val(value + 1);
        }
    }
}
function statusCodeInitialiseRes() {
    "use strict";
    filterResourceListParam.resourceState = $('#resourceState').val();
}
function center_align_timescale() {
    "use strict";
    var test, prop, obj, flag, width, td_margin;
    test = document.getElementsByClassName('content');
    for (prop = 0; prop < test.length; prop++) {
        obj = test[prop];
        flag = 0;
        width = parseInt(obj.clientWidth, 10) + 1;
        td_margin = obj.style['margin-left'];
        if (!td_margin) {
            td_margin = obj.style.marginLeft;
            flag = 1;
        }
        td_margin = td_margin.replace('px', '');
        if (flag) {
            obj.style.marginLeft = td_margin - parseInt(width, 10) / 2 + 'px';
        } else {
            obj.style['margin-left'] = td_margin - parseInt(width, 10) / 2 + 'px';
        }
    }
}

(function ($) {
  var originalVal = $.fn.val;
  $.fn.val = function(new_val) {
				if(this[0]) {
					var ele=$(this[0]);
					if (ele.hasClass("to-number-inf")) {
                        var setValue = originalVal.call(this);
                        if (new_val == undefined) {
                            if (setValue == "∞") {                            	
                                setValue = -1
                            }
							return setValue
						} else {
                            setValue = new_val;
							if (new_val == "0") {
								setValue = 0
							}
							return originalVal.call(this,setValue)
						}
					}
				}
				 if(new_val == undefined) {
					return originalVal.call(this);
				 }else {
					 return originalVal.call(this,new_val);
				 }
  };
})(jQuery);
