// Copyright (c) 2016 by Adaptive Computing Enterprises, Inc. All Rights Reserved.
var processorsMaxLimit = 1000000000,
    NodeCountFoJobMaxLimit = 2000000000,
    jobMaxLimit = 1000,
    processorsMessage = 'Processors',
    JobsMessage = 'Jobs',
    NodeCountFoJobMessage = 'Node Count for Job',
    refreshTimer,
    Repeater;
// ResourceJobTimelineSearch function : This function search node id , job id and reservation id search.
function ResourceJobTimelineSearch(caller, event, persist) {
    "use strict";
    var keycode = event.keyCode || event.charCode,
        btnid,
        pageNumber,
        viewPerPage,
        searchBoxVal,
        searchCat,
        searchVal,
        valuePan,
        splitVal,
        intervalValue,
        flag = 0;
    btnid = $(caller).attr('id');
    if ((keycode === 13 || btnid === 'searchBtn') && checkResourceJobTimeLineData()) {
        viewPerPage = $('#viewPerPage').val();
        searchBoxVal = $('#searchCat').val() + ':' + $.trim($('#searchBox').val());
        searchCat = $('#searchCat').val();
        if (!searchCat) {
            return;
        } else if (searchCat === "JobID") {
            $("#JobCheck").prop('checked', true);
        } else if (searchCat === "ReservationID") {
            $("#ReservastionChk").prop('checked', true);
        }

        //Changes done for interval refresh retention
        intervalValue = 'OFF';
        intervalValue = $('#selectIntervals').val();
        //Changes done for IRIS - 434 starts
        searchVal = $.trim($('#searchBox').val());
        searchVal = searchVal.replace(/"/g, '\\"');
        searchVal = searchVal.replace(/\\/g, '\\');
        searchVal = escape(searchVal);
        //Changes done for IRIS - 434 starts ends
        //Function to persist previous filter data of Narrow Search
        getnarrowsearchfilterdata();
        resourceJobTimeLineParam.resourceState = $('#resourceState').val();
        resourceJobTimeLineParam.processorFrom = $('#procsFrom').val();
        resourceJobTimeLineParam.processorTo = $('#procsTo').val() == "∞" ? -1 : $('#procsTo').val();
        resourceJobTimeLineParam.jobsFrom = $('#jobsFrom').val();
        resourceJobTimeLineParam.jobsTo = $('#jobsTo').val() == "∞" ? -1 : $('#jobsTo').val();
        resourceJobTimeLineParam.nodeJobCntFrom = $('#nodeJobCntFrom').val();
        resourceJobTimeLineParam.nodeJobCntTo = $('#nodeJobCntTo').val() == "∞" ? -1 : $('#nodeJobCntTo').val();
        resourceJobTimeLineParam.StartDate = $('#txtStartDate').val();
        resourceJobTimeLineParam.EndDate = $('#txtEndDate').val();
        if ($('#JobCheck').is(":checked")) {
            resourceJobTimeLineParam.showJobs = 1;
        } else {
            resourceJobTimeLineParam.showJobs = 0;
        }
        if ($('#ReservastionChk').is(":checked")) {
            resourceJobTimeLineParam.showReservation = 1;
        } else {
            resourceJobTimeLineParam.showReservation = 0;
        }
        valuePan = '<span class="search-values" >'
                    + '<input type="text" id="filterInput" class="form-control" disabled>'
                    + '<span class="glyphicon glyphicon-remove" id="destroyFilter" onclick="removeTimeLineFilterVal(this)">'
                    + '</span></span>';
        $('#dataGrid').append('<div class="preloader"></div>').show();
        $('#dataGrid').append('<div id="jobTimeLineLoader"></div>');
        $('#resourceState').prop('disabled', true);
        disableresourcejobtimelinesearch();
        switch (searchCat) {
        case 'NodeID':
            searchResourceListParam.NodeID = searchVal;
            $('#opt1').attr('disabled', 'disabled');
            $('#opt1').addClass("optiondisabled");
            $('#searchCat').val($('#searchCat').find('#opt0').val());
            break;
        case 'JobID':
            searchResourceListParam.JobID = searchVal;
            $('#opt2').attr('disabled', 'disabled');
            $('#opt2').addClass("optiondisabled");
            $('#searchCat').val($('#searchCat').find('#opt0').val());
            break;
        case 'ReservationID':
            searchResourceListParam.ReservationID = searchVal;
            $('#opt3').attr('disabled', 'disabled');
            $('#opt3').addClass("optiondisabled");
            $('#searchCat').val($('#searchCat').find('#opt0').val());
            break;
        }

        $('#searchValues').append(valuePan);
        splitVal = searchBoxVal.split(':')[0];

        // Adding code for setting value for filterInput box.
        $('#filterInput').val(searchBoxVal);
        $('#filterInput').prop("id", "filterInput" + splitVal);
        $('#destroyFilter').prop("id", "destroyFilter" + splitVal);
        $('#searchBox').val('');
        currentDateTime = js_yyyy_mm_dd_hh_mm_ss();

        $.ajax({
            url: '/resourcejobtimelinegrid/',
            type: 'GET',
            data: {
                persist: persist,
                nodeId: searchResourceListParam.NodeID,
                jobId: searchResourceListParam.JobID,
                reservationID: searchResourceListParam.ReservationID,
                state: resourceJobTimeLineParam.resourceState,
                procsFrom: resourceJobTimeLineParam.processorFrom,
                procsTo: resourceJobTimeLineParam.processorTo,
                jobsFrom: resourceJobTimeLineParam.jobsFrom,
                jobsTo: resourceJobTimeLineParam.jobsTo,
                nodeJobCntFrom: resourceJobTimeLineParam.nodeJobCntFrom,
                nodeJobCntTo: resourceJobTimeLineParam.nodeJobCntTo,
                startDate: resourceJobTimeLineParam.StartDate,
                endDate: resourceJobTimeLineParam.EndDate,
                showJobs: resourceJobTimeLineParam.showJobs,
                showReservation: resourceJobTimeLineParam.showReservation,
                currentDateTime: currentDateTime,
                max: viewPerPage,
                intervalValue: intervalValue
            },
            success: function (result) {
                if (/^\s*<!DOCTYPE html>/.test(result)) {
                    if (/Viewpoint Login/.test(result)) {
                        window.location = '/logout?expired=1';
                        return;
                    }
                    $('#dataGrid').html('500 Internal Server Error.');
                    return;
                }
                $('#dataGrid').children('.preloader').hide();
                $('#timeRangeAlert').hide();
                $('#dataGrid').html(result);
                modifyDetailsLinks();
                $(".reservationRows").show();
                $('#viewPerPage').val(viewPerPage);
                $('#totalResourcesCnt').text($('#hiddenTotalCnt').val() + " " + gettext("results returned"));
                disablePaginationContent();
                $('#searchCat').prop('disabled', false);
                $('.form-control').removeAttr('readonly');
                $('#resourceState').prop('disabled', false);
                $('.filter').prop('disabled', false);
                enableresourcejobtimelinesearch();
                flag = 1;
            },
            error: function (jqXHR, exception) {
                griderror(jqXHR, exception);
                flag = 1
                $('#dataGrid').find('.preloader').hide();
                $('#jobTimeLineLoader').remove();
            }
        });
        // Large data load message
        setInterval(function () {
            if (flag == 0) {
                $('#timeRangeAlert').show(1000);
            }
            flag = 1;
        }, 5000);
    } else {
        $('#searchCat').prop('disabled', false);
        $('.form-control').removeAttr('readonly');
        $('#resourceState').prop('disabled', false);
        $('.filter').prop('disabled', false);
    }
}

function getURLParameterByName(name) {
  name = name.replace(/[\[]/, "\\[").replace(/[\]]/, "\\]");
  var regex = new RegExp("[\\?&]" + name + "=([^&#]*)"),
    results = regex.exec(location.search);
  return results === null ? "" : decodeURIComponent(results[1].replace(/\+/g, " "));
}

function restoreSearchParams() {
  // Init filters (In case user returned by "Return to previous search" link)
  var filterExists = false;
  for (var pName in resourceJobTimeLineParam) {
    var param = getURLParameterByName(pName);
    if (param && param != '-1') {
      filterExists = true;
      resourceJobTimeLineParam[pName] = param;
      switch (pName) {
        case 'StartDate':
          pName = 'txtStartDate';
          break;
        case 'EndDate':
          pName = 'txtEndDate';
          break;
        case 'processorFrom':
          pName = 'procsFrom';
          break;
        case 'processorTo':
          pName = 'procsTo';
          break;
        case 'showJobs':
          $('#JobCheck').prop('checked', true);
          pName = '';
          break;
        case 'showReservation':
          $('#ReservastionChk').prop('checked', true);
          pName = '';
          break;
      }
      if (pName) {
        $('#' + pName).val(param);
      }
    }
  }
  return filterExists;
}

function modifyDetailsLinks() {
  $('.jobNameLink').each(function() {
    var href = $(this).attr('href');
    var params = jQuery.extend(true, {}, resourceJobTimeLineParam);
    // Collect and store to href all filter parameters
    for (var i in params) {
      if (!params[i] || params[i] == '-1' || params[i] == '0') {
        delete params[i];
      }
    }
    if (!$.isEmptyObject(params)) {
      href += '&' + $.param(params);
    }
    $(this).attr('href', href);
  });
}

function removeTimeLineFilterVal(caller, persist) {
    "use strict";
    var searchValue = $(caller).prev('input[type="text"]').val(), searchString = searchValue.split(':'), switchVal = searchString[0];
    /*Check for Filter validation*/
    if (checkResourceJobTimeLineData()) {
        switch (switchVal) {
        case 'NodeID':
            searchResourceListParam.NodeID = 'null';
            $('#opt1').removeAttr('disabled');
            $('#opt1').removeClass("optiondisabled");
            break;
        case 'JobID':
            searchResourceListParam.JobID = 'null';
            $('#opt2').removeAttr('disabled');
            $('#opt2').removeClass("optiondisabled");
            $("#JobCheck").prop('checked', true);
            break;
        case 'ReservationID':
            searchResourceListParam.ReservationID = 'null';
            $('#opt3').removeAttr('disabled');
            $('#opt3').removeClass("optiondisabled");
            break;
        }
        $(caller).parent().remove();
        $('#nodelist').removeAttr("href");
        $('#timelineresources').removeAttr("href");
        $('#consumption').removeAttr("href");
        $('#viewPerPage').attr('disabled', false);
        $('#next').attr('disabled', false);
        $('#goToFirst').attr('disabled', false);
        $('#prev').attr('disabled', false);
        $('#goToLast').attr('disabled', false);
        $('#pageNumber').attr('disabled', false);
        $('.form-control').prop('readonly', true);
        $('.filter').prop('disabled', true);
        $('#searchCat').prop('disabled', true);
        $('#JobCheck').prop('disabled', true);
        $('#ReservastionChk').prop('disabled', true);
        $('#workload_toDate').css('display', 'none');
        $('#workload_startDate').css('display', 'none');
        $('.incbutton').css('display', 'none');
        $('.decbutton').css('display', 'none');
        //Add code for fix IRIS-509- Abhinavr - 8/21/2014
        doResourceJobTimelineFiltering(null, persist);
        //Add code for IRIS-509 ends

        if (!$('#filterInputNodeID').is(':visible')) {
            (searchResourceListParam.NodeID) = "";
        }

        if (!$('#filterInputJobID').is(':visible')) {
            (searchResourceListParam.JobID) = "";
        }

        if (!$('#filterInputReservationID').is(':visible')) {
            searchResourceListParam.ReservationID = "";
        }
    }
}

//doResourceJobTimelineFiltering function : This function filter out data for Start Date and end date (if selected), data as per status of jobs or reservations and Processors count, Jobs count and Node Count for Job.
//Modified for IRIS-851 starts - added a parameter (hidecurrentsearch)
function doResourceJobTimelineFiltering(cb, persist, hidecurrentsearch) {
    "use strict";
    var pageNumber, StartDate, EndDate, re, eDate, sDate, viewPerPage, intervalValue, flag = 0;
    if (checkResourceJobTimeLineData()) {

        //Function to persist previous filter data of Narrow Search
        getnarrowsearchfilterdata();
        viewPerPage = $('#viewPerPage').val();
        intervalValue = 'OFF';
        intervalValue = $('#selectIntervals').val();
        viewPerPage = $('#viewPerPage').val();
        pageNumber = $('#pageNumber').val();

        if (!$('#filterInputNodeID').is(':visible')) {
            searchResourceListParam.NodeID = "";
        }

        if (!$('#filterInputJobID').is(':visible')) {
            searchResourceListParam.JobID = "";
        }

        if (!$('#filterInputReservationID').is(':visible')) {
            searchResourceListParam.ReservationID = "";

            resourceJobTimeLineParam.resourceState = $('#resourceState').val();

            resourceJobTimeLineParam.processorFrom = $('#procsFrom').val();
        }

        if (resourceJobTimeLineParam.processorFrom === "") {
            $('#procsFrom').val(0);
            resourceJobTimeLineParam.processorFrom = 0;
        }
        if ($('#procsTo').val() === '∞') {
            resourceJobTimeLineParam.processorTo = -1;
        } else {
            resourceJobTimeLineParam.processorTo = $('#procsTo').val();
        }
        if (resourceJobTimeLineParam.processorTo === "") {
            $('#procsTo').val('∞');
            resourceJobTimeLineParam.processorTo = -1;
            if (!checkData()) {
                $('#dataGrid .preloader').hide();
                return false;
            }
        }
        resourceJobTimeLineParam.jobsFrom = $('#jobsFrom').val();

        if (resourceJobTimeLineParam.jobsFrom === "") {
            $('#jobsFrom').val(0);
            resourceJobTimeLineParam.jobsFrom = 0;
        }

        if ($('#jobsTo').val() === '∞') {
            resourceJobTimeLineParam.jobsTo = -1;
        } else {
            resourceJobTimeLineParam.jobsTo = $('#jobsTo').val();
        }
        if (resourceJobTimeLineParam.jobsTo === "") {
            $('#jobsTo').val('∞');
            resourceJobTimeLineParam.jobsTo = -1;
            if (!checkData()) {
                $('#dataGrid .preloader').hide();
                return false;
            }
        }
        resourceJobTimeLineParam.nodeJobCntFrom = $('#nodeJobCntFrom').val();

        if (resourceJobTimeLineParam.nodeJobCntFrom === "") {
            $('#nodeJobCntFrom').val(0);
            resourceJobTimeLineParam.nodeJobCntFrom = 0;
        }

        if ($('#nodeJobCntTo').val() === '∞') {
            resourceJobTimeLineParam.nodeJobCntTo = -1;
        } else {
            resourceJobTimeLineParam.nodeJobCntTo = $('#nodeJobCntTo').val();
        }
        if (resourceJobTimeLineParam.nodeJobCntTo === "") {
            $('#nodeJobCntTo').val('∞');
            resourceJobTimeLineParam.nodeJobCntTo = -1;
            if (!checkResourceJobTimeLineData()) {
                $('#dataGrid .preloader').hide();
                return false;
            }
        }
        resourceJobTimeLineParam.StartDate = $('#txtStartDate').val();
        resourceJobTimeLineParam.EndDate = $('#txtEndDate').val();
        if ($('#JobCheck').is(":checked")) {
            resourceJobTimeLineParam.showJobs = 1;
        } else {
            resourceJobTimeLineParam.showJobs = 0;
        }
        if ($('#ReservastionChk').is(":checked")) {
            resourceJobTimeLineParam.showReservation = 1;
        } else {
            resourceJobTimeLineParam.showReservation = 0;
        }
        $('#resourceListRefresh').hide();

        currentDateTime = js_yyyy_mm_dd_hh_mm_ss();

        $('#dataGrid').append('<div class="preloader"></div>').show();
        $('#dataGrid').append('<div id="jobTimeLineLoader"></div>');
        $('#searchCat').prop('disabled', true);
        $('.form-control').prop('readonly', 'true');
        $('#resourceState').prop('disabled', true);
        $('.filter').prop('disabled', true);
        $('#JobCheck').prop('disabled', true);
        $('#ReservastionChk').prop('disabled', true);
        if (searchResourceListParam.JobID !== '') {
            $('.jobsCheckBox').prop('disabled', false);
            $('.jobsCheckBox').prop("checked", true);
        }
        if (searchResourceListParam.ReservationID !== '') {
            $('.reservationsChkBox').prop('disabled', false);
            $('.reservationsChkBox').prop("checked", true);
        }
        disableresourcefilter();
          $.ajax({
              url: '/resourcejobtimelinegrid/',
              type: 'GET',
              data: {
                  persist: persist,
                  nodeId: searchResourceListParam.NodeID,
                  jobId: searchResourceListParam.JobID,
                  reservationID: searchResourceListParam.ReservationID,
                  state: resourceJobTimeLineParam.resourceState,
                  procsFrom: resourceJobTimeLineParam.processorFrom,
                  procsTo: resourceJobTimeLineParam.processorTo,
                  jobsFrom: resourceJobTimeLineParam.jobsFrom,
                  jobsTo: resourceJobTimeLineParam.jobsTo,
                  nodeJobCntFrom: resourceJobTimeLineParam.nodeJobCntFrom,
                  nodeJobCntTo: resourceJobTimeLineParam.nodeJobCntTo,
                  startDate: resourceJobTimeLineParam.StartDate,
                  endDate: resourceJobTimeLineParam.EndDate,
                  showJobs: resourceJobTimeLineParam.showJobs,
                  showReservation: resourceJobTimeLineParam.showReservation,
                  currentDateTime: currentDateTime,
                  offset: pageNumber,
                  max: viewPerPage,
                  intervalValue: intervalValue
              },
              success: function (result) {
                  if (/^\s*<!DOCTYPE html>/.test(result)) {
                      if (/Viewpoint Login/.test(result)) {
                          window.location = '/logout?expired=1';
                          return;
                      }
                      $('#dataGrid').html('500 Internal Server Error.');
                      return;
                  }
                  $('#dataGrid').children('.preloader').hide();
                  $('#timeRangeAlert').hide();
                  $('#dataGrid').html(result);
                  modifyDetailsLinks();
                  $(".reservationRows").show();
                  $('#viewPerPage').val(viewPerPage);
                  $('#pageNumber').val(pageNumber);

                  var itemsCount = $('#hiddenTotalCnt').val();
                  if (itemsCount) {
                    $('#totalResourcesCnt').text(itemsCount + " results returned");
                  }

                  disablePaginationContent();
                  $('#searchCat').prop('disabled', false);
                  $('.form-control').removeAttr('readonly');
                  $('#resourceState').prop('disabled', false);
                  $('.filter').prop('disabled', false);
                  $('#JobCheck').prop('disabled', false);
                  $('#ReservastionChk').prop('disabled', false);
                  enableresourcefilter();
                  flag = 1;
                  $('#resourceJobTimeLineRefresh').removeClass('disabled');
                  $('#selectIntervals').removeAttr('disabled');
                  if ($.isFunction(cb)) {
                    cb();
                  }
              },
              error: function (jqXHR, exception) {
                  griderror(jqXHR, exception);
                  flag = 1
                  $('#dataGrid').find('.preloader').hide();
                  $('#jobTimeLineLoader').remove();
              }
          });
        // Large data load message             
        setInterval(function () {
            if (flag == 0) {
                $('#timeRangeAlert').show(1000);
            }
            flag = 1;
        }, 5000);

    } else {
        $('#searchCat').prop('disabled', false);
        $('.form-control').removeAttr('readonly');
        $('#resourceState').prop('disabled', false);
        $('.filter').prop('disabled', false);
    }
    $('.reservationRows').find('div').popover('hide');
}
function checkResourceJobTimeLineData() {
    var processorFrom = 0, processorTo = 0, jobsFrom = 0, jobsTo = 0, nodeJobCntFrom = 0, nodeJobCntTo = 0,
        min_start_date = new Date('2000-01-01'), max_end_date = new Date('2900-12-31');
    processorFrom = parseInt($('#procsFrom').val(), 0);
    processorTo = parseInt($('#procsTo').val(), 0);
    StartDate = $('#txtStartDate').val();
    EndDate = $('#txtEndDate').val();
    re = /-/gi;
    StartDate = StartDate.replace(re, "/");
    EndDate = EndDate.replace(re, "/");
    eDate = new Date(EndDate);
    sDate = new Date(StartDate);
    startTxtDate = new Date(StartDate);
    startTxtDate = startTxtDate.toString();
    startTxtDate = startTxtDate.substring(11, 15);
    min_start_date = min_start_date.toString();
    min_start_date = min_start_date.substring(11, 15);
    endTxtDate = new Date(EndDate);
    endTxtDate = endTxtDate.toString();
    endTxtDate = endTxtDate.substring(11, 15);
    max_end_date = max_end_date.toString();
    max_end_date = max_end_date.substring(11, 15);

    if ((StartDate !== '' && EndDate !== '') && (startTxtDate < min_start_date || endTxtDate > max_end_date)) {
        alert(gettext("Please ensure Start Date is greater than {0}  and End Date is less than {1}.").replace('{0}', '2000-01-01').replace('{0}', '2900-12-31'));
        return false;
    }

    if (StartDate !== '' && EndDate !== '' && StartDate === EndDate) {
        alert(gettext("Please ensure that the End Date is greater than the Start Date."));
        return false;
    }

    if (StartDate !== '' && EndDate !== '' && sDate > eDate) {
        alert(gettext("Please ensure that the End Date is greater than the Start Date."));
        return false;
    }

    if ((StartDate === '' && EndDate !== '') || (StartDate !== '' && EndDate === '')) {
        alert(gettext("Please enter both Start Date and End date range."));
        return false;
    }

    // Adding code to remove rank columns --IRIS-333
    if (processorFrom !== 0 && processorFrom > processorTo && processorTo !== 0 && processorTo !== -1) {
        alert(gettext("Processors: Please enter correct Range"));
        return false;
    }
    jobsFrom = parseInt($('#jobsFrom').val(), 0);
    jobsTo = parseInt($('#jobsTo').val(), 0);

    // Adding code to remove rank columns --IRIS-333
    if (jobsFrom !== 0 && jobsFrom > jobsTo && jobsTo !== 0 && jobsTo !== -1) {
        alert(gettext("Jobs: Please enter correct Range"));
        return false;
    }
    nodeJobCntFrom = parseInt($('#nodeJobCntFrom').val(), 0);
    nodeJobCntTo = parseInt($('#nodeJobCntTo').val(), 0);

    // Adding code to remove rank columns --IRIS-333
    if (nodeJobCntFrom !== 0 && nodeJobCntFrom > nodeJobCntTo && nodeJobCntTo !== 0 && nodeJobCntTo !== -1) {
        alert(gettext("Node Count for Job: Please enter correct Range"));
        return false;
    }
    return true;
}

function refreshTimeLine(caller) {
  var btnid = $(caller).attr('id');
  if (btnid === 'resourceJobTimeLineRefresh') {
    if ($('#resourceJobTimeLineRefresh').hasClass('disabled')) {
      return;
    }
  }
  disableResTimeLineContent();
  doResourceJobTimelineFiltering(null, true);
}

function loadData(cb) {
  doResourceJobTimelineFiltering(cb, true);
}

/*Function to do ajax call on job reservation button click*/
$(document).ready(
    function () {
        "use strict";
        //Checking Job and Reservation checkbox conditions
        $('#ReservastionChk').change(function () {
            $('#filterInputReservationID').parent().remove();
            $('#destroyFilterReservationID').parent().remove();
            $('#opt3').removeAttr('disabled');
            $('#opt3').removeClass("optiondisabled");
        });
        $('#JobCheck').change(function () {
            $('#filterInputJobID').parent().remove();
            $('#destroyFilterJobID').parent().remove();
            $('#opt2').removeAttr('disabled');
            $('#opt2').removeClass("optiondisabled");
        });

        Repeater = new Viewpoint.Repeater({
          timeout: $('#selectIntervals').val(),
          fn: [loadData]
        });
        setRefreshInterval();
        changeIntervalHandler();
        $("#selectIntervals").change(changeIntervalHandler);

    }
);

function changeIntervalHandler() {
  var value = $('#selectIntervals').val();
  if (value === 'OFF') {
    Repeater.stop();
  } else {
    Repeater.setTimeout(value);
  }
  localStorage.setItem("nodesRefreshInterval", value);
}

function setRefreshInterval() {
  var refreshInterval = localStorage.getItem("nodesRefreshInterval");
  if (refreshInterval) {
    $('#selectIntervals').val(refreshInterval);
  }
}

/*Function to increment valaue on clicks of increement button*/
function incrementMaxCount(id, limit, elementMessage) {
    "use strict";
    if (checkMaxLimit(id, 0, limit, elementMessage, limit -1 ) == true) {
        var value = parseInt($('#' + id).val(), 10);
        if (isNaN(value)) {
            $('#' + id).val(0);
        } else {
            $('#' + id).val(value + 1);
        }
    }
}

/*Function to check Max Limit for filter items*/
function checkMaxLimit(ctrl, min, max, elementMessage, maxLimit) {
    "use strict";
    var input,
        maxCnt = max;
    /*maxLimit will be used when user clicks on increement button*/
    if (maxLimit) {
        maxCnt = maxLimit;
    }

    input = parseInt(document.getElementById(ctrl).value, 10);
    if (input < min || input > maxCnt) {
        alert(gettext("{0} :Value should be between {1} -  {2}").replace("{0}", elementMessage).replace("{1}", 0).replace("{2}", max.toLocaleString()));
        clearInterval(intervalId);
        document.getElementById(ctrl).value = max;
        return false;
    }
    return true;
}
function disableresourtimelineviewcontentoninterval() {
    "use strict";
    $('#resourceState').prop('disabled', true);
    $('.form-control').prop('readonly', true);
    $('.filter').prop('disabled', true);
    $('#searchCat').prop('disabled', true);
    $('#JobCheck').prop('disabled', true);
    $('#ReservastionChk').prop('disabled', true);
    $('#workload_toDate').css('display', 'none');
    $('#workload_startDate').css('display', 'none');
    $('#nodelist').removeAttr("href");
    $('#timelineresources').removeAttr("href");
    $('#consumption').removeAttr("href");
    $('.incbutton').css('display', 'none');
    $('.decbutton').css('display', 'none');
    $('#viewPerPage').attr('disabled', true);
    $('#next').attr('disabled', true);
    $('#goToFirst').attr('disabled', true);
    $('#prev').attr('disabled', true);
    $('#goToLast').attr('disabled', true);
    $('#next').attr('disabled', true);
    $('#pageNumber').attr('disabled', true);
}
function enableresourtimelineviewcontentoninterval() {
    "use strict";
    $('#searchCat').prop('disabled', false);
    $('.form-control').removeAttr('readonly');
    $('#resourceState').prop('disabled', false);
    $('.filter').prop('disabled', false);
    $('#JobCheck').prop('disabled', false);
    $('#ReservastionChk').prop('disabled', false);
    $('#workload_toDate').css('display', 'block');
    $('#workload_startDate').css('display', 'block');
    $('#nodelist').attr("href", "/nodelist/");
    $('#timelineresources').attr("href", "#");
    $('#consumption').attr("href", "#");
    $('.incbutton').css('display', 'block');
    $('.decbutton').css('display', 'block');
    $('#nodelist').attr("href", "/nodelist/");
    $('#timelineresources').attr("href", "#");
    $('#consumption').attr("href", "#");
    $('#viewPerPage').attr('disabled', false);
    $('#next').attr('disabled', false);
    $('#goToFirst').attr('disabled', false);
    $('#prev').attr('disabled', false);
    $('#goToLast').attr('disabled', false);
    $('#pageNumber').attr('disabled', false);
}
function disableresourcejobtimelinesearch() {
    "use strict";
    $('.form-control').prop('readonly', true);
    $('.filter').prop('disabled', true);
    $('#searchCat').prop('disabled', true);
    $('.incbutton').css('display', 'none');
    $('.decbutton').css('display', 'none');
    $('#JobCheck').prop('disabled',  true);
    $('#ReservastionChk').prop('disabled', true);
    $('#nodelist').removeAttr("href");
    $('#timelineresources').removeAttr("href");
    $('#consumption').removeAttr("href");
    $('#selectIntervals').prop('disabled', true);
    $('#viewPerPage').attr('disabled', true);
    $('#next').attr('disabled', true);
    $('#goToFirst').attr('disabled', true);
    $('#prev').attr('disabled', true);
    $('#goToLast').attr('disabled', true);
    $('#pageNumber').attr('disabled', true);
}
function enableresourcejobtimelinesearch() {
    "use strict";
    $('.incbutton').css('display', 'block');
    $('.decbutton').css('display', 'block');
    $('#nodelist').attr("href", "/nodelist/");
    $('#timelineresources').attr("href", "#");
    $('#consumption').attr("href", "#");
    $('#JobCheck').prop('disabled',  false);
    $('#ReservastionChk').prop('disabled', false);
    $('#selectIntervals').prop('disabled', false);
    $('#viewPerPage').attr('disabled', false);
    $('#next').attr('disabled', false);
    $('#goToFirst').attr('disabled', false);
    $('#prev').attr('disabled', false);
    $('#goToLast').attr('disabled', false);
    $('#pageNumber').attr('disabled', false);
}
function disableresourcefilter() {
    "use strict";
    $('#workload_toDate').css('display', 'none');
    $('#workload_startDate').css('display', 'none');
    $('.incbutton').css('display', 'none');
    $('.decbutton').css('display', 'none');
    $('#nodelist').removeAttr("href");
    $('#timelineresources').removeAttr("href");
    $('#consumption').removeAttr("href");
    $('#viewPerPage').attr('disabled', true);
    $('#next').attr('disabled', true);
    $('#goToFirst').attr('disabled', true);
    $('#prev').attr('disabled', true);
    $('#goToLast').attr('disabled', true);
    $('#pageNumber').attr('disabled', true);
}
function enableresourcefilter() {
    "use strict";
    $('#workload_toDate').css('display', 'block');
    $('#workload_startDate').css('display', 'block');
    $('.incbutton').css('display', 'block');
    $('.decbutton').css('display', 'block');
    $('#nodelist').attr("href", "/nodelist/");
    $('#timelineresources').attr("href", "#");
    $('#consumption').attr("href", "#");
    $('#viewPerPage').attr('disabled', false);
    $('#next').attr('disabled', false);
    $('#goToFirst').attr('disabled', false);
    $('#prev').attr('disabled', false);
    $('#goToLast').attr('disabled', false);
    $('#pageNumber').attr('disabled', false);
}
// Added clear all button funtion IRIS-371
function resTimeLineClearForm() {
    "use strict";
    $('input[type=text]').val('');
    $('#searchCat').val("").attr('selected', 'selected');
    $('#resourceState').val('').attr('selected', 'selected');
    $('#pageNumber').val("1").attr('selected', 'selected');
    $('.reservationsChkBox').attr('checked', false);
    $("#JobCheck").prop("checked", true);
    $('#opt1').removeClass('optiondisabled');
    $('#opt2').removeClass('optiondisabled');
    $('#opt3').removeClass('optiondisabled');
    $('#opt1').removeAttr('disabled');
    $('#opt2').removeAttr('disabled');
    $('#opt3').removeAttr('disabled');
    $('.search-values').remove();
    $('#totalResourcesCnt').text('');
    doResourceJobTimelineFiltering(null, false, true);
}
//Added clear all button funtion IRIS-371

//Function to persist previous filter data of Narrow Search
function getnarrowsearchfilterdata() {
    "use strict";
    var searchString, switchVal;
    $(".search-values").children("input[type=text]").each(function () {
        searchString = $(this).val().split(':');
        switchVal = searchString[0];
        switch (switchVal) {
        case 'NodeID':
            searchResourceListParam.NodeID = searchString[1];
            break;
        case 'JobID':
            searchResourceListParam.JobID = searchString[1];
            break;
        case 'ReservationID':
            searchResourceListParam.ReservationID = searchString[1];
            break;
        }
    });
}
