/* Copyright (c) 2016 by Adaptive Computing Enterprises, Inc. All Rights Reserved. */

/**
 * Bootbox wrapper.
 */

;(function($) {
  'use strict';

  function confirm(title, message, buttons) {
    if (message === undefined) {
      message = title;
      title = undefined;
    }

    // XXX: https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Functions/arguments
    if (arguments.length > 2)
      buttons = Array.prototype.slice.call(arguments, 2);

    var deferred = $.Deferred();

    var options = {
      message: message,
      title: title
    };

    var fn;

    if (buttons) {
      var o = {};

      $(buttons).each(function(k, v) {
        o[k] = {
          callback: _.partial(deferred.resolve, v.result),
          label: v.label,
          className: v.className || 'btn-default'
        };
      });

      $.extend(options, { buttons: o } );

      fn = bootbox.dialog;
    } else {
      $.extend(options, {
        callback: function(result) {
          deferred.resolve(result);
        }
      });

      fn = bootbox.confirm;
    }

    fn(options);

    return deferred.promise();
  }

  if (!$.viewpoint) {
    $.viewpoint = {};
  }

  $.viewpoint.confirm = confirm;
})(jQuery);
