/* Copyright (c) 2016 by Adaptive Computing Enterprises, Inc. All Rights Reserved. */

/**
 * Bootstrap modal enhancements.
 */

;(function($) {
  'use strict';

  // XXX: it may be better to copy whole Bootstrap Modal and hack it

  function removeScrollBar() {
    var body = $(document.body);

    if (document.body.scrollHeight > document.documentElement.clientHeight)
      body
        .css('padding-right', parseInt(body.css('padding-right') || 0, 10) +
          window.innerWidth - $(window).width())
        .addClass('modal-open');
  }

  var Modal = function() {
    this.element = null;
  };

  Modal.prototype.show = function(url, payload, options) {
    var deferred = $.Deferred();

    this.element = $('<div>')
      .appendTo(document.body);

    // Additional backdrop to display loading animation
    removeScrollBar();
    this.backdrop = $('<div>')
      .addClass('modal-backdrop load active fade in')
      .appendTo(document.body)
      .css('height', document.body.scrollHeight);

    this.element.data('payload', payload);

    this.element.load(url, $.proxy(function() {
      if (this.backdrop) {
        this.backdrop.removeClass('active');

        // Restore scroll bar after removeScrollBar
        $(document.body).css('padding-right', '');
      }

      this.element
        .one('hidden.bs.modal', $.proxy(function(e) {
          var payload = this.element.data('payload');

          this.element.remove();

          deferred.resolve(payload);
        }, this))
        .one('shown.bs.modal', $.proxy(function(e) {
          if (this.backdrop)
            this.backdrop.remove();

          this.element.find('[tabindex="1"]').focus();
        }, this));

      this.element.find('.modal')
        .modal(options);
      if ($(this.element).html().indexOf('login-page-key') > -1) {
        // there was redirect to login
        // IRIS-1430
        window.location.assign("/login");
      }
    }, this));

    return deferred.promise();
  };

  Modal.prototype.dismiss = function(payload) {
    this.element.data('payload', payload);
    this.element.find('.modal').modal('hide');
  };

  Modal.prototype.payload = function(payload) {
    return payload ? this.element.data('payload', payload)
      : this.element.data('payload');
  };

  if (!$.viewpoint) {
    $.viewpoint = {};
  }

  $.viewpoint.modal = new Modal();
})(jQuery);
