from rest_framework_2_3_10.views import APIView
from rest_framework_2_3_10 import status
from rest_framework_2_3_10 import parsers
from rest_framework_2_3_10 import renderers
from rest_framework_2_3_10.response import Response
from rest_framework_2_3_10.authtoken.models import Token
from rest_framework_2_3_10.authtoken.serializers import AuthTokenSerializer


class ObtainAuthToken(APIView):
    throttle_classes = ()
    permission_classes = ()
    parser_classes = (parsers.FormParser, parsers.MultiPartParser, parsers.JSONParser,)
    renderer_classes = (renderers.JSONRenderer,)
    serializer_class = AuthTokenSerializer
    model = Token

    def post(self, request):
        serializer = self.serializer_class(data=request.DATA)
        if serializer.is_valid():
            token, created = Token.objects.get_or_create(user=serializer.object['user'])
            return Response({'token': token.key})
        return Response(serializer.errors, status=status.HTTP_400_BAD_REQUEST)


obtain_auth_token = ObtainAuthToken.as_view()
