## Copyright (c) 2016 by Adaptive Computing Enterprises, Inc. All Rights Reserved.

<%! from django.utils.translation import ugettext as _ %>
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <meta http-equiv='pragma' content='no-cache'>
    <meta http-equiv='expires' content='0'>
    <meta http-equiv='cache-control' content='no-cache'>

    <title>${self.title()}</title>

    <!--[if !IE]><!--><script>
    if (/*@cc_on!@*/false) {
            document.documentElement.className+=' ie10';
    }
</script><!--<![endif]-->

    <!-- CSS -->
    <link rel="stylesheet" type="text/css" href="/static/legacy/bootstrap/css/bootstrap.min.css" />
    %if debug:
    <link rel="stylesheet" type="text/css" href="/static/legacy/css/style.css" />
    %else:
    <link rel="stylesheet" type="text/css" href="/static/legacy/css/style.min.css" />
    %endif
    <link rel="stylesheet" href="../static/api/css/loader.css"/>
    <link rel="stylesheet" type="text/css" href="../static/number-polyfill/number-polyfill.css" />
    <link rel="icon" href="/static/iris/favicon.ico" type="image/x-icon"/>
    <link href="/static/iris/css/notify.css" rel="stylesheet" type="text/css" />

    <!-- JavaScripts -->
        <script type="text/javascript" src="/jsi18n/"></script>
		<script src="/static/legacy/js/common.js"></script>
        <script src="/static/legacy/js/jquery-min.js"></script>

        <script src="/static/js-cookie/src/js.cookie.js"></script>

        %if test:
        <script src="/static/jquery-mockjax/dist/jquery.mockjax.js"></script>
        <script src="/static/test/js/mock.js"></script>
        %endif

        <!-- Latest compiled and minified JavaScript -->
        <script src="/static/legacy/bootstrap/js/bootstrap.min.js"></script>

        <!-- Added require.js only on nodes page -->
        <!--<script src="/static/legacy/js/require.js" type="text/javascript"></script>-->

        <script type="text/javascript" src="../static/number-polyfill/number-polyfill.min.js"></script>
        <script type="text/javascript" src="/static/legacy/js/jsapi.js"></script>

        <script type="text/javascript" src="../static/lodash/lodash.min.js"></script>

        <script type="text/javascript" src="/static/api/js/api.js"></script>
        <script type="text/javascript" src="/static/api/js/loader.js"></script>

        <script type="text/javascript" src="/static/async/lib/async.js"></script>
        <script type="text/javascript" src="/static/iris/js/job-watcher.js"></script>
        <script type="text/javascript" src="/static/iris/js/repeater.js"></script>

        <script type="text/javascript" src="/static/remarkable-bootstrap-notify/dist/bootstrap-notify.js"></script>
        <script type="text/javascript" src="/static/iris/js/notify.js"></script>
        <script src="/static/moment/min/moment.min.js" type="text/javascript"></script>

    <script type="text/javascript">
        $(document).ready(function(){
            if (document.body.style['msTextCombineHorizontal'] != undefined) {
                document.documentElement.className+='ie11';
            }
            //inner pages if tab is in querystring
            var querytab = getParameterByName("tab");
            $('#mainNav li a').each(function(){
            //alert(this.id);
            if(this.id.trim() == querytab.trim()){
                $(this).parent().addClass('active');
                return true;
            }else{
                $(this).parent().removeClass('active');
            }
        });

        var str = location.href.toLowerCase();

        $('#mainNav li a').each(function(){
            if(str.indexOf(this.href.toLowerCase()) > -1) {
                $('li.active').removeClass('active');
                $(this).parent().addClass('active');
            }
        });

    });

    initCsrfToken('${ csrftoken }');


      // TODO: it can be moved to a separate JS-file or to data attribute
      $.viewpoint.user = {
        name: '${ user }',
        permissions: {
            templates_admin: ${ str('Templates Admin' in perms).lower() },
            job_details: ${ str('Job Details' in perms).lower() },
            job_edit_admin: ${ str('Job Edit Admin' in perms).lower() },
            nitro_jobs_create: ${ str('Create Nitro Jobs' in perms).lower() },
            nitro_statistics_details_widget_admin: ${ str('Nitro Statistics Details Widget Admin' in perms).lower() },
            remote_visualization_jobs_create: ${ str('Create Remote Visualization Jobs' in perms).lower() },
            remote_visualization_details_widgets_admin: ${ str('Remote Visualization Details Widgets Admin' in perms).lower() },
            remote_visualization_details_widget: ${ str('Remote Visualization Details Widget' in perms).lower() }
        }
      }

    </script>
<script type="text/javascript">
			$(document).ready(function(){
				var str = location.href.toLowerCase();
				$('.icons-box a').each(function(){
					if(str.indexOf('resourcejobtimeline') > -1) {
						$('.active1').removeClass('active1');
						$("#resources").parent().addClass('active');
					}//else if(str.indexOf('principal') > -1) {
						//$('li.active1').removeClass('active1');
						//$("#principals").parent().addClass('active1');
					//}

				});
			});
	</script>


    ${self.head_tags()}

    ${self.jquery_tags()}
</head>

<%
    if user.is_staff and not \
            (__features__.vp_user or __features__.vp_admin):
        configuration_url = '/licensed-features/'
    else:
        configuration_url = '/configuration/'
%>

<body>
    <div class="container">
        <header>

		<div class="col-xs-8">
            <img src="../static/legacy/images/moab_logo.png" width="209" height="30" alt="Moab Logo" />

			</div>
			<div class="col-xs-4">
			<ul class="nav navbar-nav navbar-right">
                %if user.is_authenticated() and not user.is_anonymous():
                    <li id="welcome_user">${_("Welcome")}, ${ user }</li>
                    <li><a href="/logout/" title="${_("Sign Out")}" id="signout">${_("Sign Out")}</a></li>
                %else:
                    <li><a href="/login/" title="Login">${_("Login")}</a></li>
                %endif
                <li>
                %if 'Configuration' in perms:
                        <a href="${configuration_url}" id="settings"><span class="icon ico-settings"></span></a>
                    %endif
                    <a href="http://docs.adaptivecomputing.com/9-1-0/Viewpoint/help.htm" target="_blank" id="help"><span class="icon ico-question"></span></a>
                </li>
            </ul>
			</div>

        </header>
        <nav id="mainNav">
            <ul>
                %if __features__.vp_admin or __features__.vp_user:
                %if hasAccess('Home'):
                    <li class="active"><a href="/dashboard/" id="dashboard" title="${_("Home")}">${_("Home")}</a></li>
                %endif
                %endif
                %if __features__.vp_admin or __features__.vp_user:
                %if hasAccess('Workload'):
                    <li><a href="/workload/" id="workload" title="${_("Workload")}">${_("Workload")}</a></li>
                %endif
                %endif

                %if __features__.vp_user:
                %if hasAccess('Templates'):
                    <li><a href="/templates/" id="appTemplates" title="${_("Templates")}">${_("Templates")}</a></li>
                %endif
                %endif

                %if __features__.vp_admin:
                %if hasAccess('Nodes'):
                    <li class="active1"><a href="/nodelist/" id="resources" title="${_("Nodes")}">${_("Nodes")}</a></li>
                %endif
                %endif

                %if __features__.vp_user:
                %if hasAccess('File Manager'):
                    <li class="active1"><a href="/file-manager/" id="fileManager" title="${_("File Manager")}">${_("File Manager")}</a></li>
                %endif
                %endif

                %if __features__.vp_remote_viz:
                %if hasAccess('Sessions'):
                <li><a href="/sessions/" id="sessions" title="${_("Remote Visualization Sessions")}">${_("Sessions")}</a></li>
                %endif
                %endif

                %if hasAccess('Configuration'):
                    <li><a href="${configuration_url}" id="configuration" title="${_("Configuration")}">${_("Configuration")}</a></li>
                %endif
            </ul>
        </nav>
        <div id="page-content">

            ${self.main_content()}

            <div class="separator">
                <div></div>
            </div>
            <footer>
                <div><img src="/static/legacy/images/adaptive_logo.jpg" width="159" height="103" alt="Adaptive Computing" /></div>
                <span class="copyright">
						<span>${_("Copyright")}&nbsp;&copy;&nbsp;<script type="text/javascript">document.write(new Date().getFullYear());</script>&nbsp;Adaptive&nbsp;Computing&nbsp;Enterprises,&nbsp;Inc.&nbsp;${_("All rights reserved.")}</span>
                </span>
            </footer>
        </div>
    </div>
    % if google_analytics == "1":
    <script>
        (function(i,s,o,g,r,a,m){i['GoogleAnalyticsObject']=r;i[r]=i[r]||function(){
        (i[r].q=i[r].q||[]).push(arguments)},i[r].l=1*new Date();a=s.createElement(o),
        m=s.getElementsByTagName(o)[0];a.async=1;a.src=g;m.parentNode.insertBefore(a,m)
        })(window,document,'script','//www.google-analytics.com/analytics.js','ga');
        ga('create', 'UA-35839514-1', 'adaptivecomputing.com');
        ga('send', 'pageview');
    </script>
    %endif
    ${self.end_script()}
    <%def name="hasAccess(x)">
    %if x in perms:
         <% return True %>
    %endif
    </%def>
</body>
</html>
