## Copyright (c) 2016 by Adaptive Computing Enterprises, Inc. All Rights Reserved.

<%! from django.utils.translation import ugettext as _ %>

<%inherit file="base.mako" />
<%namespace name="base" file="base.mako" />
<%def name="title()">${_("Viewpoint Configuration")}</%def>
<%def name="head_tags()"></%def>
<%def name="jquery_tags()">
<script type="text/JavaScript">
		$(document).ready(function(){
					 var h = document.getElementById("page-content").offsetHeight;
					 $("#side").height(h);

				createDirtyUnloadListener("input.form-control","${_("You have unsaved changes that will be lost.")}");
				$('[data-toggle="tooltip"]').tooltip();

				var date = moment.utc($('.build-date').text().replace(' UTC', '')).toDate();
                if (moment(date).isValid()) {
                  $('.build-date').text(moment(date).format('YYYY-MM-DD HH:mm:ss'));
                }
		});
</script>
</%def>
<%def name="main_content()">
	<div class="row configuration">
	<%include file="leftpanel.mako"/>

		<div class="col-xs-8">
			<div class="col-xs-12 section-header search-filter-section">
				
				<div>
						<div class="alert alert-danger" id="myAlert" style="display:none">				
						</div>
						<div class="alert alert-success" id="successAlert" style="display:none">                
                        </div>								
				</div>
				
			</div>
			<div class="clearfix"></div>

			<div class="col-xs-12 search-filter-section">

				<form id="contact-form" class="form-horizontal" action="/configuration/" method="POST">
				  	<h1>MWS Configuration</h1>
					<div class="clearfix"></div>
					<span class="control-group">
						<label for="URL" class="col-xs-2 text-left">${_("Server")}</label>
						<div class="col-xs-8">
							<input type="text" class="form-control" id="URL" name="URL" value="${ fileData['URL']  }" required />
							<div id="testpreload" style="display:none;"></div>
							<span id="urlverify" class="glyphicon glyphicon-ok-circle valid" style="display:none;"></span>
							<span id="urlwrong" class="glyphicon glyphicon-remove" style="display:none;"></span>
							<span id="lblLegitimate" style="display:none;"></span>
						</div>
						<div class="col-xs-2"></div>
					</span>
					<div class="clearfix"></div>
					<span class="control-group">
						<label for="Username" class="col-xs-2 text-left">${_("Username")}</label>
						<div class="col-xs-8">
							<input type="text" class="form-control" id="Username" name="Username" value="${ fileData['USERNAME']  }" required />
						</div>
						<div class="col-xs-2"></div>
					</span>
					<div class="clearfix"></div>
					<span class="control-group">
						<label for="Password" class="col-xs-2 text-left">${_("Password")}</label>
						<div class="col-xs-8">
							<input type="password" class="form-control" id="Password" name="Password" value="${ fileData['PASSWORD']  }" required/>
						</div>
						<div class="col-xs-2"></div>
					</span>
					<div class="clearfix"></div>
					<span class="control-group">
						<label for="Path" class="col-xs-2 text-left">${_("Path")}</label>
						<div class="col-xs-8">
							<input type="text" class="form-control" id="Path" name="Path" value="${ fileData['SUB_URL']  }" required/>
						</div>
						<div class="col-xs-2"></div>
					</span>
					<div class="clearfix"></div>
					<span class="control-group">
						<label for="ClientId" class="col-xs-2 text-left" title="This is required for OAuth.">${_("Client Id")}</label>
						<div class="col-xs-8">
							<input type="text" class="form-control col-xs-10 pull-left" id="ClientId" name="ClientId" title="${ fileData['CLIENTID']  }" value="${ fileData['CLIENTID']  }" required/>
						</div>
						<div class="col-xs-2"></div>
					</span>

					<div class="clearfix"></div>
					<span class="control-group">
						<label for="ClientSecret" class="col-xs-2 text-left" title="This is required for OAuth.">${_("Client Secret")}</label>
						<div class="col-xs-8">
							<input type="password" class="form-control" id="ClientSecret" name="ClientSecret" value="${ fileData['CLIENTSECRET']  }" required />
						</div>
						<div class="col-xs-2"></div>
					</span>
					%if not user.is_staff:
						<div class="clearfix"></div>
						<span class="control-group">
							<div class="col-xs-7 height">
                <input type="hidden" id="resetpermission" name="resetpermission" />
								<input type="checkbox" class="form-control" id="Permissions" name="Permissions" value="alert-danger" onclick="resetPermission(this)"/>
								<label for="Permissions" class="col-xs-7 text-left permission">${_("Reset Permissions")} </label>
								<div class="reset-permissions-alert-container">
								  <div class="alert alert-danger pull-left" style="display:none; position: absolute; width: 300px;">
                    ${_("Warning: All roles will be deleted from all principals, and all permissions and roles will be recreated using default values. This action cannot be undone!")}
                  </div>
                </div>
							</div>
							<div class="col-xs-5 height">
              						    <button type="button" class="btn btn-primary cnf-button right"
                					    onclick="testForm('test')" id="test">${_("Test")}</button>
							</div>
						</span>
					%else:
					    <div class="col-xs-12 height">
              			                <button type="button" class="btn btn-primary cnf-button right"
                		                onclick="testForm('test')" id="test">${_("Test")}</button>
					    </div>
          %endif

          <div class="clearfix"></div>
          <div class="col-xs-12">
					 <div class="hrule_cnf"></div>
          </div>

          %if __features__.vp_user:
					<h1>File Manager Configuration</h1>
					<div class="clearfix"></div>
					<span class="control-group">
						<label for="AccessibleRoots" class="col-xs-2 text-left long-label">${_("Accessible Roots")}</label>
						<div class="col-xs-8">
							<input type="text" class="form-control" id="AccessibleRoots" name="AccessibleRoots" value="${ fileData['ACCESSIBLE_ROOTS']  }" required />
						</div>
						<div class="col-xs-2"></div>
					</span>

					<div class="clearfix"></div>
					<span class="control-group">
						<label for="FileUploadSize" class="col-xs-2 text-left long-label">${_("Maximum Upload Size (bytes)")}</label>
						<div class="col-xs-8">
							<input type="text" class="form-control" id="FileUploadSize" name="FileUploadSize" value="${ fileData['FILE_UPLOAD_SIZE']  }"
							    data-placement="top" title="Set this to -1 to disable the upload limit"/>
						</div>
						<div class="col-xs-2"></div>
					</span>

          <div class="clearfix"></div>
          <span class="control-group">
            <label for="ClientProtocol" class="col-xs-2 text-left long-label">${_("Server Protocol")}</label>
            <div class="col-xs-8">
              <input type="text" class="form-control" id="ClientProtocol" name="ClientProtocol"
                value="${ fileData['WEBDAV']['CLIENT_PROTOCOL'] }" data-placement="top" />
            </div>
            <div class="col-xs-2"></div>
          </span>

          <div class="clearfix"></div>
          <span class="control-group">
            <label for="ClientVerifySSL" class="col-xs-2 text-left long-label">${_("Server Verify SSL")}</label>
            <div class="col-xs-8">
              <input type="hidden" id="ClientVerifySSL" name="ClientVerifySSL"
                value="${ fileData['WEBDAV']['CLIENT_VERIFY_SSL'] }" />
              <input type="checkbox" class="form-control" id="ClientVerifySSLChbox" style="margin-top: 14px"
                name="ClientVerifySSLChbox" onclick="certificateCheckBoxClick()" />
            </div>
            <div class="col-xs-2"></div>
          </span>

          <div class="clearfix"></div>
          <span class="control-group">
            <label for="SSLClientCert" class="col-xs-2 text-left long-label">
              ${_("SSL Certificate File")}</label>
            <div class="col-xs-8">
              <input type="text" class="form-control" id="SSLClientCert" name="SSLClientCert"
                data-placement="top" value="${ fileData['SSL_CERT'] }" />
            </div>
            <div class="col-xs-2"></div>
          </span>

          <div class="clearfix"></div>
          <span class="control-group">
            <label for="SSLClientKey" class="col-xs-2 text-left long-label">
              ${_("SSL Certificate Key")}</label>
            <div class="col-xs-8">
              <input type="text" class="form-control" id="SSLClientKey" name="SSLClientKey"
                data-placement="top" value="${ fileData['SSL_KEY'] }" />
            </div>
            <div class="col-xs-2"></div>
          </span>

          <div class="clearfix"></div>
          <span class="control-group">
            <label for="SSLClientKey" class="col-xs-2 text-left long-label">
              ${_("CA Bundle File")}</label>
            <div class="col-xs-8">
              <input type="text" class="form-control" id="CABundleFile" name="CABundleFile"
                data-placement="top" value="${get_verify_ssl_param(fileData['WEBDAV']['CLIENT_VERIFY_SSL'])}" />
            </div>
            <div class="col-xs-2"></div>
          </span>

          <div class="clearfix"></div>
          <span class="control-group">
            <label for="ClientHost" class="col-xs-2 text-left long-label">${_("Server Host")}</label>
            <div class="col-xs-8">
              <input type="text" class="form-control" id="ClientHost" name="ClientHost"
                value="${ fileData['WEBDAV']['CLIENT_HOST'] }" data-placement="top" />
            </div>
            <div class="col-xs-2"></div>
          </span>

          <div class="clearfix"></div>
          <span class="control-group">
            <label for="ClientPort" class="col-xs-2 text-left long-label">${_("Server Port")}</label>
            <div class="col-xs-8">
              <input type="text" class="form-control" id="ClientPort" name="ClientPort"
                value="${ fileData['WEBDAV']['CLIENT_PORT'] }" data-placement="top" />
            </div>
            <div class="col-xs-2"></div>
          </span>

          <div class="clearfix"></div>
          <span class="control-group">
            <label for="ClientRootPath" class="col-xs-2 text-left long-label">${_("Server Root Path")}</label>
            <div class="col-xs-8">
              <input type="text" class="form-control" id="ClientRootPath" name="ClientRootPath"
                value="${ fileData['WEBDAV']['CLIENT_ROOT_PATH'] }" data-placement="top" />
            </div>
            <div class="col-xs-2"></div>
          </span>

          <div class="clearfix"></div>
          <div class="col-xs-12">
           <div class="hrule_cnf"></div>
          </div>
          %endif

					<h1>Misc Options</h1>
					<div class="clearfix"></div>

          %if __features__.vp_admin:

					<span class="control-group">
						<label for="NodeNamesFilter" class="col-xs-2 text-left long-label" title="">${_("Node Names to Ignore")}</label>
						<div class="col-xs-8">
							<input type="text" class="form-control" id="NodeNamesFilter" name="NodeNamesFilter" value="${ fileData['IGNORED_NODES']  }"
							    data-placement="top" title="Enumerate the node names separating with commas."/>
						</div>
						<div class="col-xs-2"></div>
					</span>
					<div class="clearfix"></div>
            %endif

					<span class="control-group">
						<div class="col-xs-6">
							% if fileData['GOOGLE_ANALYTICS'] == "1":
							<input type="checkbox" class="form-control" id="analytics" name="analytics" onclick="setAnalytics(this)" checked />
							%else:
							<input type="checkbox" class="form-control" id="analytics" name="analytics" onclick="setAnalytics(this)" />
							% endif
							<label for="analytics" class="col-xs-7 text-left required">${_("Use Google Analytics to help improve this product")} </label>
							<input type="hidden" id="analytics1" name="analytics1" value="" />
						</div>
					</span>

          <div class="clearfix"></div>
          <div class="col-xs-12">
              <div class="hrule_cnf" style="margin-bottom:0px;"></div>
          </div>
          <div class="col-xs-12">
              <button type="button" class="btn btn-primary cnf-button right" style="margin-top:10px"
              id="submit" onclick="testForm('save')">${_("Save")}</button>
          </div>

				</form>
			</div>

		<div class="col-xs-12">
			<h4>${_("Viewpoint Build Information")}</h4>
					<span class="control-group">
						<span class="col-xs-2 text-left">${_("Version")}:</span>
						<div class="col-xs-8">
							<span class="col-xs-10 pull-left build-field">
								%if build_info["version"] is not None:
									${ build_info["version"]  }
								%else:
								   &nbsp;-&nbsp;
								%endif
							</span>
						</div>
						<div class="col-xs-2"></div>
					</span>

			<div class="clearfix"></div>
					<span class="control-group">
						<span class="col-xs-2 text-left">${_("Revision")}:</span>
						<div class="col-xs-8">
							<span class="col-xs-10 pull-left build-field">
								%if build_info["changeset"] is not None:
									${ build_info["changeset"] }
								%else:
								   &nbsp;-&nbsp;
								%endif
							</span>
						</div>
						<div class="col-xs-2"></div>
					</span>

			%if build_info["branch"] is not None:

			## Can be set in staging builds

			<div class="clearfix"></div>
					<span class="control-group">
						<span class="col-xs-2 text-left">${_("Branch")}:</span>
						<div class="col-xs-8">
							<span class="col-xs-10 pull-left build-field">
 								${ build_info["branch"] | h }
							</span>
						</div>
						<div class="col-xs-2"></div>
					</span>

			%endif

			<div class="clearfix"></div>
					<span class="control-group">
						<span class="col-xs-2 text-left">${_("Build Date")}:</span>
						<div class="col-xs-8">
							<span class="col-xs-10 pull-left build-field build-date">${build_info.get('build_date', 'N/A') or 'N/A'}</span>
						</div>
						<div class="col-xs-2"></div>
					</span>

			<div class="clearfix"></div>
		</div>
		</div>
	</div>
</%def>
<%def name="get_verify_ssl_param(value)">
%if isinstance(value, basestring):
${value}
%else:
${""}
%endif
</%def>
<%def name="end_script()">

	<script type="text/javascript">
		function setAnalytics(obj)
		{
			if(obj.checked){
				$("#analytics1").val(1)
			}
		}
		function resetPermission(obj)
		{
			if(obj.checked){
				$("#resetpermission").val(1)
				$('.alert-danger.pull-left').show()
			}else{
				$("#resetpermission").val(0)
				$('.alert-danger.pull-left').hide()
			}
		}
	</script>

<script type="text/javascript">

var initData;

function getConfigData() {
  return {
    "URL": $('#URL').val(),
    "Username": $('#Username').val(),
    "Password": $('#Password').val(),
    "Path": $('#Path').val(),
    "ClientId": $('#ClientId').val(),
    "ClientSecret": $('#ClientSecret').val(),
    "analytics1": $('#analytics1').val(),
    "resetpermission": $('#resetpermission').val(),
    "AccessibleRoots": $('#AccessibleRoots').val(),
    "FileUploadSize": $('#FileUploadSize').val(),
    "NodeNamesFilter": $('#NodeNamesFilter').val(),
    "ClientProtocol": $('#ClientProtocol').val(),
    "ClientHost": $('#ClientHost').val(),
    "ClientPort": $('#ClientPort').val(),
    "ClientRootPath": $('#ClientRootPath').val(),
    "ClientVerifySSL": $('#ClientVerifySSLChbox').is(':checked') ? $('#CABundleFile').val() : 'false',
    "SSLClientCert": $('#SSLClientCert').val(),
    "SSLClientKey": $('#SSLClientKey').val()
  };
}

$(document).ready(function() {
  $('#ClientVerifySSLChbox').prop('checked', false);
  if ($('#ClientVerifySSL').val() && $('#ClientVerifySSL').val() != 'False') {
    $('#ClientVerifySSLChbox').prop('checked', true);
  }
  initData = getConfigData();
  certificateCheckBoxClick();
});

function testForm(action) {

  //Code to validate the required fields, done on 7/4/14 - abhinavr
  if(!validateConfigurationForm('URL'))
    return false;
  if(!validateConfigurationForm('Username'))
    return false;
  if(!validateConfigurationForm('Password'))
    return false;
  if(!validateConfigurationForm('Path'))
    return false;
  if(!validateConfigurationForm('ClientId','${_('Client Id')}'))
    return false;
  if(!validateConfigurationForm('ClientSecret','${_('Client Secret')}'))
    return false;
  if ($('#ClientVerifySSLChbox').is(':checked') && !validateConfigurationForm('SSLClientKey'))
    return false;
  if ($('#ClientVerifySSLChbox').is(':checked') && !validateConfigurationForm('SSLClientCert'))
    return false;
  if ($('#ClientVerifySSLChbox').is(':checked') && !validateConfigurationForm('CABundleFile'))
    return false;
  //Code to validate the required fields ends
  if (action == 'save' && JSON.stringify(initData) == JSON.stringify(getConfigData())) {
    $('#successAlert').empty();
    $('#successAlert').html('<a onclick="closeBtn()" class="close" id="crossBtn" href="#">&times;</a>');
    $('#successAlert').append('Successfully saved settings.');
    $('#successAlert').show();
    return;
  }

  //Code to post the form fields asynchronously
  url = $("#URL").val();
  $("#lblLegitimate").hide();
  $("#urlverify").hide();
  $("#urlwrong").hide();
  $("#testpreload").show();
  $("#testpreload").addClass("configuration-preloader");

  //$('#divSubmitLoader').show();
  if(action != 'test') {
	$('#submit').text("In progress..");
  }
  //disabling the buttons on post start
  $('.form-control').prop('readonly', 'true');   //disables all textbox
  $('#submit').prop('disabled', true);
  $('#test').prop('disabled', true);
  //disabling the buttons on post ends

  //removing the links
  $("#dashboard").removeAttr("href");
  $('#workload').removeAttr("href");
  $('#resources').removeAttr("href");
  $('#configuration').removeAttr("href");
  $('#mwsconfiguration').removeAttr("href");
  $('#roles').removeAttr("href");
  $('#principals').removeAttr("href");
  $('#signout').removeAttr("href");
  $('#settings').removeAttr("href");
  $('#help').removeAttr("href");
  $('#mwsconfiguration').css("color","#fff");
  $('#roles').css("color","#fff");
  $('#principals').css("color","#fff")
  //removing the links ends

  var formData = {
    "URL": $('#URL').val(),
    "Username": $('#Username').val(),
    "Password": $('#Password').val(),
    "Path": $('#Path').val(),
    "ClientId": $('#ClientId').val(),
    "ClientSecret": $('#ClientSecret').val(),
    "analytics1": $('#analytics1').val(),
    "resetpermission": $('#resetpermission').val(),
    "AccessibleRoots": $('#AccessibleRoots').val(),
    "FileUploadSize": $('#FileUploadSize').val(),
    "NodeNamesFilter": $('#NodeNamesFilter').val(),
    "Action": action,
    "ClientProtocol": $('#ClientProtocol').val(),
    "ClientHost": $('#ClientHost').val(),
    "ClientPort": $('#ClientPort').val(),
    "ClientRootPath": $('#ClientRootPath').val(),
    "ClientVerifySSL": $('#ClientVerifySSLChbox').is(':checked') ? $('#CABundleFile').val() : 'false',
  };
  if ($('#SSLClientCert').val() != '' || $('#SSLClientKey').val() != '') {
    formData.SSLClientCert = $('#SSLClientCert').val();
    formData.SSLClientKey = $('#SSLClientKey').val();
  }

  $.post('/configuration/', formData, function (result) {
    if(result != 'False') {

      //Showing the alert message on success
      var res = "";
      var resStatus = ""
      var resStatusModifier = ""
      if(result.lastIndexOf(",") > 0) {
        res = result.substring(0,result.lastIndexOf(",")).trim();
        resStatus = result.substring(result.lastIndexOf(",")+1).trim()
        resStatusParts = resStatus.split(':')
        if (resStatusParts.length > 1) {
        	resStatus = resStatusParts[0];
        	resStatusModifier = resStatusParts[1];
        }
      } else {
        res = result;
      }
      if(res.length > 0) {
        res[0] = res[0].toUpperCase();
      }
      $('#myAlert').hide();
      $('#successAlert').hide();
      if(resStatus=="success") {
        if(action != 'test') {
          successCase(res);
            // for turning off dirty check on save
            isDirtyPlaceholder = false;
        }
        $("#urlverify").show();
        $("#testpreload").hide();
      }
      else {
        failCase(res, resStatusModifier);
      }

      $('#submit').text("Save");
      //Showing the alert message on success ends

      //enabling the buttons on post
      enableButtons();
      //Enabling the buttons on post ends

      //Adding the links again
      if (action == 'test') {
        addLinks();
      }
      //Adding the links again ends

      if (action == 'save' && resStatus == "success") {
        if (initData['resetpermission'] != formData['resetpermission'] ||
         initData['URL'] != formData['URL'] || initData['Username'] != formData['Username'] ||
          initData['Password'] != formData['Password'] || initData['Path'] != formData['Path'] ||
           initData['ClientId'] != formData['ClientId'] || initData['ClientSecret'] != formData['ClientSecret']) {
			setTimeout('window.location = "/logout?expired=1"', 5000);
        }
        else {
        	addLinks()
        }
      }
    }
  })
  .fail(function(response) {
    if (response.status == 403) {
        successCase(response.responseText);
        $('#submit').text("Save");
        setTimeout('window.location = "/logout?expired=1"', 6500);
    }
    else {
        if (response.responseText == "" || response.responseText =="Unknown error") {
            response.responseText = "Could not connect";
       	}
       	enableButtons();
       	addLinks();
        failCase(response.responseText);
        $('#submit').text("Save");
    }
  });
}

function addLinks() {
    $("#dashboard").attr("href","/dashboard/");
    $('#workload').attr("href","/workload/");
    $('#resources').attr("href","/nodelist/");
    $('#configuration').attr("href","/configuration/");
    $('#mwsconfiguration').attr("href","/configuration/");
    $('#roles').attr("href","/rolelist/?tab=configuration");
    $('#principals').attr("href","/principallist/?tab=configuration");
    $('#signout').attr("href","/logout/");
    $('#settings').attr("href","/configuration/");
    $('#help').attr("href","http://docs.adaptivecomputing.com/9-1-0/Viewpoint/help.htm");
}

function enableButtons() {
    $('#submit').prop('disabled', false);
    $('#test').prop('disabled', false);
    $('.form-control').removeAttr('readonly');
}

function failCase(message, modifier) {
    $('#myAlert').empty();
    $('#myAlert').html('<a onclick="closeBtn()" class="close" id="crossBtn" href="#">&times;</a>');
    $('#myAlert').append(message);
    $('#myAlert').show();
    $("#urlwrong").show();
    $("#testpreload").hide();
    isDirtyPlaceholder = false;
}

function successCase(message) {
    $('#successAlert').empty();
    $('#successAlert').html('<a onclick="closeBtn()" class="close" id="crossBtn" href="#">&times;</a>');
    if (/^\s*<!DOCTYPE html>/.test(message)) {
      if (/initCsrfToken/.test(message)) {
        window.location = '/logout?expired=1';
        return;
      } else {
        message = 'We detected an error while retrieving data from Moab Web Services. Please check your MWS log files for more information.'
      }
    }
    $('#successAlert').text(message);
    $('#successAlert').show();
    $("#testpreload").hide();
    isDirtyPlaceholder = false;
}

  function closeBtn() {

    $('#myAlert').hide();
    $('#successAlert').hide();
  }
</script>
<script type="text/javascript">
<!--
// Form validation code will come here.
function validateConfigurationForm(ctrlName, ctrlValue)
{
   if( $('#' + ctrlName + '').val().trim() == "" )
   {
	 if(ctrlValue == undefined || ctrlValue == null || ctrlValue.trim() == ""){
		 ctrlValue = ctrlName
	 }
     alert("${_("Please provide valid value for {0}")}".replace("{0}", ctrlValue));
     $('#' + ctrlName + '').focus() ;
     return false;
   }
   
   if(!document.getElementById("URL").value.match(/^[\u0020-\u007e]+$/))            
    {
        $('#myAlert').empty();
        $('#myAlert').append('<a onclick="closeBtn()" class="close" id="crossBtn" href="#">x</a>Invalid URL: Server url is invalid');
        $('#myAlert').show();
        return false;
    }
    
    if(!document.getElementById("Path").value.match(/^[\u0020-\u007e]+$/))          
    {
        $('#myAlert').empty();
        $('#myAlert').append('<a onclick="closeBtn()" class="close" id="crossBtn" href="#">x</a>Invalid URL: Server path is invalid');
        $('#myAlert').show();
        return false;
    }
   
   return true;
}
//-->
</script>
</%def>
