## Copyright (c) 2016 by Adaptive Computing Enterprises, Inc. All Rights Reserved.

<%! from django.utils.translation import ugettext as _ %>

<%inherit file="base.mako" />
<%namespace name="base" file="base.mako" />
<%def name="title()">${_("Viewpoint Configuration")}</%def>
<%def name="head_tags()"></%def>
<%def name="jquery_tags()">
<script type="text/JavaScript">
  $(document).ready(function() {
	var h = document.getElementById("page-content").offsetHeight;
	$("#side").height(h);

	var str = location.href.toLowerCase();
	$('#leftnav li a').each(function() {
	  if(str.indexOf('role') > -1) {
	    $('li.active1').removeClass('active1');
	    $("#roles").parent().addClass('active1');
	  } else if(str.indexOf('principal') > -1) {
	    $('li.active1').removeClass('active1');
	    $("#principals").parent().addClass('active1');
	  } else if (str.indexOf('fastx-configuration') > -1) {
	    $('li.active1').removeClass('active1');
	    $("#fastx-config").parent().addClass('active1');
	  }
	});

	$('.section-header').on('click', '#crossBtn', function() {
      $('#myAlert').hide();
      $('#successAlert').hide();
    });

    function isValidForm() {
      var url = $("#url").val();
      if(!url) {
        showAlert('Server URL can not be empty');
        return false;
	  }
	  var username = $('#username').val();
	  if(!username) {
	    showAlert('Username can not be empty');
        return false;
	  }
	  var pass = $('#password').val();
	  if(!pass) {
	    showAlert('Password can not be empty');
        return false;
	  }
	  return true;
    }

    function showAlert(message) {
      $('#myAlert').empty();
      $('#myAlert').append('<a class="close" id="crossBtn" href="#">x</a>' + message);
      $('#myAlert').show();
    }

    function getURL() {
      var url = $('#url').val();
      if (url.slice(-1) == '/') {
        return url.slice(0, -1);
      }
      return url;
    }

	function postForm(action) {
	  var formData = {
        "url": getURL(),
        "username": $('#username').val(),
        "password": $('#password').val(),
        "verifySSL": !$('#trustSelfSigned').is(':checked')
    };

    var alertTimer = setTimeout(function() {
      showAlert('Server is not responding. Maybe it is a connection problem. You can wait more or try again later.')
    }, 30000);

    $.post('/fastx-configuration/?action=' + action, formData, function(result) {
          clearTimeout(alertTimer);
          successCase(result);
          afterSentingForm();
        })
        .fail(function(response) {
          clearTimeout(alertTimer);
          if (response.status == 0) {
            response.responseText = 'Could not connect';
          }
          if (response.status == 403) {
            setTimeout('window.location = "/logout?expired=1"', 500);
            return;
          }
          failCase(response);
          afterSentingForm();
        });
  }

	function successCase(message) {
	  $('#myAlert').hide();
      $('#successAlert').empty();
      $('#successAlert').html('<a class="close" id="crossBtn" href="#">&times;</a>');
      $('#successAlert').append(message);
      $('#successAlert').show();
      $("#testpreload").hide();
      isDirtyPlaceholder = false;
	}

    function failCase(response) {
      $('#successAlert').empty().hide();
      var message = /.*<!DOCTYPE html>.*/.test(response.responseText) ? response.statusText : response.responseText;
      showAlert(message);
      $("#testpreload").hide();
      $("#urlverify").hide();
      isDirtyPlaceholder = false;
    }

	function beforeSendForm() {
	  $('#fastx-form input, #fastx-form button').prop('disabled', true);
	  $("#testpreload").show();
  	  $("#testpreload").addClass("configuration-preloader");
	}

	function afterSentingForm() {
	  $('#fastx-form input, #fastx-form button').prop('disabled', false);
	  $("#testpreload").hide();
  	  $("#testpreload").removeClass("configuration-preloader");
	}

    $('#submit-btn').click(function() {
      if (isValidForm()) {
        beforeSendForm();
	    postForm('save');
	  }
    });

    $('#test-btn').click(function() {
      if (isValidForm()) {
        beforeSendForm();
	    postForm('test');
	  }
    });
  });
</script>
</%def>
<%def name="main_content()">
	<div class="row configuration">
	<%include file="leftpanel.mako"/>

		<div class="col-xs-8">
			<div class="col-xs-12 section-header search-filter-section">
				
				<div>
						<div class="alert alert-danger" id="myAlert" style="display:none">				
						</div>
						<div class="alert alert-success" id="successAlert" style="display:none">                
                        </div>								
				</div>
				
			</div>
			<div class="clearfix"></div>

			<div class="col-xs-12 search-filter-section">

				<form id="fastx-form" class="form-horizontal" action="/fastx-configuration/" method="POST">
					<h1>Remote Visualization Configuration</h1>
					<div class="clearfix"></div>
					<span class="control-group">
						<label for="url" class="col-xs-2 text-left long-label">Gateway Server</label>
						<div class="col-xs-8">
							<input type="text" class="form-control" id="url" name="url"
								   title="Url to the FastX remote server e.g. https://<your_fastx_gateway>:3443"
								   value="${ fileData['FASTX']['URL']  }" required />
							<div id="testpreload" style="display:none;"></div>
							<span id="urlverify" class="glyphicon glyphicon-ok-circle valid" style="display:none;"></span>
							<span id="lblLegitimate" style="display:none;"></span>
						</div>
						<div class="col-xs-2"></div>
					</span>
					<div class="clearfix"></div>
					<span class="control-group">
						<label for="username" class="col-xs-2 text-left long-label">Username</label>
						<div class="col-xs-8">
							<input type="text" class="form-control" id="username" name="username"
								   title="Username to login on FastX" value="${ fileData['FASTX']['USERNAME']  }" required />
						</div>
						<div class="col-xs-2"></div>
					</span>
					<div class="clearfix"></div>
					<div class="clearfix"></div>
					<span class="control-group">
						<label for="password" class="col-xs-2 text-left long-label">Password</label>
						<div class="col-xs-8">
							<input type="password" class="form-control" id="password" name="password"
								   title="Password to login on FastX" value="${ fileData['FASTX']['PASSWORD']  }" required/>
						</div>
						<div class="col-xs-2"></div>
					</span>
					<div class="clearfix"></div>
					<div class="clearfix"></div>
					<span class="control-group">
						<label for="trustSelfSigned" class="col-xs-2 text-left long-label">Trust Self Signed</label>
						<div class="col-xs-8 verify-ssl-container">
                <input type="checkbox"
                    title="Activate this option if you setup the Remote Visualization services using self signed certificates"
                    class="form-control" id="trustSelfSigned" name="trustSelfSigned"
                    {{if fileData['FASTX']['CLIENT_VERIFY_SSL']:}}
                     checked
                    {{endif}}
                />
						</div>
					</span>
					<div class="clearfix"></div>
                    <div class="col-xs-12 height">
                        <button type="button" class="btn btn-primary cnf-button" id="test-btn">Test</button>
                        <button type="button" class="btn btn-primary cnf-button" id="submit-btn">Save</button>
                    </div>
				</form>
			</div>
		</div>
    </div>
</%def>
<%def name="end_script()">

</%def>
