## Copyright (c) 2016 by Adaptive Computing Enterprises, Inc. All Rights Reserved.

<%! from django.utils.translation import ugettext as _ %>

<%inherit file="base.mako" />
<%namespace name="base" file="base.mako" />
<%def name="title()">${_("Viewpoint Configuration")}</%def>
<%def name="head_tags()"></%def>
<%def name="jquery_tags()">
  <script src="../static/modal/js/modal.js" type="text/javascript"></script>
  <script src="../static/api/js/api.js" type="text/javascript"></script>
  <script src="../static/api/js/loader.js" type="text/javascript"></script>
  <script type="text/JavaScript">
    $(document).ready(function() {
      var h = document.getElementById("page-content").offsetHeight;
      $("#side").height(h);

      var str = location.href.toLowerCase();
      $('#leftnav li a').each(function() {
        if (str.indexOf('role') > -1) {
          $('li.active1').removeClass('active1');
          $("#roles").parent().addClass('active1');
        } else if (str.indexOf('principal') > -1) {
          $('li.active1').removeClass('active1');
          $("#principals").parent().addClass('active1');
        } else if (str.indexOf('fastx-configuration') > -1) {
          $('li.active1').removeClass('active1');
          $("#fastx-config").parent().addClass('active1');
        } else if (str.indexOf('licensed-features') > -1) {
          $('li.active1').removeClass('active1');
          $("#licenses").parent().addClass('active1');
        }
      });

      var date = moment.utc($('.expiration-date').text().replace(' UTC', '')).toDate();
      if (moment(date).isValid()) {
        $('.expiration-date').text(moment(date).format('YYYY-MM-DD HH:mm:ss'));
      }

      var path = $('.license-file').text();
      if (path) {
        var api = new Viewpoint.API();
        var fullPath = '/api/fsobject/' + path;
        api.get(encodeURI(fullPath)).done(function(data) {
          if (data.object_type == 'FILE') {
            $('.license-file')
                .append(
                    $('<a></a>')
                        .addClass('path-link')
                        .attr('title', 'Go to file preview')
                        .attr('href', '#')
                        .text('...')
                        .show()
                        .click(function(e) {
                          e.preventDefault();
                          $.viewpoint.modal.show('/file-viewer/', {
                            title: 'File Viewer',
                            path: path
                          }).done(function(payload) {
                          });
                        })
                )
          }
        });
      }

      $('#show-errors').click(function() {
        if ($('#show-errors span').hasClass('glyphicon-chevron-right')) {
          $('#show-errors span').removeClass('glyphicon-chevron-right');
          $('#show-errors span').addClass('glyphicon-chevron-down');
          $('.license-errors-title').addClass('expanded');
          $('.license-errors-bar #errors').show();
        } else {
          $('#show-errors span').removeClass('glyphicon-chevron-down');
          $('#show-errors span').toggleClass('glyphicon-chevron-right');
          $('.license-errors-title').removeClass('expanded');
          $('.license-errors-bar #errors').hide();
        }
      });

      var $diagnosticsTrigger = $('#show-diagnostic');
      $diagnosticsTrigger.click(function() {
        if ($diagnosticsTrigger.find('span').hasClass('glyphicon-chevron-right')) {
          $diagnosticsTrigger.find('span').removeClass('glyphicon-chevron-right');
          $diagnosticsTrigger.find('span').addClass('glyphicon-chevron-down');
          $('.license-errors-title').addClass('expanded');
          $('.license-errors-bar #diagnostic-messages').show();
        } else {
          $diagnosticsTrigger.find('span').removeClass('glyphicon-chevron-down');
          $diagnosticsTrigger.find('span').toggleClass('glyphicon-chevron-right');
          $('.license-errors-title').removeClass('expanded');
          $('.license-errors-bar #diagnostic-messages').hide();
        }
      });

      $('input[name=licenseType]').change(function() {
        $('#remote-license-server-url').prop('disabled', this.value == 'local');
        $('#license-text').prop('disabled', this.value == 'remote');
      });

      $('#vp-license-file-input').change(function(e) {
        var files = e.target.files;
        var $uploadBtn = $('#save-license-btn');
        if (1 != files.length) {
          $uploadBtn.prop( "disabled", true );
          return;
        }
        $('#vp-license-file-name').text(files[0].name);
        $uploadBtn.prop("disabled", false);
      });
    });
  </script>
</%def>
<%def name="main_content()">
  <div class="row configuration">
    <%include file="leftpanel.mako"/>

    <div class="col-xs-8">
      <div class="col-xs-12 license-info">
        %if messages:
          %for message in messages:
          <div class="alert alert-${message.tags} alert-dismissible" role="alert">
            <button type="button" class="close" data-dismiss="alert"><span>&times;</span></button>
            ${message}
          </div>
          %endfor

        %endif
        <ul class="nav nav-tabs license-tabs" role="tablist">
          <li role="presentation" class="configuration-license-tab active">
            <a href="#viewpoint-license-tab" role="tab" data-toggle="tab">
              Viewpoint License
            </a>
          </li>
        %if not user.is_staff:
          <li role="presentation" class="configuration-license-tab">
            <a href="#moab-license-tab" role="tab" data-toggle="tab">
              Moab License
            </a>
          </li>
        %endif
        </ul>

        <div class="tab-content">
          <div role="tabpanel" class="tab-pane" id="moab-license-tab">
            %if license_info:
              <dl class="dl-horizontal">
                <dt>Expiration Date</dt>
                <dd class="expiration-date">${license_info.get('expirationDate', 'N/A') or 'N/A'}</dd>
                <dt>Licensed Host Name</dt>
                <dd>${license_info.get('host', 'N/A') or 'N/A'}</dd>

                %if license_info.get('processors', 0) > 0:
                    <dt>Licensed Processors</dt>
                    <dd>${license_info.get('processors', 'N/A') or 'N/A'}</dd>
                %endif

                %if license_info.get('sockets', 0) > 0:
                    <dt>Licensed Sockets</dt>
                    <dd>${license_info.get('sockets', 'N/A') or 'N/A'}</dd>
                %endif

                %if license_info.get('path', None):
                    <dt>Moab License File</dt>
                    <dd class="license-file"><span>${license_info.get('path', 'N/A') or 'N/A'}</span></dd>
                %endif
              </dl>
            %endif
            <h3>Moab Licensed Features</h3>
            <table id="features-table" class="table table-hover table-bordered">
              <thead>
              <tr>
                <th>Product License</th>
                <th>Description</th>
                <th>Status</th>
              </tr>
              </thead>
              <tbody>
                %if license_info and 'features' in license_info and license_info['features']:
                  %for feature in license_info['features']:
                    %if feature.get('enabled', None):
                        <tr>
                          <td>
                            %if feature.get('link', None):
                              <a href="${feature['link']}" title="This feature expires on ${feature['expirationDate']}">${feature.get('name', 'N/A')}</a>
                            %else:
                              <span title="This feature expires on ${feature['expirationDate']}">${feature.get('name', 'N/A')}</span>
                            %endif
                          </td>
                          <td><span title="This feature expires on ${feature['expirationDate']}">${feature.get('description', 'N/A')}</span></td>
                          <td>
                            <span class="glyphicon glyphicon-ok-circle enabled" title="Enabled"></span>
                          </td>
                        </tr>
                    %else:
                        <tr>
                          <td>
                            %if feature.get('link', None):
                              <a href="${feature['link']}">${feature.get('name', 'N/A')}</a>
                            %else:
                              <span">${feature.get('name', 'N/A')}</span>
                            %endif
                          </td>
                          <td><span>${feature.get('description', 'N/A')}</span></td>
                          <td>
                            <span class="glyphicon glyphicon-remove-circle danger" title="Disabled"></span>
                          </td>
                        </tr>
                    %endif
                  %endfor
                %else:
                  <tr>
                    <td colspan="3" style="text-align:center;">
                      No information about features available at this time
                    </td>
                  </tr>
                %endif
              </tbody>
            </table>

            <div class="license-errors-bar">
              <div class="license-errors-title">
                <a id="show-errors" role="button" data-toggle="collapse" href="#errors">
                  <span class="glyphicon glyphicon-chevron-right"></span>
                  More information
                </a>
              </div>
              <div id="errors" class="navbar navbar-default errors-body" role="tabpanel">
                <div class="errors-container">
                  %if license_info and 'errors' in license_info and license_info['errors']:
                    <ul>
                      %for error in license_info['errors']:
                        %if error['type'] == 'warning':
                          <li><span class="glyphicon glyphicon-warning-sign warning"></span>${error['message'] | n}</li>
                        %elif error['type'] == 'error':
                          <li><span class="glyphicon glyphicon-remove-circle danger"></span>${error['message'] | n}</li>
                        %else:
                          <li>${error['message'] | n}</li>
                        %endif
                      %endfor
                    </ul>
                  %else:
                    No more information available at this time
                  %endif
                </div>
              </div>
            </div>
          </div>

          <div role="tabpanel" class="tab-pane active" id="viewpoint-license-tab">
            <h3>License</h3>
            <form action="" method="post" enctype="multipart/form-data">
            <div>
                <label class="btn btn-default" for="vp-license-file-input">
                <input id="vp-license-file-input" type="file" name="file" style="display:none"/>
                <span>Browse</span>
              </label>
              <span id="vp-license-file-name">No file chosen</span>
              <div class="save-license-btn-container">
                <button id="save-license-btn" class="btn btn-primary cnf-button api" type="submit" disabled>Upload</button>
              </div>
            </div>
            </form>
            %if __features__ and __features__.rlm:
              <div id="vp-host-id"><b>Viewpoint Host ID:</b> ${__features__.rlm.hostid}</div>
            %endif
            %if license_path:
            <div>
              <span id="license-path"><b>License path: </b>${license_path}</span>
              %if license_content:
                <button type="button" id="show-license" class="btn btn-primary" data-toggle="modal" data-target="#license-preview-modal">Preview</button>
              %endif
            </div>
            %endif
            <h3>Viewpoint Licensed Features</h3>
            <table id="features-table" class="table table-hover table-bordered">
              <thead>
              <tr>
                <th>Product License</th>
                <th>Description</th>
                <th>Status</th>
              </tr>
              </thead>
              <tbody>
                %if __features__:
                  <tr>
                    <td>
                      <span
                          %if __features__.vp_admin.enabled:
                            title="This feature expires on ${__features__.vp_admin.license.exp}"
                          %endif
                      >Admin Functionality</span>
                    </td>
                    <td>
                      <span
                          %if __features__.vp_admin.enabled:
                            title="This feature expires on ${__features__.vp_admin.license.exp}"
                          %endif
                      >
                      Enables admin functionality in Viewpoint allowing admins to manage their Moab systems directly from Viewpoint.
                      </span>
                    </td>
                    <td>
                      %if __features__.vp_admin.enabled:
                        <span class="glyphicon glyphicon-ok-circle enabled" title="Enabled"></span>
                      %else:
                        <span class="glyphicon glyphicon-remove-circle danger" title="Disabled"></span>
                      %endif
                    </td>
                  </tr>

                  <tr>
                    <td>
                      <span
                          %if __features__.vp_user.enabled:
                            title="This feature expires on ${__features__.vp_user.license.exp}"
                          %endif
                      >
                      User Functionality</span>
                    </td>
                    <td>
                      <span
                          %if __features__.vp_user.enabled:
                            title="This feature expires on ${__features__.vp_user.license.exp}"
                          %endif
                      >
                      Enables user-centric functionality in Viewpoint like managing application templates and jobs.</span>
                    </td>
                    <td>
                      %if __features__.vp_user.enabled:
                        <span class="glyphicon glyphicon-ok-circle enabled" title="Enabled"></span>
                      %else:
                        <span class="glyphicon glyphicon-remove-circle danger" title="Disabled"></span>
                      %endif
                    </td>
                  </tr>

                  <tr>
                    <td>
                      <span
                          %if __features__.vp_nitro.enabled:
                            title="This feature expires on ${__features__.vp_nitro.license.exp}"
                          %endif
                      >
                      Nitro Support</span>
                    </td>
                    <td>
                      <span
                          %if __features__.vp_nitro.enabled:
                            title="This feature expires on ${__features__.vp_nitro.license.exp}"
                          %endif
                      >
                      Enables Nitro support in Viewpoint, allowing admins and users to manage Nitro applications directly from Viewpoint.
                      </span>
                    </td>
                    <td>
                      %if __features__.vp_nitro.enabled:
                        <span class="glyphicon glyphicon-ok-circle enabled" title="Enabled"></span>
                      %else:
                        <span class="glyphicon glyphicon-remove-circle danger" title="Disabled"></span>
                      %endif
                    </td>
                  </tr>

                  <tr>
                    <td>
                      <span
                          %if __features__.vp_remote_viz.enabled:
                            title="This feature expires on ${__features__.vp_remote_viz.license.exp}"
                          %endif
                      >
                      Remote Visualization Support
                      </span>
                    </td>
                    <td>
                      <span
                          %if __features__.vp_remote_viz.enabled:
                            title="This feature expires on ${__features__.vp_remote_viz.license.exp}"
                          %endif
                      >
                      Enables Remote Visualization in Viewpoint, allowing users to manage their remote sessions directly from the browser
                      </span>
                    </td>
                    <td>
                      %if __features__.vp_remote_viz.enabled:
                        <span class="glyphicon glyphicon-ok-circle enabled" title="Enabled"></span>
                      %else:
                        <span class="glyphicon glyphicon-remove-circle danger" title="Disabled"></span>
                      %endif
                    </td>
                  </tr>
                %else:
                  <tr>
                    <td colspan="3" style="text-align:center;">
                      No information about license features available at this time
                    </td>
                  </tr>
                %endif
              </tbody>
            </table>
            <div class="license-errors-bar">
              <div class="license-errors-title">
                <a id="show-diagnostic" role="button" data-toggle="collapse" href="#diagnostic-messages">
                  <span class="glyphicon glyphicon-chevron-right"></span>
                  More Information
                </a>
              </div>
              <div id="diagnostic-messages" class="navbar navbar-default errors-body" role="tabpanel">
                <div class="errors-container">
                  %if __features__:
                    %if license_error:
                      <span class="help-block">${license_error}</span>
                    %else:
                      %if any(__features__) and not all(__features__):
                        <span class="help-block">More features can be licensed by contacting Adaptive Computing Enterprises.</span>
                      %else:
                        %if not any(__features__):
                           <span class="help-block">Please contact sales at Adaptive Computing Enterprises to start your Viewpoint evaluation today.</span>
                        %endif
                      %endif
                    %endif
                    <ul>
                      %if __features__.vp_admin.enabled:
                        <li>Admin Functionality: this license will expire on ${__features__.vp_admin.license.exp}</li>
                      %endif
                      %if __features__.vp_user.enabled:
                        <li>User Functionality: this license will expire on ${__features__.vp_user.license.exp}</li>
                      %endif
                      %if __features__.vp_nitro.enabled:
                        <li>Nitro Support: this license will expire on ${__features__.vp_nitro.license.exp}</li>
                      %endif
                      %if __features__.vp_remote_viz.enabled:
                        <li>Remote Visualization Support: this license will expire on ${__features__.vp_remote_viz.license.exp}</li>
                      %endif
                    </ul>
                  %else:
                    No more information available at this time
                  %endif
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
    <div id="license-preview-modal" class="modal fade" tabindex="-1" role="dialog">
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <h4 class="modal-title">Preview</h4>
          </div>
          <div class="modal-body">
            <textarea readonly>${license_content}</textarea>
          </div>
          <div class="modal-footer">
            <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
          </div>
        </div>
      </div>
    </div>
  </div>
</%def>
<%def name="end_script()">

</%def>
