## Copyright (c) 2016 by Adaptive Computing Enterprises, Inc. All Rights Reserved.

<%! from django.utils.translation import ugettext as _ %>
<%! from frontend_utils.utils import capitalize_first_letter_filter as first_upper %>
<%inherit file="base.mako" />

<%def name="title()">${_("Viewpoint Principals")}</%def>

<%def name="head_tags()">

</%def>

<%def name="jquery_tags()">
<script src="/static/legacy/js/configuration.js" type="text/javascript"></script>
<script type="text/JavaScript">
  function setLdapTooltip() {
    var title = '';
    if ($('.user-type').val() == 'LDAPGROUP') {
      title = 'e.g. cn=Engineering,ou=groups,dc=testldap,dc=ac';
    } else if ($('.user-type').val() == 'LDAPOU') {
      title = 'e.g. ou=Engineering,ou=people,dc=testldap,dc=ac';
    } else if ($('.user-type').val() == 'LDAP') {
      title = 'e.g. username';
    }
    $('.user-type').attr('title', title);
  }

	$(document).ready(function() {
    var autoheight = document.getElementById("page-content").offsetHeight;
    $("#side").height(autoheight);

    createDirtyUnloadListener("input.form-control, textarea.form-control, input[name=roleslist], select[name=groupusertype]", "${_("You have unsaved changes that will be lost.")}");
    disablecopypaste();
    $(document).on('change', '.user-type', setLdapTooltip);
    setLdapTooltip();
	});

	function addrow_ldap() {
		$('#grouptable .has-error').remove();
		var rowCount = $('#grouptable tr').length;
		typecolumn = "<select id='groupusertype"+rowCount+"' class='form-control user-type' name='groupusertype'>";
		typecolumn += "<option value='LDAPGROUP' title='e.g. cn=Engineering,ou=groups,dc=testldap,dc=ac'>LDAP Group</option>";
		typecolumn += "<option value='LDAPOU' title='e.g. ou=Engineering,ou=people,dc=testldap,dc=ac'>LDAP Organizational Unit</option>";
		typecolumn += "<option value='LDAP' title='e.g. username'>LDAP Username</option>";
		typecolumn += "</select>";

		row = "<tr id='"+rowCount+"'>";
		row += "<td><input type='text' class='form-control' id='groupuser"+rowCount+"' maxlength='255' name='groupuser'></td>";
		row += "<td>"+typecolumn+"</td>";
		row += "<td>";
		//row += "<a href='#'><span class='glyphicon glyphicon-check'></span></a>";

		row += "<a href='JavaScript:deleteRow("+rowCount+")' class='link' ><span class='glyphicon glyphicon-remove' id='removeuser"+rowCount+"'></span></a>";

		row += "</td>";
		row += "</tr>";
		$("#grouptable").append(row);
		$("#grouptable input.form-control").first().trigger("change");
    setLdapTooltip();
	}

	function addrow_pam(){
		var rowCount = $('#grouptable tr').length;		
		typecolumn = "<select id='groupusertype"+rowCount+"' name='groupusertype'>";
		typecolumn += "<option value='PAMGROUP'>PAM Group</option>";
		typecolumn += "<option value='PAM'>PAM Username</option>";
		typecolumn += "</select>";
		
		row = "<tr id='"+rowCount+"'>";
		row += "<td><input type='text' class='form-control' id='groupuser"+rowCount+"' name='groupuser'></td>";
		row += "<td>"+typecolumn+"</td>";
		row += "<td>";
		//row += "<a href='#'><span class='glyphicon glyphicon-check'></span></a>";
		row += "<a href='JavaScript:deleteRow("+rowCount+")' class='link' ><span class='glyphicon glyphicon-remove' id='removeuser"+rowCount+"'></span></a>";\
		row += "</td>";
		row += "</tr>";
		$("#grouptable").append(row);
		$("#grouptable input.form-control").first().trigger("change");
	}
	
	function deleteRow(id){
		$("#" + id + " input.form-control").trigger("change");
		$("#"+id).remove();
	}
	
</script>

</%def>
<%def name="main_content()">
	<div class="row configuration">
	<%include file="leftpanel.mako"/>
		<div class="row principle">
			<div class="col-xs-8 pull-left">
				<div class="text-left col-xs-12">
					<h2>${_("Principals")}</h2>
					${_("A principal's resources and access is based on the role(s) they are granted.  Each role has a list of permissions that can be configured in the Roles tab")}.
				</div>
				<div class="col-xs-12">				
					%if messages:						   
						%if status == "success":						  
                             <div class="alert alert-success" id="alertp">
                            <a class="close" data-dismiss="alert">&times;</a>
                                ${ messages | first_upper }
                            </div>                                                       
                        %else:
                               <div class="alert alert-danger" id="alertp">
                                <a class="close" data-dismiss="alert">&times;</a>
                                ${ messages | first_upper }
                                </div>
                        %endif    
						
					%endif
					
					<form id="principal" class="management" method="post" action="/principal/" onsubmit="return validateForm()" name="principalform">

				
					<input type="hidden" id="principalId" name="principalId" maxlength="255" value="${ principalId  }">

						<div id="name-group" class="col-xs-4 form-group">
							<span class="control-group">
								<label for="Name" class="col-xs-11 role">${_("Name")}:</label>
									<div class="clearfix">
									</div>
								<div class="col-xs-12">														
								%if principalId:
									  <div class="col-xs-12" id="principalNameContainer">
									  <input type="hidden" class="form-control" id="name" name="name" maxlength="255" value="${ name  }" />
									  ${ name  }									  
									  </div>
								%else:
									<input type="text" class="form-control" id="name" name="name" maxlength="255" value="${ name  }" />
								%endif
								

								</div>
							</span>
						</div>
						<div class="col-xs-6">
							<span class="control-group">
								<label for="Description" class="col-xs-11 role">${_("Description")}:</label>
									<div class="clearfix">
									</div>
									<div class="col-xs-9">
										<textarea id="Description" name="description" class="form-control resize" maxlength="100">${ description }</textarea>
									</div>
							</span>
						</div>
						<div class="clearfix"></div>
						<div class="col-xs-12">
							${_("Roles")}
								<table class="table table-bordered" id="role-table">
									<tbody>
										%if status_code_roles == 200:
											%for count,roles in enumerate(rolelist) :
												%for id in roles:										
												<tr>
													<td><label id="${ ''.join(roles[id]['name'].split(' '))  }">${ roles[id]['name']  }</label></td>
													%if roles[id]['id'] in existing_roles_list:
														<td><input type="checkbox" id="${ ''.join(roles[id]['name'].split(' '))  }CB" name="roleslist" value = "${ roles[id]['name']  }"  checked  /></td>
													% else:
														<td><input type="checkbox" name="roleslist" id="${ ''.join(roles[id]['name'].split(' '))  }CB" class="page1" value="${ roles[id]['name']  }"  /></td>
													% endif
												</tr>
												%endfor
											%endfor
										%else:
											<div class="alert alert-success">${ rolelist  }</div>
										%endif
									</tbody>
								</table>
							</div>
					
   <div class="clearfix"></div>
   
   <table class="table table-bordered width pull-left" id="grouptable">
				<thead>
					<tr id="0">
						<th class="bg">${_("Principal Entity")}</th>
            <th class="bg" colspan="2">Type</th>

          </tr>
        </thead>
        <tbody>
		
		%for num , group in enumerate(groupslist):
          <tr id ="${ num + 1 }">
		  
              <td><input type="text" class="form-control" id="groupuser${ num + 1  }" name="groupuser" maxlength="255" value= "${ group['name']  }" /></td>
              <td>
			  <select id="groupusertype${ num + 1  }" class="form-control user-type" name="groupusertype">
				%if LDAP_Entity == "true" and PAM_Entity == "false":
					<option value="LDAPGROUP" title="e.g. cn=Engineering,ou=groups,dc=testldap,dc=ac" ${'selected' if group['type'] == "LDAPGROUP"  else ''  }>LDAP Group</option>
					<option value="LDAPOU" title="e.g. ou=Engineering,ou=people,dc=testldap,dc=ac" ${'selected' if group['type'] == "LDAPOU" else ''  }>LDAP Organizational Unit</option>
					<option value="LDAP" title="e.g. username" ${'selected' if group['type'] == "LDAP" else ''  }>LDAP Username</option>
				%elif PAM_Entity == "true" and LDAP_Entity == "false":
					<option value="PAMGROUP" ${'selected' if group['type'] == "PAMGROUP" else ''  }>PAM Group</option>
					<option value="PAM" ${'selected' if group['type'] == "PAM" else ''  }>PAM Username</option>
				%else:
					<option value="LDAPGROUP" title="e.g. cn=Engineering,ou=groups,dc=testldap,dc=ac" ${'selected' if group['type'] == "LDAPGROUP"  else ''  }>LDAP Group</option>
					<option value="LDAPOU" title="e.g. ou=Engineering,ou=people,dc=testldap,dc=ac" ${'selected' if group['type'] == "LDAPOU" else ''  }>LDAP Organizational Unit</option>
					<option value="LDAP" title="e.g. username" ${'selected' if group['type'] == "LDAP" else ''  }>LDAP Username</option>
				%endif
			  </select>
			  </td>
              <td><a href="JavaScript:deleteRow('${ num + 1  }')" class="link" title="Delete"><span class="glyphicon glyphicon-remove" id="removeuser${ num + 1  }"></span></a></td>
          </tr>
		%endfor
	
		</tbody>
      </table>
		<div class="col-xs-4">
			<div class="addbut col-xs-7" id="principalPlusIcon">
				%if LDAP_Entity == "true" and PAM_Entity == "false":
					<span class="glyphicon glyphicon-plus pull-left" id="icon1" onclick="addrow_ldap()" style="cursor:pointer;" title="Add"></span>					
				%elif PAM_Entity == "true" and LDAP_Entity == "false":
					<span class="glyphicon glyphicon-plus pull-left" id="icon2" onclick="addrow_pam()" style="cursor:pointer;" title="Add"></span>					
				%else:
					<span class="glyphicon glyphicon-plus pull-left" id="icon3" onclick="addrow_ldap()" style="cursor:pointer;" title="Add"></span>					
				%endif
				</div>
			</div>
		</div>
		<div class="col-xs-12">
			<div class="row">
				<div class="col-xs-2">
				</div>
				<div class="col-xs-2">         
					<button type="button" class="btn btn-primary" style="margin-right: 10px" id="principalCancelBtn">${_("Cancel")}</button>
				</div>	
				<div class="col-xs-2"> 		
					<button type="submit" class="btn btn-primary" style="margin-right: 10px" name="action" value="Done" id="principalDoneBtn">${_("Done")}</button>
				</div>	
				<div class="col-xs-2">
					<button type="submit" class="btn btn-primary" name="action" value="Apply" id="principalApplyBtn">${_("Apply")}</button>
				</div>
			</div>
		</div>
   </form>
</div>
</div>
</div>
</%def>
  <%def name="end_script()">
  <script type="text/javascript">
$(function(){
   $(".close").click(function(){
      $("#alertp").alert();
   });
});

function validateForm() {
  var isValid = true;
  var $form = $('#principal');
  var $name = $form.find('#name');
  var $nameGroup = $form.find('#name-group');
  var $roleTable = $form.find('#role-table');
  var $groupTable = $form.find('#grouptable');

  $nameGroup
	  .removeClass('has-error')
	  .find('.help-block').remove();
  $roleTable.find('.has-error').remove();
  $groupTable.find('.has-error').remove();

  if (!($name.val())) {
	$nameGroup.addClass('has-error').append(
		$('<span></span>').addClass('help-block').text('Please enter principal name')
	);
    document.principalform.name.focus();
    isValid = false;
  }

  var $selectedRoles = $roleTable.find('input:checked');

  if ($selectedRoles.length == 0) {
    $roleTable.append(
        $('<tr></tr>')
            .addClass('has-error')
            .append(
            $('<td colspan="2" style="display: table-cell;"></td>')
				.addClass('help-block')
                .text('Please choose roles')
        )
    );
    isValid = false;
  }

  var $emptyCredentials = $groupTable.find('input:text')
	  .filter(function() { return !$(this).val(); });
  var $credentials = $groupTable.find('input:text');

  if ($credentials.length == 0 || $emptyCredentials.length > 0) {
	$groupTable.append(
        $('<tr></tr>')
            .addClass('has-error')
            .append(
            $('<td colspan="3" style="display: table-cell;"></td>')
				.addClass('help-block')
                .text('Please enter users and(or) groups')
        )
    );
	isValid = false;
  }

  isDirtyPlaceholder = false;
  return isValid;
}

	$("#name").on("keydown", function (e) {
		return e.which !== 32;
	});
	
$("#principalCancelBtn").click(function() {
	isDirtyPlaceholder = false;
document.location.href="/principallist/?tab=configuration";
$("#mainNav li").addClass("active1");
});
   </script>
  </%def>
