## Copyright (c) 2016 by Adaptive Computing Enterprises, Inc. All Rights Reserved.

<%! from django.utils.translation import ugettext as _ %>
<%! from frontend_utils.utils import capitalize_first_letter_filter as first_upper %>
<%inherit file="base.mako" />

<%def name="title()">${_("Viewpoint Principal management")}</%def>

<%def name="head_tags()"></%def>

<%def name="jquery_tags()">
<script src="/static/legacy/js/configuration.js" type="text/javascript"></script>  
<script type="text/javascript">
		$(document).ready(function(){
			$('#principallistcontainer.preloader').show();
			$.ajax({
				url:'/principallist_grid/',
				type:'GET',
				data:{max:10, offset:1},
				success:function(result){
					if (/^\s*<!DOCTYPE html>/.test(result)) {
                        $('#principallistcontainer').html('500 Internal Server Error.');
                        return;
                    }
					$('#principallistcontainer.preloader').hide();
					$('#principallistcontainer').html(result);
					 var autoheight = document.getElementById("page-content").offsetHeight;
					 $("#side").height(autoheight);
			},
			error: function(jqXHR, textStatus, errorThrown){      
			 gridconfigerror(jqXHR, textStatus, errorThrown);
			      //$('#loaderDiv.preloader').hide();
			 }
		});
	});
</script>
<script type="text/javascript">
	function editPrincipal(id){
		window.location.href = "/principal/?principalId="+id+"&tab=configuration";
	}

	function deletePrincipal(id,name) {
		// Added for IRIS-632
		var nameLength = 150;
		var platForm, userAgent;
		platForm = navigator.platform;
		userAgent = navigator.userAgent;
		if (platForm == 'Linux x86_64' || platForm == 'Win32' || platForm == 'MacIntel') {			
			if (userAgent.toLowerCase().indexOf("firefox") >= 0) {
				if(name.length > nameLength) {		
					name = name.substring(0, 50) + '\n' + name.substring(50, 100) + '\n' + name.substring(210);
				}	
			}
		}
		// Added for IRIS-632
		
		// Disable default filtering for confirmation alert java script localization
		data = confirm("${_("Are you sure you want to delete principal '{0}'?") | n,decode.utf8 }".replace("{0}", name));
		if(data){			
			
			$('#loaderDiv').show();
			$('#loaderDiv').html('<div id="err preloader" class="preloader" style="left:65%"></div>');
				
			$.ajax({
				url:'/deleteprincipal/',
				type:'GET',
				data:{principalId:id, name:name},
				cache:false,			
				success:function(result){
				$('#error').html('<a href="#" id="crossBtn" class="close" onClick="closeBtn()">&times;</a><div id="errpreloader" class="preloader"></div>');			
					if(result == "True"){
						$('#loaderDiv').hide();
						$('#myAlert').hide();
						$('#alertp').hide();
						$('#error').show();
						$('#error').addClass("alert alert-success");
						$('#error').append("${_("Principal '{0}' was deleted successfully")}".replace("{0}", name));
						$('#errpreloader').hide();			
						refreshContentPrincipal('principallistrefresh')
											
					}
				},
				error: function(jqXHR, textStatus, errorThrown){
				gridconfigerror(jqXHR, textStatus, errorThrown);
				$('#loaderDiv').hide();
				}			
			});
		}				
	}	
</script>
</%def>
<%def name="main_content()">
<div class="row configuration">
<%include file="leftpanel.mako"/>
	<div id="mainContent" class="row rolesmanagement">
		<div class="col-xs-8 pull-left padle15">
			<div class="configuration-header-bar">
				<h2>Principal Management</h2>
        <div title="Refresh" class="refresh-button" id="principallistrefresh" onClick="refreshPrincipalList('principallistrefresh');">
          <span class="glyphicon glyphicon-refresh"></span>
        </div>
			</div>
				<form id="rolemanagement">
				%if messages:				    
					%if status == "success":                          
                             <div class="alert alert-success" id="alertp">
                            <a class="close" data-dismiss="alert">&times;</a>
                                ${ messages | first_upper }
                            </div>                                                       
                     %else:
                               <div class="alert alert-danger" id="alertp">
                                <a class="close" data-dismiss="alert">&times;</a>
                                ${ messages | first_upper }
                                </div>
                    %endif 				
				%endif
				
				<div style="display:none;" id="error" name="error">

				</div>
				
				<div style="display:none;" id="loaderDiv">

				</div>
				
					<div class="col-xs-3">
					</div>
					<div class="clearfix"></div>
					%if 'create-principals' in perms:
                      <div class="text-left col-xs-3">
                        <button type="button" class="btn btn-primary" onclick="createPrincipal()"
                                id="create_principal">${_("Create")}</button>
                      </div>
					%endif
					<div class="col-xs-12">
					<div class="clearfix"></div>
					<div class="col-xs-12">
						<div id="principallistcontainer" style="overflow:auto;">  
						<div class="preloader"></div>	
					</div> 						
					</div>
				</div>
			</form>							
		</div>	
	</div>
</%def>
<%def name="end_script()">
<script type="text/javascript">
$(function(){
   $(".close").click(function(){
      $("#myAlert").alert();
   });
});  
</script>
<script type="text/javascript">
function closeBtn(){
	$('#error').hide();
}
</script> 
</%def>
