## Copyright (c) 2016 by Adaptive Computing Enterprises, Inc. All Rights Reserved.

<%! from django.utils.translation import ugettext as _ %>
<%! from frontend_utils.utils import capitalize_first_letter_filter as first_upper %>
<%inherit file="base.mako" />

<%def name="title()">${_("Viewpoint Role management")}</%def>

<%def name="head_tags()"></%def>

<%def name="jquery_tags()">
<script src="/static/legacy/js/configuration.js" type="text/javascript"></script>  
<script type="text/javascript">
	function editRole(id)
	{
		window.location.href = "/createrole/?roleid="+id+"&tab=configuration";
	}
	function deleteRole(id,name) {
		// Added for IRIS-632
		var nameLength = 150;
		var platForm, userAgent;
		platForm = navigator.platform;
		userAgent = navigator.userAgent;
		if (platForm == 'Linux x86_64' || platForm == 'Win32' || platForm == 'MacIntel') {			
			if (userAgent.toLowerCase().indexOf("firefox") >= 0) {
				if(name.length > nameLength) {		
					name = name.substring(0, 50) + '\n' + name.substring(50, 100) + '\n' + name.substring(210);
				}	
			}
		}
		// Added for IRIS-632
								
		// Disable default filtering for confirmation alert java script localization
		data = confirm("${_("Are you sure you want to delete role '{0}'?") | n,decode.utf8 }".replace("{0}", name ));
		if(data){			
			
			$('#loaderDiv').show();
			$('#loaderDiv').html('<div id="err preloader" class="preloader" style="left:65%"></div>');			
			$.ajax({
				url:'/deleterole/?id='+id,
				type:'GET',
				cache:false,			
				success:function(result){
				$('#error').html('<a href="#" id="crossBtn" class="close" onClick="closeBtn()">&times;</a><div id="errpreloader" class="preloader"></div>');
					if(result == "True"){
						$('#loaderDiv').hide();
						$('#myAlert').hide();
						$('#error').show();
						$('#error').addClass("alert alert-success");
						$('#error').append("${_("Role '{0}' was deleted successfully")}".replace("{0}", name));
						$('#errpreloader').hide();
						refreshContentRole('rolelistrefresh')
					}
                    else {
                      $('#loaderDiv').hide();
                      $('#myAlert').hide();
                      $('#error').show();
                      $('#error').addClass("alert alert-success");
                      if (/^\s*<!DOCTYPE html>/.test(result)) {
						$('#error').html('500 Internal Server Error.');
						return;
					  }
                      $('#error').append(result);
                      $('#errpreloader').hide();
                      refreshContentRole('rolelistrefresh')
                    }
				},
				error: function(jqXHR, textStatus, errorThrown){
                gridconfigerror(jqXHR, textStatus, errorThrown);
                $('#loaderDiv').hide();
                }		
			});
		}				
	}
</script>

<script type="text/javascript">
		$(document).ready(function(){
			$('#rolelistcontainer.preloader').show();
			$.ajax({
				url:'/rolelist_grid/',
				type:'GET',
				data:{},
				success:function(result){
					if (/^\s*<!DOCTYPE html>/.test(result)) {
                        $('#rolelistcontainer').html('500 Internal Server Error.');
                        return;
                    }
					$('#rolelistcontainer.preloader').hide();
					$('#rolelistcontainer').html(result);
					disablePaginationContent();
					 var h = document.getElementById("page-content").offsetHeight;
					 $("#side").height(h);

                  $('#recreate-basic-roles-btn').click(function() {
                    var $error = $('#error');

                    $('#loaderDiv').show();
                    $('#loaderDiv').html('<div id="err preloader" class="preloader" style="left:65%"></div>');
                    $.ajax({
                      url: '/recreate-roles/',
                      type: 'GET',
                      cache: false,
                      success: function(result) {
                        $error.html('<a href="#" id="crossBtn" class="close" onClick="closeBtn()">&times;</a><div id="errpreloader" class="preloader"></div>');
                        if (result == "True") {
                          $('#loaderDiv').hide();
                          $('#myAlert').hide();
                          $error.show();
                          $error.addClass("alert alert-success");
                          $error.append("Roles were recreated successfully");
                          $('#errpreloader').hide();
                          refreshContentRole('rolelistrefresh');
                        }
                      },
                      error: function(jqXHR, textStatus, errorThrown) {
                        gridconfigerror(jqXHR, textStatus, errorThrown);
                        $('#loaderDiv').hide();
                      }
                    });
                  })
			},
			error: function(jqXHR, textStatus, errorThrown){      
             gridconfigerror(jqXHR, textStatus, errorThrown);
             }
			
		});
	});
</script>

</%def>
<%def name="main_content()">

		<div class="row rolesmanagement">
		<%include file="leftpanel.mako"/>
			<div class="col-xs-8 pull-left padle15">
        <div class="configuration-header-bar">
  				<h2>Role Management</h2>
          %if ('update-roles' in perms) or ('delete-roles' in perms) or ('create-roles' in perms):
            <div title="Refresh" class="refresh-button" id="rolelistrefresh" onClick="refreshRoleListPage('rolelistrefresh');">
              <span class="glyphicon glyphicon-refresh"></span>
            </div>
          %endif
        </div>
					<form id="rolemanagement">
						%if messages:
						  %if status == "success":
    							<div class="alert alert-success" id="myAlert">
    							 <a href="#" class="close" data-dismiss="alert">&times;</a>
    							${ messages | first_upper }
    							</div>
    					   %else:
    					       <div class="alert alert-danger" id="myAlert">
                                 <a href="#" class="close" data-dismiss="alert">&times;</a>
                                ${ messages | first_upper }
                                </div>
    					   %endif				
						%endif
						<div style="display:none;" id="error" name="error">

						</div>
						
						<div style="display:none;" id="loaderDiv">

						</div>
				
						<div class="col-xs-3">
						</div>
						<div class="clearfix"></div>
						%if 'create-roles' in perms:
                          <div class="text-left col-xs-3">

                            <button type="button" class="btn btn-primary" onclick="createRole()"
                                    id="create_role">${_("Create")}</button>

                          </div>
						%endif
						<div class="col-xs-12">
							<div class="clearfix"></div>
								<div class="col-xs-12">
									<div id="rolelistcontainer">
									<div class="preloader"></div>
									</div>
		</div>
	</div>
	</form>							
	</div>	
</div>

  </%def>
<%def name="end_script()">
<script type="text/javascript">
function closeBtn(){

	$('#error').hide();
}


</script> 
</%def>
