## Copyright (c) 2016 by Adaptive Computing Enterprises, Inc. All Rights Reserved.

<%! from django.utils.translation import ugettext as _ %>
<%! from frontend_utils.utils import capitalize_first_letter_filter as first_upper %>
<%inherit file="base.mako" />

<%def name="title()">${_("Viewpoint Roles")}</%def>

<%def name="head_tags()"></%def>

<%def name="jquery_tags()">
<script src="/static/legacy/js/configuration.js" type="text/javascript"></script>
<script src="/static/modal/js/confirm.js"></script>
<script src="/static/bootbox/bootbox.js"></script>
<script type="text/JavaScript">
		$(document).ready(function(){
					 var h = document.getElementById("page-content").offsetHeight - $("footer").height();
					 $("#side").height(h);
					 
					 disablecopypaste();
					 });
 </script>
<script>
  $(function() {
    var dangerPermissions = ['Job Details - Scheduling Analysis', 'Job Details - Priority'];

    $('.permission').click(function(e) {
      var $checkbox = $(this);
      if ($checkbox.is(':checked') && $.inArray($checkbox.data('permission-label'), dangerPermissions) > -1) {
        e.preventDefault();
        var confirmDialog = $.viewpoint.confirm('Grant Permission', 'This permission are very taxing on Moab and should not be abused on heavily loaded systems.' +
            ' Are you sure want to grant this permission?');
        $('.modal-dialog .btn-primary').addClass('normprimary');
        confirmDialog.done(function(result) {
          if (result) {
            $checkbox.prop('checked', true)
          }
        });
      }
    })
  });
</script>
</%def>
<%def name="main_content()">
<div class="row configuration">
		<%include file="leftpanel.mako"/>
		<div class="row rolesmanagement">
			
			<div class="col-xs-7 pull-left">
		<h2>${_("Roles")}</h2>
	</div>
	<div class="col-xs-8 padle15">	
	%if messages:
	   %if status == "success":	      
            <div class="alert alert-success" id="alertrole">
            <a href="#" class="close" data-dismiss="alert" id="alert_success_closeBtn">&times;</a>
                ${ messages | first_upper }
            </div>
       %else:
            <div class="alert alert-danger" id="alertrole">
            <a href="#" class="close" data-dismiss="alert" id="alert_danger_closeBtn">&times;</a>
                ${ messages | first_upper }
            </div>
       %endif
    %endif
	
		<form id="rolesForm" class="management" method="post" action="/createrole/" name="roleform">
			<span class="control-group">
				<label for="RoleName" class="col-xs-3">${_("Enter Role Name")}</label>
					<div class="col-xs-5">
					%if role['id']:
						<div class="col-xs-12" id="roleNameContainer">
						<input type="hidden" id="RoleName" name="RoleName" value="${ role['name']  }" maxlength="255"  />
						${ role['name']  }  </div>
					%else:					
						<div class="col-xs-12"><input type="text" class="form-control" id="RoleName" maxlength="255" name="RoleName"/></div>
					%endif
					</div>
				<div class="col-xs-3">
					<!--<div class="text-left">
							<button type="submit" class="btn btn-primary">${_("Create Role")}</button>
					</div> -->  
				</div>
			</span>
			<div class="clearfix"></div>
			<span class="control-group">
				<label for="Description" class="col-xs-3">${_("Description")}</label>
					<div class="col-xs-5">
                        %if 'description' in role:
						  <textarea class="form-control resize" id="Description" name="Description" maxlength="100">${ role['description']  }</textarea>
                        %else:
                          <textarea class="form-control resize" id="Description" name="Description" maxlength="100"></textarea>
                        %endif
					</div>
			</span>
			<div class="clearfix"></div>
            %if isinstance(data, dict):
                <div class="col-xs-5 text-left">
                    <b>${_("Viewpoint Permissions")}:</b>
                    
                    <div class="clearfix"></div>
					   <table class="table borderless" cellpadding="0" cellspacing="0" style="margin-bottom:0px;">
							<tr>
								<td width="11%">
								<input type="checkbox" id="selectallvp"/>
								</td>
								<td>${_("Select All")}</td>
							</tr>
						</table>
                        <div class="col-xs-12 padding scroll">
                            <table class="table borderless" cellpadding="0" cellspacing="0">
                                %if data['permissions']:
                                    %for p in data['permissions']:
                                        <tr>
                                            <td>
                                              <input class="permission viewpoint-perm" type="checkbox" name="permissions"
                                                     id="${ ''.join(p['label'].split(' '))  }CB"
                                                     class="checked" value="${ p['id'] }"
                                                     data-permission-label="${ p['label'] }"
                                                  % if p['id'] in rolepermission:
                                                     checked
                                                  % endif
                                                  />
                                            </td>
                                            <td>
                                                <label for="permissions" id="${ ''.join(p['label'].split(' '))  }" class="col-xs-11">${ p['label']  }</label>
                                            </td>
                                        </tr>
                                    %endfor
                                %else:
                                    <br/>
                                    ${_("No Viewpoint permissions found")}
                                %endif

                        </table>
                    </div>
                </div>
                <div class="col-xs-5 text-left">
                    <b> ${_("Domain Permissions")}:</b>
					 <div class="clearfix"></div>
                    <table class="table borderless" cellpadding="0" cellspacing="0" style="margin-bottom:0px;">
						<tr>
							<td width="11%">
								<input type="checkbox" id="selectall"/>
							</td>
							<td>${_("Select All")}</td>
						</tr>
					</table>
							
                   
                        <div class="col-xs-12 padding scroll">
                            <table class="table borderless" cellpadding="0" cellspacing="0">
							
							
                                %if data['domainpermissions']:
                                    %for p in data['domainpermissions']:
                                        <tr>

                                            <td>

                                                % if p['id'] in rolepermission:
                                                    <input type="checkbox" name="permissions" id="${ ''.join(p['label'].split(' '))  }CB" class="mws-perm" value="${ p['id']  }" checked />
                                                % else:
                                                    <input type="checkbox" name="permissions" id="${ ''.join(p['label'].split(' '))  }CB" class="mws-perm" value="${ p['id']  }" />
                                                % endif
                                            </td>
                                            <td>
                                                <label for="permissions" id="${ ''.join(p['label'].split(' '))  }" class="col-xs-12">${ p['label']  }</label>
                                            </td>
                                        </tr>

                                    %endfor
                                %else:
                                <br/>
                                ${_("No Domain permissions found")}
                                %endif
								
                        </table>
                    </div>
                </div>
            %else:
                <div class="alert alert-success">${ data  }</div>
            %endif
            
		<div class="col-xs-12">			
			<div class="col-xs-2">
			<input type="hidden" id="roleid" name="roleid" value="${ role['id']  }">
				<div class="text-left">
					<button type="button" class="btn btn-primary"  id="roleCancelBtn">
					${_("Cancel")}
					</button>
				</div> 
			</div>
			<div class="col-xs-2">
				<div class="text-left">
					<button type="submit_button" name="submit_form" id="submitDone" class="btn btn-primary" value="Done">
					${_("Done")}
					</button>
				</div> 
			</div>
			<div class="col-xs-2">
				<div class="text-left">
					<button type="submit_button" name="submit_form" id="submitApply" class="btn btn-primary" value="Apply">
					${_("Apply")}
					</button>
				</div> 
			</div>
            %if role['name'] == 'HPCUser' or role['name'] == 'HPCAdmin':
            <div class="col-xs-2">
				<div class="text-left">
					<button type="submit_button" name="submit_form" id="reset" class="btn btn-primary" value="Reset">
					${_("Reset")}
					</button>
				</div>
			</div>
			%endif
		</div>
		</form>
		</div>
  </div>
</%def>
<%def name="end_script()">
 <script type="text/javascript">
$(function(){
   $(".close").click(function(){
      $("#alertrole").alert();
   });
});
$('#reset').click(function (evt) {
  evt.preventDefault();
  var conf = $.viewpoint.confirm('Reset Permissions', 'Are you sure want to reset permissions to the default?');
  $('.modal-dialog .btn-primary').addClass('normprimary');
  conf.done(function(result) {
    if (result) {
      $('#rolesForm').append('<input type="hidden" name="submit_form" value="Reset" />');
      $("#rolesForm").submit();
    } else {
      return false;
    }
  });
});
</script>
 <script type="text/javaScript">
	$(document).ready(function() {
    $('#selectall').click(function(event) {  //on click 
        if(this.checked) { // check select status
            $('.mws-perm').each(function() { //loop through each checkbox
                this.checked = true;                 
            });
        }else{
            $('.mws-perm').each(function() { //loop through each checkbox
                this.checked = false;                        
            });         
        }
    });
    createDirtyUnloadListener("input.form-control, textarea.form-control, input[name=permissions], #selectall, #selectallvp","${_("You have unsaved changes that will be lost.")}");
});

	$(document).ready(function() {
    $('#selectallvp').click(function(event) {  //on click 
        if(this.checked) { // check select status
            $('.viewpoint-perm').each(function() { //loop through each checkbox
                this.checked = true;                 
            });
        }else{
            $('.viewpoint-perm').each(function() { //loop through each checkbox
                this.checked = false;                        
            });         
        }
    });
    
});

	$("#RoleName").on("keydown", function (e) {
		return e.which !== 32;
	});  
	
$("#roleCancelBtn").click(function() {
	isDirtyPlaceholder = false;
document.location.href="/rolelist/?tab=configuration";
$("#mainNav li").addClass("active1");
});

$("#submitApply").click(function() {
    isDirtyPlaceholder = false;
});

$("#submitDone").click(function() {
    isDirtyPlaceholder = false;
});
   </script>
</%def>
