## Copyright (c) 2016 by Adaptive Computing Enterprises, Inc. All Rights Reserved.

<%! from django.utils.translation import ugettext as _ %>
<%! from frontend_utils.utils import capitalize_first_letter_filter as first_upper %>
<%inherit file="base.mako" />
<%namespace name="base" file="base.mako" />

<%def name="title()">${_("Viewpoint Dashboard")}</%def>

<%def name="head_tags()">
    <link rel="stylesheet" type="text/css" href="../static/subjobs_widget/css/subjobs_widget.min.css"/>
	<link rel="stylesheet" type="text/css" href="../static/datatables/media/css/jquery.dataTables.min.css"/>
	<link rel="stylesheet" type="text/css" href="../static/c3/c3.css"/>

    <style type="text/css">
        .datagrid-container .table .job-arr-widget td a {
            width: auto;
        }
    </style>
</%def>


<%def name="jquery_tags()">
		<script src="../static/jquery-bootpag/lib/jquery.bootpag.js" type="text/javascript"></script>
		<script src="../static/d3/d3.js" type="text/javascript"></script>
		<script src="../static/c3/c3.js" type="text/javascript"></script>
		<script src="../static/api/js/api.js" type="text/javascript"></script>
		<script src="../static/api/js/loader.js" type="text/javascript"></script>
		<script src="../static/subjobs_widget/js/subjobs-widget.js" type="text/javascript"></script>
		<script src="../static/legacy/js/jobs.js" type="text/javascript"></script>
		<script src="../static/iris/js/workload-table.js" type="text/javascript"></script>
		<script src="/static/datatables/media/js/jquery.dataTables.min.js" type="text/javascript"></script>
		<script src="../static/js-url/url.min.js" type="text/javascript"></script>
		<script src="../static/iris/js/main.js"></script>
</%def>

<%def name="main_content()">
	<div class="row dashboard-page">
		%if dashboardWidgetExists():
			<div id="workload" class="col-xs-8 padlt">
		%else:
			<div id="workload" class="col-xs-12 padlt">
		%endif
		%if messages:
			%if status == "200":
				<div class="alert alert-success" id="myAlert">
				<a href="#" class="close" data-dismiss="alert">&times;</a>
				${ "<br />".join(str(messages).split(",")) | n,decode.utf8,first_upper }
				</div>
			%else:
				<div class="alert alert-danger" id="myAlert">
				<a href="#" class="close" data-dismiss="alert">&times;</a>
				${ "<br />".join(str(messages).split(",")) | n,decode.utf8,first_upper }
				</div>
			%endif
		%endif
			<div class="search-section">
				<div class="input-group-container">
					<div class="input-group">
						<input id="searchBox" type="text" class="form-control search-input"
							placeholder="${_("Search")}">
						<select id="searchCat" class="form-control search-select" onChange="$('#searchBox').focus()">
							<option value="job_name">${_("Job ID")}</option>
							<option value="job_custom_name">${_("Job Name")}</option>
		          %if 'update-jobs-any' in perms and 'Job View All' in perms and 'read-insight-privileged' in perms:
		            <option id="opt2" value="user_name">${_("Submitter ID")}</option>
		          %endif
						</select>
					</div>
				</div>
				<div class="pull-right search-btn-container">
					<button id="searchBtn" type="button" class="btn btn-primary search-btn">
						<span class="glyphicon glyphicon-search"></span>
					</button>
				</div>
			</div>

			<h1><b>${_("Workload")}</b>
				<span class="refresh" id="workloadRefresh" title="Refresh"></span>
			</h1>
			%if not user.is_superuser and 'Create Job' in perms:
            	<%include file="job_type_dialog.html"/>
            %endif
				<div class="intervalDiv pull-right">
				  <label class="intervalLabel">Refresh Interval</label>
				  <select name="intervals" id="selectIntervals" class="form-control selectIntervals">
            <option value="OFF">OFF</option>
            <option value="5000">5s</option>
            <option value="15000" selected>15s</option>
            <option value="30000">30s</option>
            <option value="60000">60s</option>
            <option value="300000">5m</option>
				  </select>
				</div>
				<div class= "alert alert-success" style= "display: none" id="statusMsg">
				</div>
				<div style="display:none;" id="loaderDiv">
				</div>
				<%include file="workload_table.html"/>
			</div>
		<div class="col-xs-4 padLeft">
		%if systemResourcesWidgetExists():
			<h3 class="first-title"><b>${_("Dedicated System Resources")}</b></h3>
			<div class="panel panel-default" id="systemresourcespanel">
				<div class="chart-legend">
					<span class="legend legend-grey">CPU</span>
					<span class="legend legend-blue pull-right">${_("MEMORY")}</span>
				</div>
				<div class="su_chart_wrapper">
					<div id="chart_div"></div>
				</div>
				<div class="chart-legend">
					<span class="legend small">24h...</span>
					<span class="legend pull-right small">current</span>
				</div>
			</div>
		%endif
			%if __features__.vp_admin:
				%if nodeSummaryWidgetExists():
					<h3><b>${_("Node Summary")}</b></h3>
					<div class="panel panel-default" id="resourcepanel">
						<h4 id="countNodes"></h4>
						<div class="panel-body chart-section" id="resourcepanelbody">
						</div>
						%if 'Nodes' in perms:
                            <a href="/nodelist/"  class="btn btn-primary" id="view_nodes_btn">
                                View All Nodes
                                <span class="glyphicon glyphicon-play"></span>
                            </a>
						%endif
					</div>
				%endif
			%endif
			%if workloadSummaryWidgetExists():
				<h3><b>${_("Workload Summary")}</b></h3>
				<div class="panel panel-default" id="jobpanel">
					<h4 id="countJobs"></h4>
					<div class="panel-body chart-section" id="jobpanelbody">
					</div>
					%if 'Workload' in perms:
                        <a href="/workload/" class="btn btn-primary" id="view_workload_btn">
                            View All Workload
                            <span class="glyphicon glyphicon-play"></span>
                        </a>
                    %endif
				</div>
			%endif
		</div>
	</div>

</%def>
<%def name="systemResourcesWidgetExists()">
    %if base.hasAccess('System Resources Widget'):
         <% return True %>
    %endif
</%def>
<%def name="nodeSummaryWidgetExists()">
    %if base.hasAccess('Node Summary Widget'):
         <% return True %>
    %endif
</%def>
<%def name="workloadSummaryWidgetExists()">
    %if base.hasAccess('Workload Summary Widget'):
         <% return True %>
    %endif
</%def>
<%def name="dashboardWidgetExists()">
    %if systemResourcesWidgetExists() or nodeSummaryWidgetExists() or workloadSummaryWidgetExists():
         <% return True %>
    %endif
</%def>
<%def name="end_script()">
	<script type="text/javascript">
		$(document).ready(function() {

			%if systemResourcesWidgetExists():
				drawCpuMemoryChart();
			%endif
			%if workloadSummaryWidgetExists() or nodeSummaryWidgetExists():
				%if workloadSummaryWidgetExists():
					drawJobSumChart();
				%endif
				%if nodeSummaryWidgetExists():
					drawResSumChart();
				%endif
			%endif

			var resizeHandlerTimer;

			$(window).resize(function() {
				if (resizeHandlerTimer) {
					clearTimeout(resizeHandlerTimer);
				}
				resizeHandlerTimer = setTimeout(function() {
					windowWasResized();
				}, 400);
			});
		});
	</script>
</%def>

