## Copyright (c) 2016 by Adaptive Computing Enterprises, Inc. All Rights Reserved.

<%! from django.utils.translation import ugettext as _ %>
<%! from frontend_utils.utils import capitalize_first_letter_filter as first_upper %>
<%inherit file="base.mako" />
<%namespace name="base" file="base.mako" />

<%def name="title()">${_("Viewpoint Job Details")}</%def>

<%def name="head_tags()">\
  <link rel="stylesheet" href="../static/api/css/loader.css"/>
  <link rel="stylesheet" href="../static/iris/css/jobicons.css">
  <link rel="stylesheet" href="../static/modal/css/modal.css"/>
  <link rel="stylesheet" href="../static/datatables/media/css/jquery.dataTables.min.css"/>
  <link rel="stylesheet" href="../static/select2/dist/css/select2.min.css"/>
  <link rel="stylesheet" href="../static/fast_scroll_arrows/css/fast_scroll_arrows.css"/>
  <link rel="stylesheet" type="text/css" href="../static/c3/c3.css"/>
</%def>

<%def name="jquery_tags()">

<link rel="stylesheet" type="text/css" href="../static/bootstrap-touchspin/dist/jquery.bootstrap-touchspin.min.css"/>
<script src="../static/legacy/js/jobs.js" type="text/javascript"></script>
<script src="../static/fast_scroll_arrows/js/fast_scroll_arrows.js" type="text/javascript"></script>
<script src="../static/jquery-bootpag/lib/jquery.bootpag.js" type="text/javascript"></script>
<script src="../static/bootstrap-touchspin/dist/jquery.bootstrap-touchspin.min.js" type="text/javascript"></script>
<script src="../static/select2/dist/js/select2.full.js" type="text/javascript"></script>
<script type="text/javascript" src="https://www.google.com/jsapi"></script>
<script src="../static/legacy/js/job-details.js" type="text/javascript"></script>
<script src="../static/d3/d3.js" type="text/javascript"></script>
<script src="../static/c3/c3.js" type="text/javascript"></script>

<script src="../static/modal/js/modal.js" type="text/javascript"></script>
<script src="../static/api/js/api.js" type="text/javascript"></script>
<script src="../static/api/js/loader.js" type="text/javascript"></script>
<script src="../static/datatables/media/js/jquery.dataTables.min.js" type="text/javascript"></script>
<script src="/static/js-url/url.js"></script>
<script src="/static/bootbox/bootbox.js"></script>
<script src="/static/modal/js/confirm.js"></script>
<script src="../static/iris/js/main.js"></script>

<script>
  $(function() {
    $('.priority-title .show-all').on('click', function(e) {
      var link = $(e.target);
      if (link.hasClass('glyphicon-chevron-right')) {
        link
          .removeClass('glyphicon-chevron-right')
          .addClass('glyphicon-chevron-down');
        $('.priority-bar .update-priority')
          .show()
          .click();
      } else {
        link
          .removeClass('glyphicon-chevron-down')
          .toggleClass('glyphicon-chevron-right');
        $('.priority-bar .priority-body').hide();
        $('.priority-bar .priority-title')
          .removeClass('expanded');
        $('.priority-bar .update-priority').hide();
        $('.priority-bar .nodefinition').remove();
        $('#apply-priority').addClass('hidden');
        $('#done-priority').addClass('hidden');
      }
    });
    $('.priority-bar .update-priority').on('click', function() {
      $('.priority-bar.api')
        .data('api')
        .get("/api/jobs/${ entries['name'] | n,decode.utf8 }/priority/")
        .done(jobPriorityReceived);
    });

    $("[data-toggle=cpu-statistics-controls]").popover({
      html: true,
      container: '.popover-cpu-statistics',
      placement: 'left',
      content: function() {
            return $('#cpu-statistics-controls').html();
          }
    });

    $("[data-toggle=nitro-refresh-bar]").popover({
      html: true,
      container: '.popover-nitro',
      placement: 'left',
      content: function() {
            return $('#nitro-refresh-bar').html();
          }
    });

    function explanation(priority) {

        var label = function (key) {
          var labels = {
            // 'credential': 'credential',
            // 'resource': 'resource',
            // 'target': 'target',
            // 'service': 'service',
            // 'attribute': 'attribute',
            // 'fairshare': 'fairshare',
            // 'usage': 'usage'
          };

          return labels[key] || key;
        };

        var title = function (key) {
          var titles = {
            'attribute': 'The Attribute component allows the incorporation of job attributes into a job\'s priority',
            'credential': 'The credential component allows a site to prioritize jobs based on political issues such as the relative importance of certain groups or accounts',
            'fairshare': 'Fairshare components allow a site to favor jobs based on short-term historical usage',
            'resource': 'Weighting jobs by the amount of resources requested allows a site to favor particular types of jobs',
            'service': 'The Service component specifies which service metrics are of greatest value to the site',
            'target': 'The target factor component of priority takes into account job scheduling performance targets',
            'usage': 'The Usage component applies to active jobs only'
          };

          return titles[key] || key;
        };

        var rows = [];

        // Component header
        rows[0] = _.map(priority.components, function (value, key) {
        var subcomponents = _(value)
          .filter(_.isObject);

          return '<th colspan="' + subcomponents.size() + '" title="' +
            title(key) + '">' +
            label(key) + '</th>';
        })
        .join('');

        rows[0] += '<th rowspan="2" title="Job\'s total priority">= priority</th>';

        // Subcomponent header
        rows[1] = _.map(priority.components, function (value, key) {
          return _(value)
            .pick(_.isObject)
              .map(function (value, key) {
                return '<th>' + label(key) + '</th>';
            })
            .join('');
        }).join('');

        // Component priority values
        rows[2] = _(priority.components)
          .map(function (value, key) {
            var subcomponents = _(value)
              .filter(_.isObject);

            var priority = subcomponents
              .map(function (value) {
                return value.weight * value.value;
              })
              .reduce(function (total, value) {
                return total + value;
              });

              return '<td colspan="' + subcomponents.size() + '">' +
                value.weight * (value.cap > 0 ? Math.min(value.cap, priority) : priority) +
                '</td>';
          })
          .join('');

        var calculatedPriority = _(priority.components)
          .map(function (value) {
            var priority = _(value)
              .filter(_.isObject)
              .map(function (value) {
                return value.weight * value.value;
              })
              .reduce(function (total, value) {
                return total + value;
              });

            return value.weight *
              (value.cap > 0 ? Math.min(value.cap, priority) : priority);
          })
          .reduce(function (total, value) {
            return total + value;
          });

        // = PRIORITY column
        rows[2] += '<td rowspan="2">' +
          (priority.system ? 1000000000 + priority.system : calculatedPriority) +
          '</td>';

        // Subcomponent priority values
        rows[3] = _.map(priority.components, function (value, key) {
          return _(value)
            .filter(_.isObject)
              .map(function (value) {
                return '<td>' + (value.weight * value.value) + '</td>';
            })
            .join('');
        }).join('');

        var explanation =
          '<table class="explanation">' +
          '<thead>' +
          rows
            .slice(0, 2)
            .map(function (value) {
              return '<tr>' + value + '</tr>';
            })
          .join('') +
          '</thead>' +
          '<tbody>' +
          rows
            .slice(2, 4)
            .map(function (value) {
              return '<tr>' + value + '</tr>';
            })
          .join('') +
          '</tbody>' +
          '</table>';

        explanation = $(explanation);

        if (priority.system)
          explanation.addClass('disabled');

        return explanation;
    }

    function jobPriorityReceived(data) {
        "use strict";

        $('.priority-bar .nodefinition').remove();

        %if entries['is_array_master'] == 1:
        <%
          user_prio_attrs = 'disabled title="You cannot change priority of master job"'
        %>
        %else:
        <%
          user_prio_attrs = 'title="User job priority should be in range between -1024 and 0"'
        %>
        %endif

        %if not 'update-jobs-any' in perms:
        <%
          system_prio_attrs = 'disabled title="You cannot change priority of job you do not own"'
        %>
        %else:
          %if entries['is_array_master'] == 1:
          <%
            system_prio_attrs = 'disabled title="You cannot change priority of master job"'
          %>
          %else:
          <%
            system_prio_attrs = 'title="System priority should be in range between 0 and 1000"'
          %>
          %endif
        %endif

        <% print perms %>

        var priority = '<table>' +
                '<thead>' +
                    '<tr>' +
                        '<th>User Job Priority</th>' +
                        '<th>System Priority</th>' +
                        '<th>Start Priority</th>' +
                        '<th>Job Start Count</th>' +
                    '</tr>' +
                '</thead>' +
                '<tbody>' +
                    '<tr>' +
                        '<td>' +
                        '<input class="form_save_data" id="job-priority" name="job_priority" type="text" value="' + data.components.service.userprior.value + '" ${ user_prio_attrs | n }>' +
                        '</td>' +
                        '<td><input class="form_save_data" id="system-priority" name="sys_priority" type="text" value="' + data.system + '" ${ system_prio_attrs | n }></td>' +
                        '<td>' + data.start + '</td>' +
                        '<td>' + data.components.service.startcount.value + '</td>' +
                    '</tr>' +
                '</tbody>' +
            '</table>';

        $('.priority-bar .priority-body')
            .empty()
            .append(priority)
            .append(explanation(data));

        // %if not user_prio_attrs:
        // https://github.com/istvan-ujjmeszaros/bootstrap-touchspin/pull/13
        $("#job-priority").TouchSpin({verticalbuttons: true, min: -1024, max: 0});
        // %endif

        // %if not system_prio_attrs:
        // https://github.com/istvan-ujjmeszaros/bootstrap-touchspin/pull/13
        $("#system-priority").TouchSpin({verticalbuttons: true, min: 0, max: 1000});
        // %endif

        // $('.priority-bar #job-priority').blur(function(e) {
        //   validate_user_priority_OnKeyUp('job-priority', 0, -1024, e);
        // });

        // $('.priority-bar #job-priority').keypress(function(e) {
        //   validateJobPriority(e);
        // });

        $('.priority-bar .priority-title').addClass('expanded');
        $('.priority-bar .priority-body').show();
        $('#apply-priority').removeClass('hidden');
        $('#done-priority').removeClass('hidden');
    }
    if (window.location.hash === "#priority_open") {
      $('.priority-title .show-all').click();
    }
  });
</script>

</%def>

<%def name="main_content()">
<div class="row">
% if status_code == 2000 :
    <form class="form-jobDetail" role="form" method="post" action='/jobdetails/'
      data-allow-changes="${allow_changes}"
      data-qos-name="${entries['qos_name']}"
      data-user-name="${entries['user_name']}"
      data-job-id="${ entries['name'] | n,decode.utf8 }">
        <div class="col-xs-12">
            <div class="col-xs-12 top-bar-container" id="top-bar-container">
              <div class="row">
                %if messages:
                    %if status == "200":
                        <div class="alert alert-success">
                        <a href="#" class="close" data-dismiss="alert">&times;</a>
                            ${ messages | n,decode.utf8,first_upper}
                        </div>
                    %else:
                        <div class="alert alert-danger">
                        <a href="#" class="close" data-dismiss="alert">&times;</a>
                            ${ messages | n,decode.utf8,first_upper}
                        </div>
                    %endif
                %endif
              </div>
              <div class="row">
              <div class="col-xs-3 template-icon-container">
                %if template_type == 'remote_viz':
                    <div class="job-type-icon icon-remote"></div>
                %endif
                %if template_type == 'nitro':
                    <div class="job-type-icon icon-nitro"></div>
                %endif
                %if template_type == 'regular':
                    <div class="job-type-icon icon-hpc"></div>
                %endif
                %if template_type == 'array':
                    <div class="job-type-icon icon-array"></div>
                %endif
                %if not template_type:
                    <div class="template-icon-none">N/A</div>
                %endif
                %if entries['custom_name']:
                  %if entries['custom_name'] == 'None':
                    <div class="template-icon-name">--</div>
                  %else:
                    <div class="case ffld template-icon-name" title="${ entries['custom_name'] }">
                      ${ entries['custom_name'] }
                    </div>
                  %endif
                %else:
                  <span class="template-icon-name">--</span>
                %endif
                <div class="case">
                  ${_("Status")}:&nbsp;
                  <span class=${ entries['queue_status'].lower() } id="jDQueueStatus">${ entries['queue_status'] }</span>
                </div>
                <div>
                  ${_("Job Status")}:&nbsp;
                  <span id="jDStatusVal">${ entries['state'] }</span>
                </div>
              </div>
              <div class="col-xs-4 right-sub-section">
                <div class="pull-left">
                  <h1>
                    <b>${_("Job Details")}</b>
                    <span id="detailsRefresh" class="refresh" title="Refresh"></span>
                  </h1>
                  <div class="jDJobNameContainer">
                    <span id="jDJobID" class="case">${_("Job Id") } :</span>
                    &nbsp;
                    <span id="jDJobIDVal" class="case ffld">
                      ${ entries['name'] }
                    </span>
                  </div>

                  %if entries['array_master_name'] and entries['is_array_master'] != 1:
                    <div>
                      <a class="case ffld parent-link" href="/jobdetails/?job_name=${entries['array_master_name']}&job_status=UNKNOWN&job_id=UNKNOWN">
                        <span class="glyphicon glyphicon-chevron-left"></span>
                        Parent Job: ${ entries['array_master_name'] }
                      </a>
                      <span class="case" id="masterJobID" style="margin-left: 20px"></span>
                    </div>
                  %endif

                  <!-- TODO: add check if script path exist -->
                  <div class="script-container">
                    <span id="script-path" class="case2">
                      Submission Script:&nbsp;
                      %if entries['submit_command_file']:
                          <span class="script-ffld" id="script-path-link" data-path="${entries['submit_command_file']}">${entries['submit_command_file']}
                          </span>
                      %else:
                          <span class="ffld">
                            N/A
                          </span>
                      %endif
                    </span>
                  </div>
                  <div class="reservation-container">
                    <div>
                      <span class="case2">${_("Reservation Name")}:&nbsp;
                          %if ('reservation_label' in entries) and entries['reservation_label']:
                            <span class="script-ffld">${entries['reservation_label']}</span>
                          %elif ('reservation_name' in entries) and entries['reservation_name']:
                            <span class="script-ffld">${entries['reservation_name']}</span>
                          %else:
                            <span class="ffld">N/A</span>
                          %endif
                      </span>
                    </div>
                  </div>
                  <input type="label" hidden id="job_name" name="job_name" size="20" value=${entries['name']  } />
                  %if __features__.vp_user:
                    <div class="template-name-container case2">
                    Template:&nbsp;&nbsp;<span class="template-name">N/A</span>
                  </div>
                  %endif
                </div>
              </div>

              <div class="col-xs-5">
              <div class="pull-right">
                <div class="pull-right back-link">
                    <span>
                        <a href="${ hrefLoc }" class="return-previous-link">${_("Return to earlier search")}</a>
                    </span>
                    <button type="button" class="btn btn-default btn-sm cancel-job-btn" style="margin-left: 15px; display: none;">Cancel</button>
                    <button type="button" class="btn btn-primary normprimary default btn-sm hold-job-btn" style="display: none;">Hold</button> 
                    <button type="button" class="btn btn-primary normprimary default btn-sm release-job-btn" style="display: none;">Release</button>                   
                </div>
                <div class="status-container api">
                  <div class="clearfix"></div>
                  %if ('Job Details - Scheduling Analysis' in perms) and (entries['queue_status'] in ('IDLE', 'BLOCKED', 'HOLD', 'ELIGIBLE')):
                    <button id="scheduler-info-btn" type="button" class="btn btn-default btn-sm"
                      data-jobid="${ entries['name'] }">More Information
                    </button>
                  %endif
                </div>

                %if entries['is_remote_viz_job'] and __features__.vp_remote_viz and (entries['queue_status'] != 'COMPLETED'):
                  <div class="remote-viz-container">
                    <div class="remote-viz-container-loader">
                        <div class="remote-viz-title">
                          <span class="glyphicon glyphicon-chevron-down pull-left show-all"></span>
                          <span class="pull-left">Remote Viz Session</span>
                          <span class="glyphicon glyphicon-refresh right remote-refresh"></span>
                        </div>
                        <div class="navbar navbar-default remote-viz-settings">
                          <div class="col-xs-2" style="padding:0;">
                            <div class="remote-connect-bar" id="remote-viz-url-container">
                              <a href="#" id="remote-viz-url" class="disabled" style="margin-bottom:5px;">
                                <span class="glyphicon glyphicon-play-circle" title="Connect to remote session"></span>
                              </a>
                              <a href="#" id="stop-session" class="disabled">
                                <span class="glyphicon glyphicon-remove-circle" title="Disconnect all users from this session"></span>
                              </a>
                            </div>
                          </div>
                          <div class="col-xs-10 screenshot-container" data-show-error="false" style="padding:0;">
                            <img id="remote-viz-screenshot">
                            <span id="remote-viz-screenshot-disabled">Screenshot is not available at this time</span>
                          </div>
                        </div>
                    </div>
                  </div>
                %endif
              </div>
              </div>
              </div>
            </div>

            %if allow_changes:
              %if 'Job Details - Priority Analysis' in perms:
              <div class="col-xs-12 priority-bar api">
                <div class="priority-title">
                  <span class="glyphicon glyphicon-chevron-right show-all" title="Priority"></span>
                  Priority
                  <span class="glyphicon glyphicon-repeat right update-priority" title="Update"></span>
                </div>
                <div class="priority-body"></div>
                <div class="priority-buttons-container pull-right">
                    <button type="button" id="done-priority" class="btn btn-primary normprimary hidden">Done</button>
                    <button type="button" id="apply-priority" class="btn btn-primary normprimary hidden">Apply</button>
                </div>
              </div>
              %endif
            %endif

            <div class="col-xs-12 messages-bar api">
              <div class="messages-title">
                <span class="glyphicon glyphicon-chevron-right show-all" title="Show Messages"></span>
                Job Messages
                <span class="glyphicon glyphicon-repeat right update-messages" title="Update"></span>
              </div>
              <div class="messages-body navbar navbar-default">
                <%include file="job_messages.html"/>
              </div>
            </div>

            %if entries['is_nitro'] == 1 and __features__.vp_nitro:
              <%include file="nitro_widget.html"/>
            %endif


                <input type="hidden" id="job_name" name="job_name" size="20" value=${entries['name']  } />
                <input type="hidden" name="job_status" value=${ entries['state'] } />
                <input type="hidden" name="job_id" value=${ job_id  } />
                <input type="hidden" id="back_count" name="back_count" value=${ back_count  } />
                <div class="clearfix"></div>

            <%include file="subjob_widget.html"/>
            <div class="clearfix"></div>
            <div class="hrule"></div>
            <div class="col-xs-6">
              <div class="section-title-common">
                ${_("Credentials")}
              </div>

              <div class="row field-row">
                <div class="col-xs-4" style="padding-right: 0">
                  <div class="left-sub-section" id="jDUser">${_("User")}</div>
                  <div class="right-sub-section ffld" id="jDUserVal" title="${entries['user_name']}">
                    ${entries['user_name']}
                  </div>
                </div>
                <div class="col-xs-4" style="padding-right: 0">
                  <div class="left-sub-section" id="jDGroup">${_("Group")}</div>
                  <div class="right-sub-section ffld" id="jDGroupVal" title="${entries['group_name']}">
                    ${entries['group_name']}
                  </div>
                </div>
                <div class="col-xs-4" style="padding-right: 0">
                  <div class="left-sub-section" id="jDAccount">${_("Account")}</div>
                  <div class="right-sub-section ffld" id="jDAccountVal" title="${entries['account_name']}">
                    ${entries['account_name']}
                  </div>
                </div>
                <div class="col-xs-4">
                  <div class="left-sub-section" id="jDClass">${_("Class")}</div>
                  <div class="right-sub-section ffld" id="jDClassNmVal">${entries['class_name']}</div>
                </div>
                <div class="col-xs-8">
                  <div class="left-sub-section api" id="jDQoS">${_("Quality of Service")}</div>
                    %if base.hasAccess('Job Edit Admin'):
                        <div class="right-sub-section-select2 api" id="qos-container">
                          <select name="qos" id="qos"></select>
                        </div>
                    %else:
                      <div class="right-sub-section ffld">
                          ${entries['qos_name']}
                      </div>
                    %endif
                </div>
              </div>
            </div>


            <div class="col-xs-6">
                <div class="row">
                  <div class="section-title-common">
                    ${_("CPU Statistics")}
                  </div>
                </div>
                %if entries['is_nitro'] == 1:
                <div id="cpu-statistics-container-unavailable">Nitro applications track their own usage statistics. Please expand the Nitro Statistics section of this page for more information.</div>
                <div class="cpu-statistics api hidden" data-show-error="false">
                %else:
                <div class="cpu-statistics api" data-show-error="false">
                %endif
                  <div id="cpu-statistics-container">
                  </div>
                  <div class="cpu-statistics-settings">
                    <span class="glyphicon glyphicon-cog cpu-statistics-config" data-toggle="cpu-statistics-controls"></span>
                  </div>
                    <div class="popover-cpu-statistics">
                      <div id="cpu-statistics-controls" class="hide">
                        <div class="row">
                          <div class="col-xs-5">
                            <label>Sample Intervals:</label>
                          </div>
                          <div class="col-xs-5">
                            <select class="cpu-statistics-granularity form-control input-sm">
                              <option selected value="1">Every min</option>
                              <option value="10">Every 10 mins</option>
                              <option value="60">Every hour</option>
                            </select>
                          </div>
                          <div class="col-xs-1">
                            <span class="glyphicon glyphicon-refresh cpu-statistics-refresh" title="Refresh"></span>
                          </div>
                        </div>
                        <div class="row">
                          <div class="col-xs-5">
                            <label class="diapason-label">Range:</label>
                          </div>
                          <div class="col-xs-5">
                            <select class="cpu-statistics-diapason form-control input-sm">
                              <option selected value="60">Last hour</option>
                              <option value="120">Last 2 hours</option>
                              <option value="180">Last 3 hours</option>
                              <option value="360">Last 6 hours</option>
                              <option value="720">Last 12 hours</option>
                              <option value="1440">Last 24 hours</option>
                            </select>
                          </div>
                        </div>
                        <div class="row">
                          <div class="col-xs-5">
                            <label for="graph-refresh">Auto refresh</label>
                          </div>
                          <div class="col-xs-5">
                            <input type="checkbox" id="graph-refresh" title="Enable auto-refresh" checked>
                          </div>
                        </div>
                      </div>
                    </div>
                </div>
            </div>


            <div class="clearfix"></div>
            <div class="hrule"></div>
            <div class="section-title-common">
              ${_("Time Frame")}
            </div>

            <table class="table-common">
              <thead>
                <tr>
                  <td id="jDStartTm">${_("Start Time")}</td>
                  <td id="jDDuration">${_("Duration")}</td>
                  <td id="jDCompletionTm">${_("Completion Time")}</td>
                  <td id="jDActualDuration">${_("Actual")} ${_("Duration")}</td>
                </tr>
              </thead>
              <tbody>
                <tr>
                  <td style="width:170px;" id="jDStartDateTmVal">
                    ${entries['start_datetime']}
                  </td>
                  <td style="position: relative;" id="jDTime">
                      <input id="durInput" type="text" readonly name="duration" class="form_save_data"
                        value=${ duration_format } onkeypress="checkObjection(this,event)" />
                      <span id="infoPopUp" class="glyphicon glyphicon-time close-popover-link duration-link"
                        style="cursor: pointer">
                      </span><div id="durationContent" style="display:none" class="popover bottom">
                        <div class="arrow"></div>
                        <div class="popover-content">
                          <div>
        										<div class="durationBtn">
                              <input type="text" name="dInput" id="dInput" value="0" onkeyup="durationDay('dInput',0)"
                                class="pull-left clockDuration" onkeypress="checkObjection(this,event)">
                              <div class="buttonbig popbuttonbig">
                                <div class="incbutton"
                                  onmousedown="mousedownfunc('dInput', incrementDay)"
                                  onmouseup="mouseupfunc()">
                                </div>
                                <div class="decbutton"
                                  onmousedown="mousedownfunc('dInput', decrement, 'dInput')"
                                  onmouseup="mouseupfunc()">
                                </div>
                              </div>
										        </div>

										        <div class="durationBtn">
										          <input type="text" name="hInput" id="hInput" value="0" onkeyup="durationHour('hInput',0,23)"
                                class="pull-left clockDuration" onkeypress="checkObjection(this,event)">
										          <div class="buttonbig popbuttonbig">
                                <div class="incbutton"
                                  onmousedown="mousedownfunc('hInput', incrementHour)"
                                  onmouseup="mouseupfunc()">
                                </div>
                                <div class="decbutton"
                                  onmousedown="mousedownfunc('hInput', decrement, 'hInput')"
                                  onmouseup="mouseupfunc()">
                                </div>
                              </div>
										        </div>

										        <div class="durationBtn">
										          <input type="text" name="mInput" id="mInput" value="0" onkeyup="durationMinutes('mInput',0,59)"
                                class="pull-left clockDuration" onkeypress="checkObjection(this,event)">
										          <div class="buttonbig popbuttonbig">
                                <div class="incbutton"
                                  onmousedown="mousedownfunc('mInput', incrementMinutes)"
                                  onmouseup="mouseupfunc()">
                                </div>
                                <div class="decbutton"
                                  onmousedown="mousedownfunc('mInput', decrement, 'mInput')"
                                  onmouseup="mouseupfunc()">
                                </div>
                              </div>
										        </div>

										        <div class="durationBtn">
										          <input type="text" name="sInput" id="sInput" value="0" onkeyup="durationSeconds('sInput',0,59)"
                                class="pull-left clockDuration" onkeypress="checkObjection(this,event)">
										          <div class="buttonbig popbuttonbig">
                                <div class="incbutton"
                                  onmousedown="mousedownfunc('sInput', incrementSeconds)"
                                  onmouseup="mouseupfunc()">
                                </div>
                                <div class="decbutton"
                                  onmousedown="mousedownfunc('sInput', decrement, 'sInput')"
                                  onmouseup="mouseupfunc()">
                                </div>
                              </div>
										        </div>
                          </div>
                          <div class="clearfix"></div>
                          <div class="labels">
                              <span>days</span>
                              <span>hours</span>
                              <span>min</span>
                              <span>sec</span>
                          </div>
                          <div class="cta">
                              <input type="button" id="btnCancel"  onclick="cancelpopover()" class="btn btn-default" value="${_("Cancel")}">
                              <input type="button" id="btnClear"  class="btn btn-default" value="${_("Clear")}" onclick="clearpopover()">
                              <input type="button" id="btnApply"  class="btn btn-default" onclick="durationContent()" value="${_("Apply")}">
                          </div>
                        </div>
                      </div>
                    </td>
                    <td id="jDCompleteionTmVal">
                      ${entries['completion_datetime']}
                    </td>
                    <td id="jDActualFormatVal">
                      ${actualduration_format}
                    </td>
                  </tr>
                </tbody>
            </table>
          </div>



          <div class="col-xs-6" style="padding-left: 20px;">
            <div class="section-title-common">
              ${_("Data Management")}
            </div>

            <div class="row">
              <div class="col-xs-6 left-sub-section">Execution Path</div>
              <div class="col-xs-6 right-sub-section ffld">
                <span class="path" title="${ entries['initial_working_directory'] }">${ entries['initial_working_directory'] }</span>
                %if entries['initial_working_directory'] is not None:
                  <a class="path-link" title="Go to File Manager" id="init-path-link"
                        data-path="${ entries['initial_working_directory'] }"
                        href="/file-manager/?path=${ entries['initial_working_directory'] }">...</a>
                %endif
              </div>
            </div>

            <div class="row">
              <div class="col-xs-6 left-sub-section output-path-label">Output Path</div>
              <div class="col-xs-6 right-sub-section ffld">
                <span class="path" title="${ entries['standard_output_file_path'] }">${ entries['standard_output_file_path'] }</span>
                %if  entries['standard_output_file_path'] is not None:
                  <a class="path-link" title="Go to File Manager" id="output-path-link"
                        data-path="${ entries['standard_output_file_path'] }"
                        href="/file-manager/?path=${ entries['standard_output_file_path'] }">...</a>
                %endif
              </div>
            </div>

            <div class="row">
              <div class="col-xs-6 left-sub-section error-path-label">Error Path</div>
              <div class="col-xs-6 right-sub-section ffld">
                <span class="path" title="${ entries['standard_error_file_path'] }">${ entries['standard_error_file_path'] }</span>
                %if entries['standard_error_file_path'] is not None:
                  <a class="path-link" title="Go to File Manager" id="error-path-link"
                        data-path="${ entries['standard_error_file_path'] }"
                        href="/file-manager/?path=${ entries['standard_error_file_path'] }">...</a>
                %endif
              </div>
            </div>
          </div>


          <div class="col-xs-6" style="padding-right: 20px;">
              <div class="row">
                <div class="section-title-common otherinfo-bar">
                  ${_("Other Information")}
                </div>
              </div>
              <div class="row">
                <div class="col-xs-6 left-sub-section" id="jDPartitionAccess">${_("Partition Access List")}</div>
                <div class="col-xs-6 right-sub-section ffld" id="jDPartitionAccessList">
                    ${entries['partition_access_list']}
                </div>
              </div>
              <div class="row">
                <div class="col-xs-6 left-sub-section" id="jDStartCount">${_("Start Count")}</div>
                <div class="col-xs-6 right-sub-section ffld" id="jDStartCountVal">
                    ${entries['start_count']}
                </div>
              </div>
          </div>



            <div class="col-xs-12">
                <div class="hrule"></div>
                <div class="row">
                  <div class="col-xs-12 req-summary-bar">
                    <div class="req-summary-title">
                      Resource Requirement Summary
                    </div>
                  </div>
                </div>
                <div class="row">
                  <div class="col-xs-6">
                    <div class="row">
                        <div class="col-xs-6 left-sub-section">Total Cores Requested</div>
                        <div class="col-xs-6 right-sub-section ffld processors-per-task">
                            ${requirements_summary.get('total_dedicated_processors', 'N/A')}
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-xs-6 left-sub-section">Total Memory Requested</div>
                        <div class="col-xs-6 right-sub-section ffld memory_requested">
                            ${requirements_summary.get('memory_byte', 'N/A')}
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-xs-6 left-sub-section">Total Swap Requested</div>
                        <div class="col-xs-6 right-sub-section ffld swap_requested">
                            ${requirements_summary.get('swap_byte', 'N/A')}
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-xs-6 left-sub-section">Total Disk</div>
                        <div class="col-xs-6 right-sub-section ffld disk_requested">
                            ${requirements_summary.get('disk_byte', 'N/A')}
                        </div>
                    </div>

                    <div class="row">
                        <div class="col-xs-6 left-sub-section">Features</div>
                        <div class="col-xs-6 right-sub-section ffld features_requested">
                            %if 'features' in requirements_summary and requirements_summary['features']:
                                %for i in requirements_summary['features']:
                                   <span class="label label-primary ffld">${i.strip()}</span>
                                %endfor
                            %else:
                                N/A
                            %endif
                        </div>
                    </div>
                  <div class="row" style='display: none'>
                      <div class="col-xs-6 left-sub-section">${_("Scheduled Features")}</div>
                      <div class="col-xs-6 right-sub-section ffld" style="padding: 0">
                        <div class="features job-details">
                          N/A
                        </div>
                      </div>
                  </div>
                  <div class="row" style='display: none'>
                      <div class="col-xs-6 left-sub-section">${_("Excluded Features")}</div>
                      <div class="col-xs-6 right-sub-section ffld" style="padding: 0">
                        <div class="features job-details">
                          N/A
                        </div>
                      </div>
                  </div>
                </div>

                <div class="col-xs-6">
                    <div class="row">
                        <div class="col-xs-6 left-sub-section">Total Nodes Requested</div>
                        <div class="col-xs-6 right-sub-section ffld nodes_requested">
                            ${requirements_summary.get('nodes', 'N/A')}
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-xs-6 left-sub-section">Allocated Node List</div>
                        <div class="col-xs-6 right-sub-section ffld allocated-nodelist">
                            %if 'nodelist_allocated' in requirements_summary and requirements_summary['nodelist_allocated']:
                                %for count,i in enumerate(requirements_summary['nodelist_allocated']):
                                    <span class="label label-primary ffld" title="${ i }" id="allocatednode${ count }">${ i }</span>
                                %endfor
                            %else:
                              N/A
                            %endif
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-xs-6 left-sub-section">Allocated Node Count</div>
                        <div class="col-xs-6 right-sub-section ffld allocated_node_count">
                            ${requirements_summary.get('allocated_node_count', 'N/A')}
                        </div>
                    </div>
                    <div class="row">
                       <div class="col-xs-6 left-sub-section">Allocated Partition</div>
                       <div class="col-xs-6 right-sub-section ffld allocated_partition">
                         ${requirements_summary.get('allocated_partition', 'N/A')}
                       </div>
                    </div>
                    <div class="row">
                       <div class="col-xs-6 left-sub-section">Operating System</div>
                       <div class="col-xs-6 right-sub-section ffld operating_system">
                         ${requirements_summary.get('operating_system', 'N/A')}
                       </div>
                    </div>
                    <div class="row">
                       <div class="col-xs-6 left-sub-section">Architecture</div>
                       <div class="col-xs-6 right-sub-section ffld requested_architecture">
                         ${requirements_summary.get('architecture', 'N/A')}
                       </div>
                    </div>
                    <div class="row">
                        <div class="col-xs-6 left-sub-section">Total Generic Resources</div>
                        <div class="col-xs-6 right-sub-section ffld generic_resources">
                          %if 'generic_resources' in requirements_summary and requirements_summary['generic_resources']:
                              <table class="table-common">
                                <thead>
                                  <tr>
                                    <td>Name</td>
                                    <td>Count</td>
                                  </tr>
                                </thead>
                                <tbody>
                                  %for gres in requirements_summary['generic_resources']:
                                    <tr>
                                      <td class="gres-name">${gres}</td>
                                      <td>${requirements_summary['generic_resources'][gres]}</td>
                                    </tr>
                                  %endfor
                                </tbody>
                              </table>
                          %else:
                            N/A
                          %endif
                        </div>
                    </div>
                </div>
              </div>

              %if requirements_details:
                <div class="col-xs-12 req-details-bar">
                  <div class="req-details-title">
                    <span id="jobCollapse" class="glyphicon glyphicon-chevron-right show-all" title="Show Details"></span>
                    Requirement Details
                  </div>
                  <div class="req-details-body navbar navbar-default reqDetails panel-collapse collapse">
                    %for i in xrange(len(requirements_details)):
                      <div class="col-xs-12">
                        <div class="row">
                          <div class="panel panel-default">
                            <div class="taskRequirementsTitle">
                                Requirement ${i + 1}
                            </div>
                            <div class="taskRequirementsBody" id="req-detail-${i}">
                              <div class="row">
                                <div class="col-xs-6">
                                  <div class="col-xs-5 req-item" >Cores</div>
                                  <div class="col-xs-7 req-item ffld processors-per-task" >${requirements_details[i].get('total_dedicated_processors', 'N/A')}</div>
                                  <div class="col-xs-5 req-item">Memory</div>
                                  <div class="col-xs-7 req-item ffld memory_requested" >${requirements_details[i].get('memory_byte', 'N/A')}</div>
                                  <div class="col-xs-5 req-item">Swap</div>
                                  <div class="col-xs-7 req-item ffld swap_requested" >${requirements_details[i].get('swap_byte', 'N/A')}</div>
                                  <div class="col-xs-5 req-item">Disk</div>
                                  <div class="col-xs-7 req-item ffld disk_requested">${requirements_details[i].get('disk_byte', 'N/A')}</div>
                                  <div class="col-xs-5 req-item ">Features:</div>
                                  <div class="col-xs-7 req-item ffld features_requested">
                                  %if 'features' in requirements_details[i] and requirements_details[i]['features']:
                                    %for feature in requirements_details[i]['features']:
                                      <span class="label label-primary ffld">${feature}</span>&nbsp;
                                    %endfor
                                  %else:
                                    <span class="ffld"> N/A </span>
                                  %endif
                                  </div>
                                </div>
                                <div class="col-xs-6">
                                  <div class="col-xs-5 req-item">Generic Resources</div>
                                  %if 'generic_resources' in requirements_details[i] and requirements_details[i]['generic_resources']:
                                    <div class="col-xs-7 req-item generic_resources">
                                      <table class="table-common">
                                        <thead>
                                          <tr>
                                            <td>Name</td>
                                            <td>Count</td>
                                          </tr>
                                        </thead>
                                        <tbody>
                                          %for gres in requirements_details[i]['generic_resources']:
                                            <tr>
                                              <td class="gres-name">${gres}</td>
                                              <td>${requirements_details[i]['generic_resources'][gres]}</td>
                                            </tr>
                                          %endfor
                                        </tbody>
                                      </table>
                                    </div>
                                  %else:
                                    <div class="col-xs-7 req-item ffld generic_resources">N/A</div>
                                  %endif
                                </div>
                              </div>
                            </div>
                          </div>
                        </div>
                      </div>
                    %endfor
                  </div>
                </div>
              %endif
    </div><!-- .row ends -->



    %if not requirements_details:
      <div class="col-xs-12">
        <div class="hrule"></div>
      </div>
    %endif


      <div class="row">
        <div class="col-xs-12">
            <input type="hidden" name="prvpath" id="prvpath">
            <div class="pull-right bottom-buttons-container">
                <button type="button" id="goback" class="btn btn-primary normprimary">
                  ${_("Go Back")}</button>
                %if allow_changes:
                  <button type="submit" class="btn btn-primary normprimary" value="Done" id="jDDoneBtn">
                    ${_("Done")}
                  </button>
                  <button type="submit" class="btn btn-primary normprimary" value="Apply" id="jDApplyBtn">
                    ${_("Apply")}
                  </button>
                  <input type="hidden" name="action" id="actionField"></input>
                  <input type="hidden" name="priority-only" id="priorityOnly"></input>
                %endif
            </div>
        </div>
      </div>
    </form>
    </div>
% else:
    <div><h5>${ entries  } </h5></div>
%endif
</%def>

<%def name="end_script()">
</%def>
