## Copyright (c) 2016 by Adaptive Computing Enterprises, Inc. All Rights Reserved.

<%! from django.utils.translation import ugettext as _ %>

<table class="table" data-total-count="${total_count}">
  <thead>
  <tr>
		<th id="job_name" width="90" onclick="onSort(this)" class="sort" >${_("Job ID")}</th>
		<th id="job_custom_name" width="95" onclick="onSort(this)" class="sort" >${_("Job Name")}</th>
		<th id="user_name" width="95" onclick="onSort(this)" class="sort">${_("Submitter ID")}</th>
		<th id="job_start_datetime" width="95" class="sort" onclick="onSort(this)">${_("Start Date")}</th>
		<th id="job_submit_datetime" width="95" class="sort" onclick="onSort(this)">${_("Submit Date")}</th>
		<th id="job_state" width="90" class="sort" onclick="onSort(this)">${_("Job Status")}</th>
		<th width="45" class="text-center sort" id="processor_count" onclick="onSort(this)">${_("Cores")}</th>
		<th width="45" class="text-center sort" id="node_count" onclick="onSort(this)">${_("Nodes")}</th>
		<th id="wallclock_seconds" width="80" class="sort" onclick="onSort(this)">${_("Wall Clock")}</th>
  </tr>
  </thead>

  <tbody>
% if status_code == 2000 :
	% if entries :
		% for count,entry in enumerate(entries):
                    %if entry['is_array_master']:
                        <tr class="master-job" data-jobName="${entry['job_id']}">
                    %else:
                        <tr>
                    %endif

					<td>

					%if hasAccessforjobdetails('Job Details'):
						<a href="/jobdetails/?job_name=${ entry['job_id'] }&job_status=${ entry['job_state'] }&job_id=${entry['uChartjobId']  }&tab=${ active  }" class="job-id-link" id="jobName${ count }" title="${entry['job_id']}">${entry['job_id']}</a>
					%else:
						<a id="jobName${ count }" class="job-id-link">${ entry['job_id'] }</a>
					%endif
					%if canShowJobPopup(entry):
						% if entry['job_state'] in ('RUNNING','SUSPENDED','DEFERRED','BLOCKED','NOTQUEUED','STAGING','STARTING'):
							<button id="infoPopUp" type="button" class="popmenu close-popover-link" rel="popover" data-placement="right" data-content="" data-trigger="hover"></button>

							<div id="popoverContent" style="display:none">
								<a href="#" id= "cancel" title="${entry['job_id']  }" onclick="JavaScript:onStatusClick('cancel','${entry['job_id']  }')" style="display:block;" >Cancel</a>
							</div>
						% elif entry['job_state'] in ('IDLE', 'UNKNOWN'):

							<button id="infoPopUp" type="button" class="popmenu close-popover-link" rel="popover" data-placement="right" data-content="" data-trigger="hover"></button>

							<div id="popoverContent" style="display:none">
								<a href="#" id= "hold" title="${entry['job_id']  }" onclick="JavaScript:onStatusClick('hold','${entry['job_id']  }')" style="display:block;">${_("Hold")}</a>
								<a href="#" id= "cancel" title="${entry['job_id']  }" onclick="JavaScript:onStatusClick('cancel','${entry['job_id']  }')" style="display:block;" >${_("Cancel")}</a>
							</div>
						% elif entry['job_state'] == 'HOLD':

							<button id="infoPopUp" type="button" class="popmenu close-popover-link" rel="popover" data-placement="right" data-content="" data-trigger="hover"></button>

							<div id="popoverContent" style="display:none">
								<a href="#" id= "unhold" title="${entry['job_id']  }" onclick="JavaScript:onStatusClick('unhold','${entry['job_id']  }')" style="display:block;">Release</a>
								<a href="#" id= "cancel" title="${entry['job_id']  }" onclick="JavaScript:onStatusClick('cancel','${entry['job_id']  }')" style="display:block;" >Cancel</a>
							</div>
						% else:
							&nbsp;
						% endif

					%endif

				</td>

				<td width="95" id="customName${ count  }" class="ellipsis shortpad" title="${entry['job_custom_name']}">
					${ entry['job_custom_name'] }
				</td>
				<td width="95" id="userName${ count  }" class="ellipsis shortpad" title="${entry['user_name']}">${entry['user_name']  }</td>
				<td width="95" id="startDatetime${ count }" class="shortpad griddate">${entry['job_start_datetime']  }</td>
				<td width="95" id="startSubmittime${ count }" class="shortpad griddate">${ entry['job_submit_datetime'] }</td>
				<td width="90" id="jobStatus${ count }" class="ellipsis" title="${entry['job_state']}">${entry['job_state']  }</td>
				<td width="45" id="cores${ count }" class="text-center">${ entry['processor_count'] }</td>
				<td width="45" id="nodes${ count }" class="text-center">${ entry['node_count'] }</td>
				<td width="80" id="wallClock${ count  }" class="shortpad">
					<div title='${ entry['elapsed_time'] }'>
						${ entry['wallclock_seconds'] }
					</div>
				</td>
				</tr>
		% endfor
	% else :
		<tr id="NoRecordsFound">
		<td colspan="7"><h5>${_("No Records Found")} </h5></td>
		</tr>
	% endif 
% else:
	<tr id="NoRecordsFound">
		<td colspan="7"><h5>${ entries  } </h5></td>
	</tr>
% endif
  </tbody>  
  
</table>
<div class="grid-pagination">
	<div class="show-items">
		${_("Show")}
		<select id="viewPerPage" class="form-control page-views-select" onchange="onPageChange()">
				<option value="10">10</option>
				<option value="20">20</option>
				<option value="50">50</option>
				<option value="100">100</option>
				<option value="500">500</option>
				<option value="1000">1000</option>
		</select>
		${_("entries")}
	</div>
	<input type='hidden' id="pageNumber" />
	<input type="text" id="hiddenTotalCnt" style='display:none' value=${total_count}></input>
	<div class="paginator-container page-count pull-right">
	</div>
</div>
	<%def name="hasAccessforjobdetails(x)">
	%if x in perms:
		 <%return True%>
	%endif
	</%def>

    <%def name="canShowJobPopup(entry)">
        <%return (username == entry['user_name']) or ('Job Edit Admin' in perms)%>
    </%def>

<script type="text/JavaScript">
				
				 if (typeof google === "object" && typeof google.visualization === "object") {
					if($('#NoRecordsFound').length == 0)
					{
						drawUAreaChart();
					}
				  } else {
					google.load("visualization", "1", { packages:["corechart"] }); 
					google.setOnLoadCallback(drawUAreaChart);
				  }
				  
				function drawUAreaChart() {
				try{
								
								var i =0;
								$('.table>tbody>tr').each(function(){
								
								
								var	chartId = $(this).find('td:last>div>div').attr('id');
								var lblUtilizationPercentage = $(this).find('td:last>label');
								
								var divPopOverContent = $(this).find('#popoverContent');
								divPopOverContent.prop("id","popoverContent-" + i); 

								var btnInfoPopUp = $(this).find('#infoPopUp');
								btnInfoPopUp.prop("id","infoPopUp-" + i); 
								btnInfoPopUp.css("visibility","hidden");
								<%doc>
								// Commenting code for Utilization Charts --IRIS-293
								
								var imgSpinner = $(this).find('td:last>img');
								imgSpinner.prop("id","spinner" + chartId);
								lblUtilizationPercentage.prop("id","lbl" + chartId); 
								
								var utilizationPercentage ;
								$.ajax({
									url:'/rpc/getutilization/',
									type:'GET',
									data:{jobId:chartId},
									success:function(result){
											var jsonData = result;

											
											if (jsonData[1] == undefined){
												$('.table>tbody>tr').find('#spinner' + chartId).hide();
												//removing the spinner ends
												$('.table>tbody>tr').find('#lbl' + chartId).text("N/A");
												return;
											}
											
											if(jsonData[1].length != undefined || jsonData[1].length != null)
											{
												

													//pass the data array to google arrayToDataTable API.
													var data = google.visualization.arrayToDataTable(jsonData[1]);

													var options = {
														hAxis: {title: '',  titleTextStyle: {color: '#333'},minValue:1,maxValue:100,textPosition:'none',baselineColor:'#aaaaaa'},
														vAxis: {minValue: 0,maxValue:100, gridlines:{count:1}, titleTextStyle:{color:'white'},textPosition:'none'},
														legend: {position: 'none'},
														colors:["#ccc5ae"],
														areaOpacity:0.8,
														isStacked: true,
														animation:{
															duration: 2000,
															easing: 'out',
														},
														'tooltip' : {
															trigger: 'none'
														},
														enableInteractivity : false,
														height:70,
														width:100
													};
													var chart = new google.visualization.AreaChart(document.getElementById(chartId));
													chart.draw(data, options);
													
													//removing the spinner
													if($('.table>tbody>tr').find('#spinner' + chartId) != null)
													{
														
														$('.table>tbody>tr').find('#spinner' + chartId).hide();
													}
													//removing the spinner ends
													//Adding the Chart utilization % value starts
													if($('.table>tbody>tr').find('#lbl' + chartId) != null)
													{
														
														$('.table>tbody>tr').find('#lbl' + chartId).text(jsonData[0]);
													}
													//Chart utilization % value ends

												}
												else
												{
													
													//removing the spinner
													if($('.table>tbody>tr').find('#spinner' + chartId) != null)
													{
														$('.table>tbody>tr').find('#spinner' + chartId).hide();
													}
													//removing the spinner ends

													$('.table>tbody>tr').find('#lbl' + chartId).text("N/A");
														
														
												}
											}											
										}); </%doc>
									
									i++;
									});// each() ends
									
								}
								catch(e)
								{
									
								}
							} 
</script>


<script type="text/JavaScript">

$(document).ready(function() {
	$(function() {
		$('[rel = popover]').popover({
			html:true,
			trigger: "click",
			content: function(){
				var arr = $(this).attr('id').split('-');
				return $('#popoverContent-'+arr[1]).html();
			}
		});
	});
	//Added for IRIS-850 starts
	// Modified for IRIS-859 starts
	 $(".number-input ").on("keypress keyup blur",function (event) {    
       reg = /^[\-]?[0-9]+$/;
        if ((event.which > 31 && event.which < 48 || event.which > 57)) {
            event.preventDefault();
        }
    });
    // Modified for IRIS-859 ends
    //Added for IRIS-850 ends
});
</script>

<script>
$( "button").click(function() {
  var arr = $(this).attr('id').split('-');
  if(arr[0] == 'infoPopUp')
  {
		$('#infoPopUp-'+arr[1]).popover();
  }
});
$("#dataGrid .table tbody tr").on({
	mouseenter:function() {
		$(this).find("button[rel = popover]").css("visibility","visible")
	},
	mouseleave: function() {
		$(this).find("button[rel = popover]").popover("hide");
		$(this).find("button[rel = popover]").css("visibility","hidden")
	}
});
</script>
<script type="text/javascript">
	function onStatusClick(status, jobId) {
		var changeStatus = status;
		$('#loaderDiv').show();
		$('#loaderDiv').html('<div id="err preloader" class="preloader"></div>');
		$.ajax({
			url: '/modifyjob/',
			type: 'GET',
			data: {jobId: jobId, changeStatus: changeStatus },
			success: function (result) {
				$('#errorMsg').hide();
				$('#statusMsg').hide();
				var lastIndex = result.lastIndexOf(",");
				if (lastIndex == -1) {
					lastIndex = result.length;
				}
				var message = result.substring(0, lastIndex).trim();
				var statusMsg = result.substring(lastIndex + 1).trim();
				if (statusMsg == "success") {
					$('#statusMsg').html('<a href="#" id="crossBtn" class="close" onClick="tryMe()">&times;</a>');
					$('#loaderDiv').hide();
					// Show hide alert message
					if($('#myAlert').length > 0 ) {
						$('#myAlert'). hide(); 
					}	
					$('#statusMsg').show();
					$('#statusMsg').append(message);
				}
				else {
					$('#statusMsg').html('<a href="#" id="crossBtn" class="close" onClick="tryMe()">&times;</a>');
					$('#statusMsg').css('background-color', '#f2dede');
					$('#statusMsg').css('color', '#a94442');
					$('#loaderDiv').hide();
					// Show hide alert message
					if($('#myAlert').length > 0 ) {
						$('#myAlert'). hide(); 
					}
					$('#statusMsg').show();
					$('#statusMsg').append(message);
				}
			}
		});
	}
</script>

<script type="text/javascript">
	function tryMe(){
		$('#statusMsg').hide();
	};
	function tryMeforerror(){
        $('#errorMsg').hide();
    }
</script> 



