## Copyright (c) 2016 by Adaptive Computing Enterprises, Inc. All Rights Reserved.

<%! from django.utils.translation import ugettext as _ %>
<%! from frontend_utils.utils import capitalize_first_letter_filter as first_upper %>
 <%inherit file="base.mako" />
 
<%def name="title()">${_("Viewpoint Workload")}</%def>

<%def name="head_tags()">
	<link rel="stylesheet" type="text/css" href="../static/subjobs_widget/css/subjobs_widget.min.css"/>
	<link rel="stylesheet" type="text/css" href="../static/datatables/media/css/jquery.dataTables.min.css"/>

    <style type="text/css">
      .datagrid-container .table .job-arr-widget td a {
        width: auto;
      }
    </style>

</%def>

<%def name="jquery_tags()">
  <script src="../static/jquery-bootpag/lib/jquery.bootpag.js" type="text/javascript"></script>
  <script src="../static/api/js/api.js" type="text/javascript"></script>
  <script src="../static/api/js/loader.js" type="text/javascript"></script>
  <script src="../static/subjobs_widget/js/subjobs-widget.js" type="text/javascript"></script>
  <script src="../static/legacy/js/jobs.js" type="text/javascript"></script>
  <script src="../static/iris/js/workload-table.js" type="text/javascript"></script>
  <script src="/static/datatables/media/js/jquery.dataTables.min.js" type="text/javascript"></script>
  <script src="../static/js-url/url.min.js" type="text/javascript"></script>
  <script src="../static/iris/js/main.js"></script>

	<script type="text/javascript">
		google.load("visualization", "1", {packages:["corechart"]});
	</script>

	<script type="text/javascript">
		$(document).ready(function() {
	  $('[data-toggle="tooltip"]').tooltip();
	  if (window.location.hash === "#job-does-not-exist") {
        $.notify('We apologize for the delay, the job is still being initialized and might take\
		   a few seconds for Insight to catch up. This might mean that Insight is overloaded.\
			Please refer to our documentation if the problem persists.', {type: 'info'});
      }
		});
	</script>

<link rel="stylesheet" type="text/css" href="/static/legacy/css/datepicker.css" />
<script src="../static/legacy/js/bootstrap-datetimepicker.js" type="text/javascript"></script>

</%def>

<%def name="main_content()">
	<div class="row">
		<div id="workload" class="col-xs-8">
			%if messages:
				%if status == "200":
    				<div class="alert alert-success" id="myAlert">
    				<a href="#" class="close" data-dismiss="alert">&times;</a>
    					${ "<br />".join(str(messages).split(",")) | n,decode.utf8,first_upper }
    				</div>
        	    %else:
        	       <div class="alert alert-danger" id="myAlert">
                    <a href="#" class="close" data-dismiss="alert">&times;</a>
                        ${ "<br />".join(str(messages).split(",")) | n,decode.utf8,first_upper  }
                    </div>
        	    %endif
			%endif
			<div class="col-xs-12 section-header padlt">
			<h1><b>${_("Workload")}</b>
					<span class="refresh" id="workloadRefresh" title="Refresh"></span>
			</h1>
			%if not user.is_superuser and 'Create Job' in perms:
				<%include file="job_type_dialog.html"/>
			%endif
              <div class="intervalDiv pull-right">
                <label class="intervalLabel">Refresh Interval</label>
                <select name="intervals" id="selectIntervals" class="form-control selectIntervals">
                  <option value="OFF">OFF</option>
                  <option value="5000">5s</option>
                  <option value="15000" selected>15s</option>
                  <option value="30000">30s</option>
                  <option value="60000">60s</option>
                  <option value="300000">5m</option>
                </select>
              </div>
			</div>
			<%include file="workload_table.html"/>

				<!--<span class="right-icon-section">
					<button type="button" class="btn btn-primary" disabled>
						<span class="glyphicon glyphicon-plus"></span>&nbsp;&nbsp;&nbsp;${_("Create Reservation")}
					</button>
				</span>-->
				<!--<div class="pull-right" style="margin-top:5px;">
					<span class="icon-grid" ></span>
					<a href="/resourceJobTimeline/" title="Resource Job Timeline">
						<span class="icon-timeline" ></span>
					</a>
				</div>-->
			<div class="clearfix"></div>
			<div>
				<input type="text" id="hiddenstatusCode" style='display:none' value=${ statusCode  }></input>
				<div class= "alert alert-success" style= "display: none" id="statusMsg">
				</div>
				<div style="display:none;" id="loaderDiv">
				</div>
			</div>
		</div>
		<div class="col-xs-4 search-filter-section padLeft">
			<h5><b>${_("Current Search")}: </b><strong><label id='totalJobsCnt' class="srchCount"></label></strong></h5>
			<div id="searchValues">

			</div>
			<span>
				<select id="searchCat" class="form-control" onChange="$('#searchBox').focus()">
					<option value="select" id="opt0">- ${_("Select")} -</option>
					<option id="opt1" value="job_name">Job ID</option>
          %if 'update-jobs-any' in perms and 'Job View All' in perms and 'read-insight-privileged' in perms:
            <option id="opt2" value="user_name">Submitter ID</option>
          %endif
          			<option id="opt3" value="job_custom_name">Job Name</option>
				</select>
			</span>

      <div class="input-group search-group">
        <!--<input id="searchBox" type="text" class="form-control search"-->
          <!--onclick="clearValue(this)"-->
          <!--placeholder="${_("Narrow Search")}"-->
          <!--onkeypress="addFilter(this,event,true)" />-->
		  <input id="searchBox" type="text" class="form-control search"
          onclick="clearValue(this)"
          placeholder="${_("Narrow Search")}"/>
        <div class="input-group-btn">
          <button id="searchBtn" type="button" class="btn btn-primary normprimary search-btn">
            <span class="glyphicon glyphicon-search search-btn">
            </span>
          </button>
        </div>
      </div>

			<h5 class="filter">${_("Filters")}</h5>
			<span>
				<select id="queueStatus" class="form-control">
					<option value="">${_("- Select Queue Status -")}</option>
					%if workload_filter:
						% for i in workload_filter:
							<option value="${ i  }">${ i  }</option>
						% endfor
					%endif
				</select>
			</span>
			<div>
				<select id="jobType" class="form-control">
					<option value="" >${_("- Select Job Type -")}</option>
					<option value="arrays">${_("Arrays Only")}</option>
					<option value="common">${_("Regular Jobs Only")}</option>
				</select>
			</div>
			<div class="col-xs-12">
<%doc>
# Commenting code to remove priority columns --IRIS-455
<div class="col-xs-6">
<div class="form-group">
<label class="labelfilter">Priority</label>
        <input type="text" name="From" id="priorityFrom" value="0" class="form-control number-input"   onkeypress="checkObjection(this,event)">
        <div class="buttonbig"><div class="incbutton" onclick="increment('priorityFrom')"></div><div class="decbutton" onclick="decrement('priorityFrom')"></div></div>
        </div>
        </div>
        <div class="col-xs-6">
<div class="form-group">
<label class="labelfilter1">To</label>
        <input type="text" name="From" id="priorityTo" value="0" class="form-control number-input"   onkeypress="checkObjection(this,event)">
        <div class="buttonbig"><div class="incbutton" onclick="increment('priorityTo')"></div><div class="decbutton" onclick="decrement('priorityTo')"></div></div>
        </div>
        </div>
</%doc>
        </div>

        <div class="clearfix"></div>
<%doc>
# Commenting code to remove rank columns --IRIS-309
		 <div class="col-xs-12">
<div class="col-xs-6">

<div class="form-group">
<label class="labelfilter">Rank</label>
        <input type="text" name="From" id="rankFrom" value="0" class="form-control number-input"  onkeypress="checkObjection(this,event)">
        <div class="buttonbig"><div class="incbutton" onclick="increment('rankFrom')"></div><div class="decbutton" onclick="decrement('rankFrom')"></div></div>
        </div>
        </div>
        <div class="col-xs-6">

<div class="form-group">
<label class="labelfilter1">To</label>
        <input type="text" name="From" id="rankTo" value="0" class="form-control number-input" onkeypress="checkObjection(this,event)">
        <div class="buttonbig"><div class="incbutton" onclick="increment('rankTo')"></div><div class="decbutton" onclick="decrement('rankTo')"></div></div>
        </div>
        </div>
        </div>
</%doc>
        <div class="clearfix"></div>
			<!--<span>
				<label class="rPadding15">${_("Priority")}</label>
				<input id="priorityFrom" type="number" class="form-control number-input" min="0"  value="0" onkeypress="checkObjection(this,event)"/>
				${_("To")} <input id="priorityTo" type="number" class="form-control number-input"  min="0" value="0" onkeypress="checkObjection(this,event)"/>
			</span>
			<span class="clearfix">
				<label class="rPadding15">${_("Rank")}</label>
				<input id="rankFrom" type="number" class="form-control number-input"  min="0"  value="0" onkeypress="checkObjection(this,event)"/>
				${_("To")} <input id="rankTo" type="number" class="form-control number-input" min="0"  value="0" onkeypress="checkObjection(this,event)"/>
			</span> -->
			<span>
				<!-- <input type="checkbox"> -->
				<select id="dateTimeRange" class="form-control">
							<option id="opt0" value="">- ${_("Select")} -</option>
							<option value="startdate">${_("Start Date")}</option>
							<option value="wallclock">${_("Wall Clock")}</option>
						</select>
						<div class="start-date">
							<label>${_("Start Date")}</label>
							<div id="startDate" class="input-append date">
								<input id="txtStartDate" data-format="yyyy-MM-dd hh:mm:ss" class="form-control" type="text"/>
								<span class="add-on icon">
									<i data-time-icon="glyphicon glyphicon-time" data-date-icon="glyphicon glyphicon-calendar" class="glyphicon glyphicon-calendar" id="workload_startDate">
									</i>
								</span>
							</div>
							<label>${_("To")}</label>
							<div id="endDate" class="input-append date">
								<input id="txtEndDate" data-format="yyyy-MM-dd hh:mm:ss" class="form-control" type="text"/>
								<span class="add-on icon">
									<i data-time-icon="glyphicon glyphicon-time" data-date-icon="glyphicon glyphicon-calendar" class="glyphicon glyphicon-calendar" id="workload_toDate">
									</i>
								</span>
							</div>
						</div><!-- //.start-date ends -->
						<div class="wall-clock">
							<span id="wallclockStart">
							
							
							<div class="col-xs-12">
								<span>${_("From")}</span>
								<div class="col-xs-6">
									<div class="clearfix"></div>
									<div class="form-group">
										<label class="labelfilter">Day</label>
											<input type="text" class="form-control number-input" min="0"  value="0" onkeypress="checkObjection(this,event)" id="day">
										<div class="buttonbig"><div class="incbutton" onmousedown="mousedownfunc('day', increment)" onmouseup="mouseupfunc()"></div><div class="decbutton" onmousedown="mousedownfunc('day', decrement, 'day')" onmouseup="mouseupfunc()"></div></div>
									</div>
								</div>
								<div class="col-xs-6">
									<div class="form-group">
										<label class="labelfilter1">Hr</label>
											<input type="text"	class="form-control number-input" id="hr" min="0"  value="0" onkeypress="checkObjection(this,event)"> 
											<div class="buttonbig"><div class="incbutton" onmousedown="mousedownfunc('hr', increment)" onmouseup="mouseupfunc()"></div><div class="decbutton" onmousedown="mousedownfunc('hr', decrement, 'hr')" onmouseup="mouseupfunc()"></div></div>
										</div>
									</div>
								</div>
								<div class="clearfix"></div>
								
							<div class="col-xs-12">
								<div class="col-xs-6">
									<div class="form-group">
									
										<label class="labelfilter">Min</label>
											<input type="text" class="form-control number-input"id="min" min="0"  value="0" onkeypress="checkObjection(this,event)">
										<div class="buttonbig"><div class="incbutton" onmousedown="mousedownfunc('min', increment)" onmouseup="mouseupfunc()"></div><div class="decbutton" onmousedown="mousedownfunc('min', decrement, 'min')" onmouseup="mouseupfunc()"></div></div>
									</div>
								</div>
								<div class="col-xs-6">
									<div class="form-group">
										<label class="labelfilter1">Sec</label>
											<input type="text"	class="form-control number-input" id="sec" min="0"  value="0" onkeypress="checkObjection(this,event)"> 
											<div class="buttonbig"><div class="incbutton" onmousedown="mousedownfunc('sec', increment)" onmouseup="mouseupfunc()"></div><div class="decbutton" onmousedown="mousedownfunc('sec', decrement, 'sec')" onmouseup="mouseupfunc()"></div></div>
										</div>
									</div>
								</div>
								<div class="clearfix"></div>
								<!-- <span>From</span>
								<span>
									<label>Day:</label><input type="number" id="day" min="0"  value="0" onkeypress="checkObjection(this,event)"/>
									<label>Hr:</label><input type="number" id="hr" min="0"  value="0" onkeypress="checkObjection(this,event)"/>
								</span>
								<span>
									<label>Min:</label><input type="number" id="min" min="0"  value="0" onkeypress="checkObjection(this,event)"/>
									<label>Sec:</label><input type="number" id="sec" min="0"  value="0" onkeypress="checkObjection(this,event)"/>
								</span> -->
							</span>
							<span id="wallclockEnd">
							
							<div class="col-xs-12">
								<span>${_("To")}</span>
								<div class="col-xs-6">
									<div class="clearfix"></div>
									<div class="form-group">
										<label class="labelfilter">Day</label>
											<input type="text" class="form-control number-input" min="0"  value="0" onkeypress="checkObjection(this,event)" id="today"/>
										<div class="buttonbig"><div class="incbutton"onmousedown="mousedownfunc('today', increment)" onmouseup="mouseupfunc()"></div><div class="decbutton" onmousedown="mousedownfunc('today', decrement, 'today')" onmouseup="mouseupfunc()"></div></div>
									</div>
								</div>
								<div class="col-xs-6">
									<div class="form-group">
										<label class="labelfilter1">Hr </label>
											<input type="text"	class="form-control number-input"  min="0"  value="0" onkeypress="checkObjection(this,event)" id="tohr"/>
											<div class="buttonbig"><div class="incbutton" onmousedown="mousedownfunc('tohr', increment)" onmouseup="mouseupfunc()"></div><div class="decbutton" onmousedown="mousedownfunc('tohr', decrement, 'tohr')" onmouseup="mouseupfunc()"></div></div>
										</div>
									</div>
								</div>
								<div class="clearfix"></div>
								
							<div class="col-xs-12">
								<div class="col-xs-6">
									<div class="form-group">
									
										<label class="labelfilter">Min</label>
											<input type="text" class="form-control number-input" min="0"  value="0" onkeypress="checkObjection(this,event)" id="tomin"/>
										<div class="buttonbig"><div class="incbutton" onmousedown="mousedownfunc('tomin', increment)" onmouseup="mouseupfunc()"></div><div class="decbutton" onmousedown="mousedownfunc('tomin', decrement, 'tomin')" onmouseup="mouseupfunc()"></div></div>
									</div>
								</div>
								<div class="col-xs-6">
									<div class="form-group">
										<label class="labelfilter1">Sec</label>
											<input type="text"	class="form-control number-input" min="0"  value="0" onkeypress="checkObjection(this,event)" id="tosec" />
											<div class="buttonbig"><div class="incbutton" onmousedown="mousedownfunc('tosec', increment)" onmouseup="mouseupfunc()"></div><div class="decbutton" onmousedown="mousedownfunc('tosec', decrement, 'tosec')" onmouseup="mouseupfunc()"></div></div>
										</div>
									</div>
								</div>
								<div class="clearfix"></div>

<!--<div class="wall-clock">
							<span id="wallclockStart">
								<span>${_("From")}</span>
								<span>
									<label>Day:</label><input type="number" id="day" min="0"  value="0" onkeypress="checkObjection(this,event)"/>
									<label>Hr:</label><input type="number" id="hr" min="0"  value="0" onkeypress="checkObjection(this,event)"/>
								</span>
								<span>
									<label>Min:</label><input type="number" id="min" min="0"  value="0" onkeypress="checkObjection(this,event)"/>
									<label>Sec:</label><input type="number" id="sec" min="0"  value="0" onkeypress="checkObjection(this,event)"/>
								</span>
							</span>
							<span id="wallclockEnd">
								<span>${_("To")}</span>
								<span>
									<label>Day:</label><input type="number" id="day" min="0"  value="0" onkeypress="checkObjection(this,event)"/>
									<label>Hr:</label><input type="number" id="hr" min="0" value="0" onkeypress="checkObjection(this,event)"/>
								</span>
								<span>
									<label>Min:</label><input type="number" id="min" min="0"  value="0" onkeypress="checkObjection(this,event)"/>
									<label>Sec:</label><input type="number" id="sec" min="0"  value="0" onkeypress="checkObjection(this,event)"/>
								</span>
							</span> -->
						</div> 
					</span>
					<div class="right-pane-buttons-container" style="margin-right: 28px;">
						<button type="button" class="btn btn-primary" id="workload_clearAllBtn">${_("Reset")}</button>
						<button type="button" class="btn btn-primary right" id="workload_filterBtn">${_("Filter")}</button>
					</div>
				</div>
			</span>
	</div>

</%def>

<%def name="end_script()">
	
</%def>
