## Copyright (c) 2016 by Adaptive Computing Enterprises, Inc. All Rights Reserved.

<%! from django.utils.translation import ugettext as _ %>
<%! from frontend_utils.utils import capitalize_first_letter_filter as first_upper %>
<%! from frontend_utils.utils import convert_to_gb as gb_convert %>
<%inherit file="base.mako" />

<%def name="title()">${_("Viewpoint Node Details")}</%def>

<%def name="head_tags()">


</%def>

<%def name="jquery_tags()">

<link rel="stylesheet" href="/static/select2/src/scss/core.css" />
<link rel="stylesheet" href="../static/api/css/loader.css"/>
<link rel="stylesheet" href="../static/iris/css/magicsuggest.css"/>
<link rel="stylesheet" href="../static/datatables/media/css/jquery.dataTables.min.css"/>
<link rel="stylesheet" type="text/css" href="../static/subjobs_widget/css/subjobs_widget.min.css"/>

<script src="../static/jquery-bootpag/lib/jquery.bootpag.js" type="text/javascript"></script>
<script src="/static/datatables/media/js/jquery.dataTables.min.js" type="text/javascript"></script>
<script src="../static/iris/js/main.js"></script>
<script src="../static/iris/js/magicsuggest.js"></script>
<script src="../static/api/js/api.js"></script>
<script src="../static/api/js/loader.js" type="text/javascript"></script>
<script src="/static/select2/dist/js/select2.full.js" type="text/javascript"></script>
<script src="/static/js-url/url.min.js" type="text/javascript"></script>
<script src="/static/legacy/js/nodes.js" type="text/javascript"></script>
<script src="../static/subjobs_widget/js/subjobs-widget.js" type="text/javascript"></script>
<script src="../static/iris/js/workload-table.js" type="text/javascript"></script>

<script type="text/javascript">
	$(document).ready(function() {
		$('#node_details_cancel_button').click(function() {
	    goto("nodelist");
		});

    var cpuVal = $('#node_details_cpu_utilization_value').text();
    if (!cpuVal || cpuVal == 'None%') {
      $('#node_details_cpu_utilization_value').text('N/A');
    }

    $(function() {
      var values = [];
      var valuesRep = [];
      var api = $('.features-container.api').data('api');
      var features;

      // transform python "config_features_json", "featurelist_json"
      // into javasript arrays
      var config_features = '${ config_features_json | n,decode.utf8 }';
      if (config_features) {
        config_features =  JSON.parse(config_features);
      }
      var featurelist = '${ featurelist_json | n,decode.utf8 }';
      if (featurelist) {
        featurelist =  JSON.parse(featurelist);
      }
      var nodeName = "${ entries[0]['name'] | n,decode.utf8 }";

      var featuresControl;
      var featuresControlValues;

      var featuresChanged = function() {
        if (!_.isEqual(featuresControlValues, featuresControl.getValue())) {
          var values = [];
          if (featuresControl.getValue()) {
            values = $.grep(featuresControl.getValue(), function(v) {
              return (valuesRep.indexOf(v) == -1);
            });
          }
          var data = {
            "featuresCustom": values
          };

          api.patch('/api/nodes/' + nodeName + '/', data)
            .done(function(){
              $.notify('Features have been successfully updated. Changes will be reflected after the next scheduling iteration',
                {
                  type: 'success'
                });
              featuresControlValues = featuresControl.getValue();
            });
        }    
      };

      api.get('/api/features/?page_size=9999')
        .done(function(data, textStatus, jqXHR) {
          var results = $.grep(data.results, function(val) {
              return (val);
          })
          featuresControl = $('#features-list').magicSuggest({
            data: results,
            value: values,
            reportedValues: valuesRep,
            allowFreeEntries: true,
            resultAsString: false,
            useSpaceKey: true,
            useTabKey: true,
            maxSelection: null,
            placeholder: 'Click here to add features'
          });
          $(featuresControl).on('acceptChanges', function() {
            featuresChanged();
          });
          featuresControlValues = featuresControl.getValue();
          if (nodeName == 'GLOBAL') {
            featuresControl.disable();
          }
      });

      var returnBackUrl = $('.return-to-earlier').data('href');
      var searchParams = {
        // Search
        'NodeID': '',
        'Class': '',
        'Features': '',
        'JobID': '',
        'ReservationID': '',
        // Filter
        'resourceState': '',
        'procsFrom': '',
        'procsTo': '',
        'processorFrom': '',
        'processorTo': '',
        'jobsFrom': '',
        'jobsTo': '',
        'proc_utilFrom': '',
        'proc_utilTo': '',
        'memory_utilFrom': '',
        'memory_utilTo': '',
        // Below Resource Job Timeline params
        'StartDate': '',
        'EndDate': '',
        'showJobs': '',
        'showReservation': '',
        'nodeJobCntFrom': '',
        'nodeJobCntTo': ''
      };
      for (var i in searchParams) {
        var param = $.url('?' + i);
        if (param) {
          returnBackUrl += '&' + i + '=' + param;
        }
      }
      $('.return-to-earlier').attr('href', returnBackUrl);


      // Collect features for displaying already applyed features for node
      if (featurelist) {
        $.each(featurelist, function(i, val) {
          values.push(val);
          valuesRep.push(val);
        });
      }

      if (config_features) {
        $.each(config_features, function(i, val) {
          values.push(val);
        });
      }
    });
	});
	disablecopypaste();

</script>
</%def>

<%def name="main_content()">
	<div class="row">
	% if status_code == 2000 :
		<form class="form-nodeDetail" role="form" method="post" action='/nodedetails/'>
			%if messages:
        %if status == "200":
        	<div class="alert alert-success" >
        			<a href="#" class="close" data-dismiss="alert">&times;</a>
        			${ messages | n,decode.utf8,first_upper }
        	</div>
        %else:
        	<div class="alert alert-danger">
              <a href="#" class="close" data-dismiss="alert">&times;</a>
              ${ messages | n,decode.utf8,first_upper }
          </div>
        %endif
			%endif
				<div class="pull-right back-link">
            <a class="return-to-earlier" data-href="${ hrefLoc }">${_("Return to earlier search")}</a>
        </div>
        <div class="clearfix"></div>

				<div class="col-xs-6">
					<h1><b>${_("Node Details")}</b></h1>
					<div class="row">
						<input type="hidden" name="node_name" value=${entries[0]['name']  } />
						<div class="col-xs-5 node-left-sub-section">${_("Name")}</div>
						<div id="node_details_name_value" class="col-xs-7 node-right-sub-section">${entries[0]['name']  }</div>
					</div>

					<div class="row">
						<div class="col-xs-5 node-left-sub-section">${_("State")}</div>
						<div id="node_details_state_value" class="col-xs-7 node-right-sub-section">${entries[0]['state']  }</div>
					</div>

					<div class="row">
						<div class="col-xs-5 node-left-sub-section">${_("Power")}</div>
						<div id="node_details_power_value" class="col-xs-7 node-right-sub-section">
              <span class="ico_on"></span>${ entries[0]['power_actual_state'] }
            </div>
					</div>

					<div class="row">
						<div class="col-xs-5 node-left-sub-section">Operating System</div>
						<div id="node_details_image_value" class="col-xs-7 node-right-sub-section">${entries[0]['image']}</div>
					</div>

					<div class="row">
						<div class="col-xs-5 node-left-sub-section">${_("Resource Managers")}</div>
						<div id="node_details_rm_value" class="col-xs-7 node-right-sub-section">
						%if torquelist:
							%for i in torquelist:
								${i  }<br />
							%endfor
						%endif
						</div>
					</div>

					<div class="row">
						<div class="col-xs-5 node-left-sub-section">${_("Jobs")}</div>
						<div id="node_details_jobs_value" class="col-xs-7 node-right-sub-section">${entries[0]['jobs']  }</div>
					</div>

					<div class="row">
						<div class="col-xs-5 node-left-sub-section">${_("Reservations")}</div>
						<div id="node_details_reservations_value" class="col-xs-7 node-right-sub-section">
              %if len(entries[0]['reservations']) > 0:
                <%
                  reservations = []
                  for reservation in entries[0]['reservations']:
                    reservations.append(reservation['name'])
                %>
                ${', '.join(reservations) }
              %else:
                None
              %endif
            </div>
					</div>
				</div><!-- .col-xs-6 ends -->

				<div class="col-xs-6">
					<h1><b>${_("Resources")}</b></h1>

					<div class="row">
						<div class="col-xs-5 node-left-sub-section">${_("Real Cores")}</div>
						<div id="node_details_real_procs_value" class="col-xs-7 node-right-sub-section">${entries[0]['real_processors']  }</div>
					</div>

					<div class="row">
						<div class="col-xs-5 node-left-sub-section">${_("Available Cores")}</div>
						<div id="node_details_available_procs_value" class="col-xs-7 node-right-sub-section">
              ${ entries[0]['available_processors'] }
            </div>
					</div>

					<div class="row">
						<div class="col-xs-5 node-left-sub-section">${_("Real Memory")} (GB)</div>
						<div id="node_details_real_mem_value" class="col-xs-7 node-right-sub-section">
              ${ entries[0]['real_memory_mb'] | gb_convert }
            </div>
					</div>

					<div class="row">
						<div class="col-xs-5 node-left-sub-section">${_("Available Memory")} (GB)</div>
						<div id="node_details_available_mem_value" class="col-xs-7 node-right-sub-section">
              ${ entries[0]['available_memory_mb'] | gb_convert }
            </div>
					</div>

					<div class="row">
						<div class="col-xs-5 node-left-sub-section">CPU ${_("Utilization")}</div>
						<div id="node_details_cpu_utilization_value" class="col-xs-7 node-right-sub-section">${entries[0]['cpu_utilization']  }%</div>
					</div>

					<div class="row">
					<div>
					<div class="dtGrid datagrid-container container panel panel-default mrlt" style="margin-left:0 !important;width:60%;">
						<table class="table table-bordered">
						<thead>
						<tr>
						<th width="80%">${_("Generic Resource")} </th>
						<th>${_("Count")} </th>
						</tr>
						</thead>
						<tbody>
						%if generic_resources:
							%for cnt,i in enumerate(generic_resources):
								<tr>
								<td><div id="genericResource${cnt  }" style="word-wrap: break-word;">${i['generic_resource']  }</div></td>
								<td id="count${cnt  }">${i['count']  }</td>
								</tr>
							%endfor
						%else:
							<tr>
								<td colspan=2 align="center" id="genericResource" >${_("No Generic Resources present for this node")}</td>
							</tr>
						%endif
						</tbody>
						</table>
					</div>
					</div>
					</div>
				</div><!-- .col-xs-6 ends -->
			</div>

      <div class="row node-row">
        <div class="col-xs-12">
          <div class="section-title-common">
            <h1><b>
              ${_("Features") }
            </b></h1>
          </div>          
          <div class="api features-container">
            <input id="features-list"/>
          </div>
        </div>
      </div>

      <div class="row node-row">

        <div class="row">
          <div class="col-xs-12 section-title-common">
            <h1><b>
              ${_("Node Jobs") }
            </b>
            <span id="workloadRefresh" class="refresh" title="Refresh"></span>
            </h1>
            <div class="intervalDiv pull-right">
              <label class="intervalLabel">Refresh Interval</label>
              <select name="intervals" id="selectIntervals" class="form-control selectIntervals">
                <option value="OFF">OFF</option>
                <option value="5000">5s</option>
                <option value="15000" selected>15s</option>
                <option value="30000">30s</option>
                <option value="60000">60s</option>
                <option value="300000">5m</option>
              </select>
            </div>
          </div>
        </div>

        <div class="col-xs-12">
          <%include file="workload_table.html"/>
        </div>
      </div>

			<div class="row node-row">
        <div class="col-xs-12">
          <div class="hrule"></div>
        </div>

				<div class="col-xs-6 paddTop10">&nbsp;</div>
				<div class="col-xs-6 paddTop10">
					<div style="float:right;clear:both">
					<button type="submit" id="node_details_cancel_button" class="btn btn-primary normprimary">${_("Close")}</button>
				</div>
			</div>
		</form>
% else:
	<div><h5>${ entries  } </h5></div>

%endif
	</div><!-- main .row ends -->
</%def>
<%def name="end_script()">
</%def>
