## Copyright (c) 2016 by Adaptive Computing Enterprises, Inc. All Rights Reserved.

<%! from django.utils.translation import ugettext as _ %>
<%! from frontend_utils.utils import capitalize_first_letter_filter as first_upper %>
<%inherit file="base.mako" />
<%def name="title()">${_("Node List")}</%def>
<%def name="head_tags()">
    <link rel="stylesheet" type="text/css" href="../static/datatables/media/css/jquery.dataTables.min.css"/>
    <link rel="stylesheet" type="text/css" href="../static/api/css/loader.css"/>
    <style type="text/css">
</style>
</%def>
<%def name="jquery_tags()">
    <script src="/static/jquery-bootpag/lib/jquery.bootpag.js" type="text/javascript"></script>
	<script src="/static/legacy/js/nodes.js" type="text/javascript"></script>
	<script src="../static/iris/js/node-table.js" type="text/javascript"></script>
	<script src="../static/iris/js/main.js"></script>
	<script src="/static/datatables/media/js/jquery.dataTables.min.js" type="text/javascript"></script>
    <script type="text/javascript">
        google.load("visualization", "1", {packages:["corechart"]});
		function returnDefaultIfNullOrEmpty(data,returnIfNullOrEmpty){
			if(data == undefined || data == null || data.trim() == "" || data.trim() == "null"){
				return returnIfNullOrEmpty;
			}else {
				return data;
			}
		}
    </script>
    <link rel="stylesheet" type="text/css" href="/static/legacy/css/datepicker.css" />
    <script src="/static/legacy/js/bootstrap-datetimepicker.js" type="text/javascript"></script>

</%def>

<%def name="main_content()">
    <div class="row">
        <div id="nodes" class="col-xs-8">
            %if messages:
                %if status == "200":
                    <div class="alert alert-success" id="myAlert">
                        <a href="#" class="close" data-dismiss="alert">&times;</a>
                        ${ messages | n,decode.utf8,first_upper}
                    </div>
                %else:
                    <div class="alert alert-danger" id="myAlert">
                        <a href="#" class="close" data-dismiss="alert">&times;</a>
                        ${ messages | n,decode.utf8,first_upper}
                    </div>
                %endif
            %endif

            <div class="col-xs-6 section-header padlt">
                <h1><b>${_("Nodes")}</b>
                    <span class="refresh" id="resourceListRefresh" title="Refresh"></span>
                </h1>
            </div>

            <div class="pull-right icons-box">
              <div class="intervalDiv">
                <label class="intervalLabel">Refresh Interval</label>
                <select name="intervals" id="selectIntervals" class="form-control selectIntervals">
                  <option value="OFF">OFF</option>
                  <option value="5000">5s</option>
                  <option value="15000" selected>15s</option>
                  <option value="30000">30s</option>
                  <option value="60000">60s</option>
                  <option value="300000">5m</option>
                </select>
              </div>
					<a href="/nodelist/" title="Nodelist" id="nodelist">
					<span id="node_list_icon" class="icon-gridactive"></span></a>
					<div class="smallicon-vertical job-timeline"></div>
					<a href="/resourcejobtimeline/" title="Resource Job Timeline" id="timeline">
						<span id="job_timeline_icon" class="icon-timelinedisabled" ></span>	
					</a>
			</div>

            <div class="clearfix"></div>
            <div>
            <input type="text" id="hiddenstatusCode" style='display:none' value=${ jobStatus  }></input>
            <%include file="node_table.html"/>
            </div>
        </div>
        <!--This is Filter section-->
        <div class="col-xs-4 search-filter-section padLeft">
            <h5><b>${_("Current Search")}: </b><strong><label id='totalResourcesCnt' class="srchCount"></label></strong></h5>
            <div id="searchValues" class="searchPage">
                
            </div>
            <span>
                <!-- <input type="checkbox"> -->
                <select id="searchCat" class="form-control" onChange="$('#searchBox').focus()">
                    <option id="opt0" value="">- ${_("Select")} -</option>
                    <option id="opt1" value="NodeID">Node ID</option>
                    <option id="opt2" value="Class">Class</option>
                    <option id="opt3" value="Features">Features</option>
                </select>
            </span>

            <div class="input-group search-group">
              <input id="searchBox" type="text" class="form-control search"
                onclick="clearValue(this)"
                placeholder="${_("Narrow Search")}"/>
              <div class="input-group-btn">
                <button id="searchBtn" type="button" class="btn btn-primary normprimary search-btn">
                  <span class="glyphicon glyphicon-search search-btn">
                  </span>
                </button>
              </div>
            </div>

            <h5 class="filter">${_("Filters")}</h5>
            <span>
                <!-- <input type="checkbox"> -->
                    <select id="resourceState" class="form-control">
                        <option id="opt0" value="">${_("Select Status")}</option>
                        %if resource_filter:
                            % for i in resource_filter:
                                <option value="${ i  }">${ i  }</option>
                            % endfor
                        %endif
                </select>
            </span>
            
            <div class="col-xs-12">
        <div class="col-xs-6 padLR">
            <div class="form-group">
                <label class="labelfilter">${_("Processors")}</label>
                    <input type="text" name="From" id="procsFrom" value="0" class="form-control number-input number-from"  onkeypress="checkObjection(this,event)">
                <div class="buttonbig"><div class="incbutton" onmousedown="mousedownfunc('procsFrom', increment)" onmouseup="mouseupfunc()"></div><div class="decbutton" onmousedown="mousedownfunc('procsFrom', decrement, 'procsFrom')" onmouseup="mouseupfunc()"></div></div>
            </div>
        </div>
        <div class="col-xs-6 padLR">
            <div class="form-group">
                <label class="labelfilter1">${_("To")}</label>
                    <input type="text" name="From" id="procsTo" value="0" class="form-control number-input to-number-inf"  onkeypress="checkObjection(this,event)">
                    <div class="buttonbig"><div class="incbutton" onmousedown="mousedownfunc('procsTo', increment)" onmouseup="mouseupfunc()"></div><div class="decbutton" onmousedown="mousedownfunc('procsTo', decrement)" onmouseup="mouseupfunc()"></div></div>
                </div>
            </div>
        </div>
        <div class="clearfix"></div>
    <div class="col-xs-12">
        <div class="col-xs-6 padLR">
            <div class="form-group">
                <label for="From" class="labelfilter">${_("Jobs")}</label>
                    <input type="text" name="From" id="jobsFrom" value="0" class="form-control number-input number-from"  onkeypress="checkObjection(this,event)">
                    <div class="buttonbig"><div class="incbutton" onmousedown="mousedownfunc('jobsFrom', increment)" onmouseup="mouseupfunc()"></div><div class="decbutton" onmousedown="mousedownfunc('jobsFrom', decrement, 'jobsFrom')" onmouseup="mouseupfunc()"></div></div>
            </div>
        </div>
        <div class="col-xs-6 padLR">
            <div class="form-group">
                <label class="labelfilter1">${_("To")}</label>
                <input type="text" name="From" id="jobsTo" value="0" class="form-control number-input to-number-inf"  onkeypress="checkObjection(this,event)">
                <div class="buttonbig"><div class="incbutton" onmousedown="mousedownfunc('jobsTo', increment)" onmouseup="mouseupfunc()"></div><div class="decbutton" onmousedown="mousedownfunc('jobsTo', decrement)" onmouseup="mouseupfunc()"></div></div>
            </div>
        </div>
    </div>
    <div class="clearfix"></div>
    <div class="col-xs-12">
        <div class="col-xs-6 padLR">
            <div class="form-group">
                <label class="labelfilter">${_("CPU Utilization")}</label>
                <input type="text" name="From" id="proc_utilFrom" value="0" class="form-control number-input number-from" onkeyup="checkMax('proc_utilFrom',0,100)" onkeypress="checkObjection(this,event)">
                <div class="buttonbig"><div class="incbutton" onmousedown="mousedownfunc('proc_utilFrom', incrementMax)" onmouseup="mouseupfunc()"></div><div class="decbutton" onmousedown="mousedownfunc('proc_utilFrom', decrement, 'proc_utilFrom')" onmouseup="mouseupfunc()"></div></div>
            </div>
        </div>
        <div class="col-xs-6 padLR">
            <div class="form-group">
                <label class="labelfilter1">${_("To")}</label>
                <input type="text" name="From" id="proc_utilTo" value="0" class="form-control number-input to-number-inf" onkeyup="checkMax('proc_utilTo',0,100)" onkeypress="checkObjection(this,event)">
				<div class="buttonbig"><div class="incbutton" onmousedown="mousedownfunc('proc_utilTo', incrementMax)" onmouseup="mouseupfunc()"></div><div class="decbutton" onmousedown="mousedownfunc('proc_utilTo', decrement)" onmouseup="mouseupfunc()"></div></div>
            </div>
        </div>

        <div class="col-xs-12">
            <div class="col-xs-6 padLR">
                <div class="form-group">
                    <label class="labelfilter">${_("Memory Utilization")}</label>
                    <input type="text" name="From" id="memory_utilFrom" value="0" class="form-control number-input number-from"  onkeyup="checkMaxMemory('memory_utilFrom',0,100)" onkeypress="checkObjection(this,event)">
                    <div class="buttonbig"><div class="incbutton" onmousedown="mousedownfunc('memory_utilFrom', incrementMaxM)" onmouseup="mouseupfunc()"></div><div class="decbutton" onmousedown="mousedownfunc('memory_utilFrom', decrement, 'memory_utilFrom')" onmouseup="mouseupfunc()"></div></div>
                </div>
            </div>
            <div class="col-xs-6 padLR">
                <div class="form-group">
                    <label class="labelfilter1">${_("To")}</label>
                        <input type="text" name="From" id="memory_utilTo" value="0" class="form-control number-input to-number-inf" onkeyup="checkMaxMemory('memory_utilTo',0,100)" onkeypress="checkObjection(this,event)">
					<div class="buttonbig"><div class="incbutton" onmousedown="mousedownfunc('memory_utilTo', incrementMaxM)" onmouseup="mouseupfunc()"></div><div class="decbutton" onmousedown="mousedownfunc('memory_utilTo', decrement)" onmouseup="mouseupfunc()"></div></div>
                </div>
            </div>
        </div>
        <div class="clearfix"></div>
    </div>
            <div class="right-pane-buttons-container" style="margin-right: 28px;">
                <button type="button" class="btn btn-primary"
                    id="nodelist_clearAllBtn">${_("Reset")}</button>
                <button type="button" class="btn btn-primary right"
                    id="nodeList_filterBtn">${_("Filter")}</button>
            </div>

    </div>
    </div>
<!--Filter section ends-->
</%def>
<%def name="end_script()">
</%def>
